(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("antd"), require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["antd", "react"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("antd"), require("react")) : factory(root["antd"], root["react"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, function(__WEBPACK_EXTERNAL_MODULE_antd__, __WEBPACK_EXTERNAL_MODULE_react__) {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "../../node_modules/@ant-design/colors/lib/generate.js":
/*!*************************************************************!*\
  !*** ../../node_modules/@ant-design/colors/lib/generate.js ***!
  \*************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: top-level-this-exports, __webpack_exports__, __webpack_require__ */
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
var tinycolor2_1 = __importDefault(__webpack_require__(/*! tinycolor2 */ "../../node_modules/tinycolor2/tinycolor.js"));
var hueStep = 2; // 色相阶梯
var saturationStep = 16; // 饱和度阶梯，浅色部分
var saturationStep2 = 5; // 饱和度阶梯，深色部分
var brightnessStep1 = 5; // 亮度阶梯，浅色部分
var brightnessStep2 = 15; // 亮度阶梯，深色部分
var lightColorCount = 5; // 浅色数量，主色上
var darkColorCount = 4; // 深色数量，主色下
function getHue(hsv, i, light) {
    var hue;
    // 根据色相不同，色相转向不同
    if (Math.round(hsv.h) >= 60 && Math.round(hsv.h) <= 240) {
        hue = light ? Math.round(hsv.h) - hueStep * i : Math.round(hsv.h) + hueStep * i;
    }
    else {
        hue = light ? Math.round(hsv.h) + hueStep * i : Math.round(hsv.h) - hueStep * i;
    }
    if (hue < 0) {
        hue += 360;
    }
    else if (hue >= 360) {
        hue -= 360;
    }
    return hue;
}
function getSaturation(hsv, i, light) {
    // grey color don't change saturation
    if (hsv.h === 0 && hsv.s === 0) {
        return hsv.s;
    }
    var saturation;
    if (light) {
        saturation = Math.round(hsv.s * 100) - saturationStep * i;
    }
    else if (i === darkColorCount) {
        saturation = Math.round(hsv.s * 100) + saturationStep;
    }
    else {
        saturation = Math.round(hsv.s * 100) + saturationStep2 * i;
    }
    // 边界值修正
    if (saturation > 100) {
        saturation = 100;
    }
    // 第一格的 s 限制在 6-10 之间
    if (light && i === lightColorCount && saturation > 10) {
        saturation = 10;
    }
    if (saturation < 6) {
        saturation = 6;
    }
    return saturation;
}
function getValue(hsv, i, light) {
    if (light) {
        return Math.round(hsv.v * 100) + brightnessStep1 * i;
    }
    return Math.round(hsv.v * 100) - brightnessStep2 * i;
}
function generate(color) {
    var patterns = [];
    var pColor = tinycolor2_1.default(color);
    for (var i = lightColorCount; i > 0; i -= 1) {
        var hsv = pColor.toHsv();
        var colorString = tinycolor2_1.default({
            h: getHue(hsv, i, true),
            s: getSaturation(hsv, i, true),
            v: getValue(hsv, i, true),
        }).toHexString();
        patterns.push(colorString);
    }
    patterns.push(pColor.toHexString());
    for (var i = 1; i <= darkColorCount; i += 1) {
        var hsv = pColor.toHsv();
        var colorString = tinycolor2_1.default({
            h: getHue(hsv, i),
            s: getSaturation(hsv, i),
            v: getValue(hsv, i),
        }).toHexString();
        patterns.push(colorString);
    }
    return patterns;
}
exports.default = generate;


/***/ }),

/***/ "../../node_modules/@ant-design/colors/lib/index.js":
/*!**********************************************************!*\
  !*** ../../node_modules/@ant-design/colors/lib/index.js ***!
  \**********************************************************/
/*! unknown exports (runtime-defined) */
/*! export generate [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! other exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: top-level-this-exports, __webpack_exports__, __webpack_require__ */
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
var generate_1 = __importDefault(__webpack_require__(/*! ./generate */ "../../node_modules/@ant-design/colors/lib/generate.js"));
exports.generate = generate_1.default;
var presetPrimaryColors = {
    red: '#F5222D',
    volcano: '#FA541C',
    orange: '#FA8C16',
    gold: '#FAAD14',
    yellow: '#FADB14',
    lime: '#A0D911',
    green: '#52C41A',
    cyan: '#13C2C2',
    blue: '#1890FF',
    geekblue: '#2F54EB',
    purple: '#722ED1',
    magenta: '#EB2F96',
    grey: '#666666',
};
exports.presetPrimaryColors = presetPrimaryColors;
var presetPalettes = {};
exports.presetPalettes = presetPalettes;
Object.keys(presetPrimaryColors).forEach(function (key) {
    presetPalettes[key] = generate_1.default(presetPrimaryColors[key]);
    presetPalettes[key].primary = presetPalettes[key][5];
});
var red = presetPalettes.red;
exports.red = red;
var volcano = presetPalettes.volcano;
exports.volcano = volcano;
var gold = presetPalettes.gold;
exports.gold = gold;
var orange = presetPalettes.orange;
exports.orange = orange;
var yellow = presetPalettes.yellow;
exports.yellow = yellow;
var lime = presetPalettes.lime;
exports.lime = lime;
var green = presetPalettes.green;
exports.green = green;
var cyan = presetPalettes.cyan;
exports.cyan = cyan;
var blue = presetPalettes.blue;
exports.blue = blue;
var geekblue = presetPalettes.geekblue;
exports.geekblue = geekblue;
var purple = presetPalettes.purple;
exports.purple = purple;
var magenta = presetPalettes.magenta;
exports.magenta = magenta;
var grey = presetPalettes.grey;
exports.grey = grey;


/***/ }),

/***/ "../../node_modules/@ant-design/icons-svg/es/asn/DownOutlined.js":
/*!***********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons-svg/es/asn/DownOutlined.js ***!
  \***********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// This icon file is generated automatically.
var DownOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M884 256h-75c-5.1 0-9.9 2.5-12.9 6.6L512 654.2 227.9 262.6c-3-4.1-7.8-6.6-12.9-6.6h-75c-6.5 0-10.3 7.4-6.5 12.7l352.6 486.1c12.8 17.6 39 17.6 51.7 0l352.6-486.1c3.9-5.3.1-12.7-6.4-12.7z" } }] }, "name": "down", "theme": "outlined" };
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (DownOutlined);


/***/ }),

/***/ "../../node_modules/@ant-design/icons-svg/es/asn/ExportOutlined.js":
/*!*************************************************************************!*\
  !*** ../../node_modules/@ant-design/icons-svg/es/asn/ExportOutlined.js ***!
  \*************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// This icon file is generated automatically.
var ExportOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M888.3 757.4h-53.8c-4.2 0-7.7 3.5-7.7 7.7v61.8H197.1V197.1h629.8v61.8c0 4.2 3.5 7.7 7.7 7.7h53.8c4.2 0 7.7-3.4 7.7-7.7V158.7c0-17-13.7-30.7-30.7-30.7H158.7c-17 0-30.7 13.7-30.7 30.7v706.6c0 17 13.7 30.7 30.7 30.7h706.6c17 0 30.7-13.7 30.7-30.7V765.1c0-4.3-3.5-7.7-7.7-7.7zm18.6-251.7L765 393.7c-5.3-4.2-13-.4-13 6.3v76H438c-4.4 0-8 3.6-8 8v56c0 4.4 3.6 8 8 8h314v76c0 6.7 7.8 10.5 13 6.3l141.9-112a8 8 0 000-12.6z" } }] }, "name": "export", "theme": "outlined" };
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (ExportOutlined);


/***/ }),

/***/ "../../node_modules/@ant-design/icons-svg/es/asn/EyeOutlined.js":
/*!**********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons-svg/es/asn/EyeOutlined.js ***!
  \**********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// This icon file is generated automatically.
var EyeOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M942.2 486.2C847.4 286.5 704.1 186 512 186c-192.2 0-335.4 100.5-430.2 300.3a60.3 60.3 0 000 51.5C176.6 737.5 319.9 838 512 838c192.2 0 335.4-100.5 430.2-300.3 7.7-16.2 7.7-35 0-51.5zM512 766c-161.3 0-279.4-81.8-362.7-254C232.6 339.8 350.7 258 512 258c161.3 0 279.4 81.8 362.7 254C791.5 684.2 673.4 766 512 766zm-4-430c-97.2 0-176 78.8-176 176s78.8 176 176 176 176-78.8 176-176-78.8-176-176-176zm0 288c-61.9 0-112-50.1-112-112s50.1-112 112-112 112 50.1 112 112-50.1 112-112 112z" } }] }, "name": "eye", "theme": "outlined" };
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (EyeOutlined);


/***/ }),

/***/ "../../node_modules/@ant-design/icons-svg/es/asn/LoadingOutlined.js":
/*!**************************************************************************!*\
  !*** ../../node_modules/@ant-design/icons-svg/es/asn/LoadingOutlined.js ***!
  \**************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// This icon file is generated automatically.
var LoadingOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "0 0 1024 1024", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M988 548c-19.9 0-36-16.1-36-36 0-59.4-11.6-117-34.6-171.3a440.45 440.45 0 00-94.3-139.9 437.71 437.71 0 00-139.9-94.3C629 83.6 571.4 72 512 72c-19.9 0-36-16.1-36-36s16.1-36 36-36c69.1 0 136.2 13.5 199.3 40.3C772.3 66 827 103 874 150c47 47 83.9 101.8 109.7 162.7 26.7 63.1 40.2 130.2 40.2 199.3.1 19.9-16 36-35.9 36z" } }] }, "name": "loading", "theme": "outlined" };
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (LoadingOutlined);


/***/ }),

/***/ "../../node_modules/@ant-design/icons-svg/es/asn/PlusOutlined.js":
/*!***********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons-svg/es/asn/PlusOutlined.js ***!
  \***********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// This icon file is generated automatically.
var PlusOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "defs", "attrs": {}, "children": [{ "tag": "style", "attrs": {} }] }, { "tag": "path", "attrs": { "d": "M482 152h60q8 0 8 8v704q0 8-8 8h-60q-8 0-8-8V160q0-8 8-8z" } }, { "tag": "path", "attrs": { "d": "M176 474h672q8 0 8 8v60q0 8-8 8H176q-8 0-8-8v-60q0-8 8-8z" } }] }, "name": "plus", "theme": "outlined" };
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (PlusOutlined);


/***/ }),

/***/ "../../node_modules/@ant-design/icons-svg/es/asn/QuestionCircleOutlined.js":
/*!*********************************************************************************!*\
  !*** ../../node_modules/@ant-design/icons-svg/es/asn/QuestionCircleOutlined.js ***!
  \*********************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// This icon file is generated automatically.
var QuestionCircleOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M512 64C264.6 64 64 264.6 64 512s200.6 448 448 448 448-200.6 448-448S759.4 64 512 64zm0 820c-205.4 0-372-166.6-372-372s166.6-372 372-372 372 166.6 372 372-166.6 372-372 372z" } }, { "tag": "path", "attrs": { "d": "M623.6 316.7C593.6 290.4 554 276 512 276s-81.6 14.5-111.6 40.7C369.2 344 352 380.7 352 420v7.6c0 4.4 3.6 8 8 8h48c4.4 0 8-3.6 8-8V420c0-44.1 43.1-80 96-80s96 35.9 96 80c0 31.1-22 59.6-56.1 72.7-21.2 8.1-39.2 22.3-52.1 40.9-13.1 19-19.9 41.8-19.9 64.9V620c0 4.4 3.6 8 8 8h48c4.4 0 8-3.6 8-8v-22.7a48.3 48.3 0 0130.9-44.8c59-22.7 97.1-74.7 97.1-132.5.1-39.3-17.1-76-48.3-103.3zM472 732a40 40 0 1080 0 40 40 0 10-80 0z" } }] }, "name": "question-circle", "theme": "outlined" };
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (QuestionCircleOutlined);


/***/ }),

/***/ "../../node_modules/@ant-design/icons-svg/es/asn/ReloadOutlined.js":
/*!*************************************************************************!*\
  !*** ../../node_modules/@ant-design/icons-svg/es/asn/ReloadOutlined.js ***!
  \*************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// This icon file is generated automatically.
var ReloadOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M909.1 209.3l-56.4 44.1C775.8 155.1 656.2 92 521.9 92 290 92 102.3 279.5 102 511.5 101.7 743.7 289.8 932 521.9 932c181.3 0 335.8-115 394.6-276.1 1.5-4.2-.7-8.9-4.9-10.3l-56.7-19.5a8 8 0 00-10.1 4.8c-1.8 5-3.8 10-5.9 14.9-17.3 41-42.1 77.8-73.7 109.4A344.77 344.77 0 01655.9 829c-42.3 17.9-87.4 27-133.8 27-46.5 0-91.5-9.1-133.8-27A341.5 341.5 0 01279 755.2a342.16 342.16 0 01-73.7-109.4c-17.9-42.4-27-87.4-27-133.9s9.1-91.5 27-133.9c17.3-41 42.1-77.8 73.7-109.4 31.6-31.6 68.4-56.4 109.3-73.8 42.3-17.9 87.4-27 133.8-27 46.5 0 91.5 9.1 133.8 27a341.5 341.5 0 01109.3 73.8c9.9 9.9 19.2 20.4 27.8 31.4l-60.2 47a8 8 0 003 14.1l175.6 43c5 1.2 9.9-2.6 9.9-7.7l.8-180.9c-.1-6.6-7.8-10.3-13-6.2z" } }] }, "name": "reload", "theme": "outlined" };
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (ReloadOutlined);


/***/ }),

/***/ "../../node_modules/@ant-design/icons-svg/es/asn/SearchOutlined.js":
/*!*************************************************************************!*\
  !*** ../../node_modules/@ant-design/icons-svg/es/asn/SearchOutlined.js ***!
  \*************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// This icon file is generated automatically.
var SearchOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M909.6 854.5L649.9 594.8C690.2 542.7 712 479 712 412c0-80.2-31.3-155.4-87.9-212.1-56.6-56.7-132-87.9-212.1-87.9s-155.5 31.3-212.1 87.9C143.2 256.5 112 331.8 112 412c0 80.1 31.3 155.5 87.9 212.1C256.5 680.8 331.8 712 412 712c67 0 130.6-21.8 182.7-62l259.7 259.6a8.2 8.2 0 0011.6 0l43.6-43.5a8.2 8.2 0 000-11.6zM570.4 570.4C528 612.7 471.8 636 412 636s-116-23.3-158.4-65.6C211.3 528 188 471.8 188 412s23.3-116.1 65.6-158.4C296 211.3 352.2 188 412 188s116.1 23.2 158.4 65.6S636 352.2 636 412s-23.3 116.1-65.6 158.4z" } }] }, "name": "search", "theme": "outlined" };
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (SearchOutlined);


/***/ }),

/***/ "../../node_modules/@ant-design/icons-svg/es/asn/UpOutlined.js":
/*!*********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons-svg/es/asn/UpOutlined.js ***!
  \*********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// This icon file is generated automatically.
var UpOutlined = { "icon": { "tag": "svg", "attrs": { "viewBox": "64 64 896 896", "focusable": "false" }, "children": [{ "tag": "path", "attrs": { "d": "M890.5 755.3L537.9 269.2c-12.8-17.6-39-17.6-51.7 0L133.5 755.3A8 8 0 00140 768h75c5.1 0 9.9-2.5 12.9-6.6L512 369.8l284.1 391.6c3 4.1 7.8 6.6 12.9 6.6h75c6.5 0 10.3-7.4 6.5-12.7z" } }] }, "name": "up", "theme": "outlined" };
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (UpOutlined);


/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/components/AntdIcon.js":
/*!**********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/components/AntdIcon.js ***!
  \**********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var _babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/esm/slicedToArray */ "../../node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var _babel_runtime_helpers_esm_defineProperty__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @babel/runtime/helpers/esm/defineProperty */ "../../node_modules/@babel/runtime/helpers/esm/defineProperty.js");
/* harmony import */ var _babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @babel/runtime/helpers/esm/objectWithoutProperties */ "../../node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! classnames */ "../../node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _IconBase__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./IconBase */ "../../node_modules/@ant-design/icons/es/components/IconBase.js");
/* harmony import */ var _twoTonePrimaryColor__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./twoTonePrimaryColor */ "../../node_modules/@ant-design/icons/es/components/twoTonePrimaryColor.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../utils */ "../../node_modules/@ant-design/icons/es/utils.js");







 // Initial setting
// should move it to antd main repo?

(0,_twoTonePrimaryColor__WEBPACK_IMPORTED_MODULE_5__.setTwoToneColor)('#1890ff');
var Icon = react__WEBPACK_IMPORTED_MODULE_3__.forwardRef(function (props, ref) {
  var className = props.className,
      icon = props.icon,
      spin = props.spin,
      rotate = props.rotate,
      tabIndex = props.tabIndex,
      onClick = props.onClick,
      twoToneColor = props.twoToneColor,
      restProps = (0,_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_2__.default)(props, ["className", "icon", "spin", "rotate", "tabIndex", "onClick", "twoToneColor"]);

  var classString = classnames__WEBPACK_IMPORTED_MODULE_4___default()('anticon', (0,_babel_runtime_helpers_esm_defineProperty__WEBPACK_IMPORTED_MODULE_1__.default)({}, "anticon-".concat(icon.name), Boolean(icon.name)), className);
  var svgClassString = classnames__WEBPACK_IMPORTED_MODULE_4___default()({
    'anticon-spin': !!spin || icon.name === 'loading'
  });
  var iconTabIndex = tabIndex;

  if (iconTabIndex === undefined && onClick) {
    iconTabIndex = -1;
  }

  var svgStyle = rotate ? {
    msTransform: "rotate(".concat(rotate, "deg)"),
    transform: "rotate(".concat(rotate, "deg)")
  } : undefined;

  var _normalizeTwoToneColo = (0,_utils__WEBPACK_IMPORTED_MODULE_6__.normalizeTwoToneColors)(twoToneColor),
      _normalizeTwoToneColo2 = (0,_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__.default)(_normalizeTwoToneColo, 2),
      primaryColor = _normalizeTwoToneColo2[0],
      secondaryColor = _normalizeTwoToneColo2[1];

  return react__WEBPACK_IMPORTED_MODULE_3__.createElement("span", Object.assign({
    role: "img",
    "aria-label": icon.name
  }, restProps, {
    ref: ref,
    tabIndex: iconTabIndex,
    onClick: onClick,
    className: classString
  }), react__WEBPACK_IMPORTED_MODULE_3__.createElement(_IconBase__WEBPACK_IMPORTED_MODULE_7__.default, {
    className: svgClassString,
    icon: icon,
    primaryColor: primaryColor,
    secondaryColor: secondaryColor,
    style: svgStyle
  }));
});
Icon.displayName = 'AntdIcon';
Icon.getTwoToneColor = _twoTonePrimaryColor__WEBPACK_IMPORTED_MODULE_5__.getTwoToneColor;
Icon.setTwoToneColor = _twoTonePrimaryColor__WEBPACK_IMPORTED_MODULE_5__.setTwoToneColor;
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Icon);

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/components/Icon.js":
/*!******************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/components/Icon.js ***!
  \******************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var _babel_runtime_helpers_esm_defineProperty__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/esm/defineProperty */ "../../node_modules/@babel/runtime/helpers/esm/defineProperty.js");
/* harmony import */ var _babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @babel/runtime/helpers/esm/objectWithoutProperties */ "../../node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! classnames */ "../../node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../utils */ "../../node_modules/@ant-design/icons/es/utils.js");



function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0,_babel_runtime_helpers_esm_defineProperty__WEBPACK_IMPORTED_MODULE_0__.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }




var Icon = react__WEBPACK_IMPORTED_MODULE_2__.forwardRef(function (props, ref) {
  var className = props.className,
      Component = props.component,
      viewBox = props.viewBox,
      spin = props.spin,
      rotate = props.rotate,
      tabIndex = props.tabIndex,
      onClick = props.onClick,
      children = props.children,
      restProps = (0,_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_1__.default)(props, ["className", "component", "viewBox", "spin", "rotate", "tabIndex", "onClick", "children"]);

  (0,_utils__WEBPACK_IMPORTED_MODULE_4__.warning)(Boolean(Component || children), 'Should have `component` prop or `children`.');
  (0,_utils__WEBPACK_IMPORTED_MODULE_4__.useInsertStyles)();
  var classString = classnames__WEBPACK_IMPORTED_MODULE_3___default()('anticon', className);
  var svgClassString = classnames__WEBPACK_IMPORTED_MODULE_3___default()({
    'anticon-spin': !!spin
  });
  var svgStyle = rotate ? {
    msTransform: "rotate(".concat(rotate, "deg)"),
    transform: "rotate(".concat(rotate, "deg)")
  } : undefined;

  var innerSvgProps = _objectSpread(_objectSpread({}, _utils__WEBPACK_IMPORTED_MODULE_4__.svgBaseProps), {}, {
    className: svgClassString,
    style: svgStyle,
    viewBox: viewBox
  });

  if (!viewBox) {
    delete innerSvgProps.viewBox;
  } // component > children


  var renderInnerNode = function renderInnerNode() {
    if (Component) {
      return react__WEBPACK_IMPORTED_MODULE_2__.createElement(Component, Object.assign({}, innerSvgProps), children);
    }

    if (children) {
      (0,_utils__WEBPACK_IMPORTED_MODULE_4__.warning)(Boolean(viewBox) || react__WEBPACK_IMPORTED_MODULE_2__.Children.count(children) === 1 && react__WEBPACK_IMPORTED_MODULE_2__.isValidElement(children) && react__WEBPACK_IMPORTED_MODULE_2__.Children.only(children).type === 'use', 'Make sure that you provide correct `viewBox`' + ' prop (default `0 0 1024 1024`) to the icon.');
      return react__WEBPACK_IMPORTED_MODULE_2__.createElement("svg", Object.assign({}, innerSvgProps, {
        viewBox: viewBox
      }), children);
    }

    return null;
  };

  var iconTabIndex = tabIndex;

  if (iconTabIndex === undefined && onClick) {
    iconTabIndex = -1;
  }

  return react__WEBPACK_IMPORTED_MODULE_2__.createElement("span", Object.assign({
    role: "img"
  }, restProps, {
    ref: ref,
    tabIndex: iconTabIndex,
    onClick: onClick,
    className: classString
  }), renderInnerNode());
});
Icon.displayName = 'AntdIcon';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Icon);

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/components/IconBase.js":
/*!**********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/components/IconBase.js ***!
  \**********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var _babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/esm/objectWithoutProperties */ "../../node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js");
/* harmony import */ var _babel_runtime_helpers_esm_defineProperty__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @babel/runtime/helpers/esm/defineProperty */ "../../node_modules/@babel/runtime/helpers/esm/defineProperty.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../utils */ "../../node_modules/@ant-design/icons/es/utils.js");



function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0,_babel_runtime_helpers_esm_defineProperty__WEBPACK_IMPORTED_MODULE_1__.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }


var twoToneColorPalette = {
  primaryColor: '#333',
  secondaryColor: '#E6E6E6',
  calculated: false
};

function setTwoToneColors(_ref) {
  var primaryColor = _ref.primaryColor,
      secondaryColor = _ref.secondaryColor;
  twoToneColorPalette.primaryColor = primaryColor;
  twoToneColorPalette.secondaryColor = secondaryColor || (0,_utils__WEBPACK_IMPORTED_MODULE_2__.getSecondaryColor)(primaryColor);
  twoToneColorPalette.calculated = !!secondaryColor;
}

function getTwoToneColors() {
  return _objectSpread({}, twoToneColorPalette);
}

var IconBase = function IconBase(props) {
  var icon = props.icon,
      className = props.className,
      onClick = props.onClick,
      style = props.style,
      primaryColor = props.primaryColor,
      secondaryColor = props.secondaryColor,
      restProps = (0,_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_0__.default)(props, ["icon", "className", "onClick", "style", "primaryColor", "secondaryColor"]);

  var colors = twoToneColorPalette;

  if (primaryColor) {
    colors = {
      primaryColor: primaryColor,
      secondaryColor: secondaryColor || (0,_utils__WEBPACK_IMPORTED_MODULE_2__.getSecondaryColor)(primaryColor)
    };
  }

  (0,_utils__WEBPACK_IMPORTED_MODULE_2__.useInsertStyles)();
  (0,_utils__WEBPACK_IMPORTED_MODULE_2__.warning)((0,_utils__WEBPACK_IMPORTED_MODULE_2__.isIconDefinition)(icon), "icon should be icon definiton, but got ".concat(icon));

  if (!(0,_utils__WEBPACK_IMPORTED_MODULE_2__.isIconDefinition)(icon)) {
    return null;
  }

  var target = icon;

  if (target && typeof target.icon === 'function') {
    target = _objectSpread(_objectSpread({}, target), {}, {
      icon: target.icon(colors.primaryColor, colors.secondaryColor)
    });
  }

  return (0,_utils__WEBPACK_IMPORTED_MODULE_2__.generate)(target.icon, "svg-".concat(target.name), _objectSpread({
    className: className,
    onClick: onClick,
    style: style,
    'data-icon': target.name,
    width: '1em',
    height: '1em',
    fill: 'currentColor',
    'aria-hidden': 'true'
  }, restProps));
};

IconBase.displayName = 'IconReact';
IconBase.getTwoToneColors = getTwoToneColors;
IconBase.setTwoToneColors = setTwoToneColors;
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (IconBase);

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/components/twoTonePrimaryColor.js":
/*!*********************************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/components/twoTonePrimaryColor.js ***!
  \*********************************************************************************/
/*! namespace exports */
/*! export getTwoToneColor [provided] [used] [could be renamed] */
/*! export setTwoToneColor [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "setTwoToneColor": () => /* binding */ setTwoToneColor,
/* harmony export */   "getTwoToneColor": () => /* binding */ getTwoToneColor
/* harmony export */ });
/* harmony import */ var _babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/esm/slicedToArray */ "../../node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var _IconBase__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./IconBase */ "../../node_modules/@ant-design/icons/es/components/IconBase.js");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../utils */ "../../node_modules/@ant-design/icons/es/utils.js");



function setTwoToneColor(twoToneColor) {
  var _normalizeTwoToneColo = (0,_utils__WEBPACK_IMPORTED_MODULE_1__.normalizeTwoToneColors)(twoToneColor),
      _normalizeTwoToneColo2 = (0,_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__.default)(_normalizeTwoToneColo, 2),
      primaryColor = _normalizeTwoToneColo2[0],
      secondaryColor = _normalizeTwoToneColo2[1];

  return _IconBase__WEBPACK_IMPORTED_MODULE_2__.default.setTwoToneColors({
    primaryColor: primaryColor,
    secondaryColor: secondaryColor
  });
}
function getTwoToneColor() {
  var colors = _IconBase__WEBPACK_IMPORTED_MODULE_2__.default.getTwoToneColors();

  if (!colors.calculated) {
    return colors.primaryColor;
  }

  return [colors.primaryColor, colors.secondaryColor];
}

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/icons/DownOutlined.js":
/*!*********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/icons/DownOutlined.js ***!
  \*********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ant_design_icons_svg_es_asn_DownOutlined__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons-svg/es/asn/DownOutlined */ "../../node_modules/@ant-design/icons-svg/es/asn/DownOutlined.js");
/* harmony import */ var _components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/AntdIcon */ "../../node_modules/@ant-design/icons/es/components/AntdIcon.js");
// GENERATE BY ./scripts/generate.ts
// DON NOT EDIT IT MANUALLY




var DownOutlined = function DownOutlined(props, ref) {
  return react__WEBPACK_IMPORTED_MODULE_0__.createElement(_components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__.default, Object.assign({}, props, {
    ref: ref,
    icon: _ant_design_icons_svg_es_asn_DownOutlined__WEBPACK_IMPORTED_MODULE_2__.default
  }));
};

DownOutlined.displayName = 'DownOutlined';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (react__WEBPACK_IMPORTED_MODULE_0__.forwardRef(DownOutlined));

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/icons/ExportOutlined.js":
/*!***********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/icons/ExportOutlined.js ***!
  \***********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ant_design_icons_svg_es_asn_ExportOutlined__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons-svg/es/asn/ExportOutlined */ "../../node_modules/@ant-design/icons-svg/es/asn/ExportOutlined.js");
/* harmony import */ var _components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/AntdIcon */ "../../node_modules/@ant-design/icons/es/components/AntdIcon.js");
// GENERATE BY ./scripts/generate.ts
// DON NOT EDIT IT MANUALLY




var ExportOutlined = function ExportOutlined(props, ref) {
  return react__WEBPACK_IMPORTED_MODULE_0__.createElement(_components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__.default, Object.assign({}, props, {
    ref: ref,
    icon: _ant_design_icons_svg_es_asn_ExportOutlined__WEBPACK_IMPORTED_MODULE_2__.default
  }));
};

ExportOutlined.displayName = 'ExportOutlined';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (react__WEBPACK_IMPORTED_MODULE_0__.forwardRef(ExportOutlined));

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/icons/EyeOutlined.js":
/*!********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/icons/EyeOutlined.js ***!
  \********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ant_design_icons_svg_es_asn_EyeOutlined__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons-svg/es/asn/EyeOutlined */ "../../node_modules/@ant-design/icons-svg/es/asn/EyeOutlined.js");
/* harmony import */ var _components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/AntdIcon */ "../../node_modules/@ant-design/icons/es/components/AntdIcon.js");
// GENERATE BY ./scripts/generate.ts
// DON NOT EDIT IT MANUALLY




var EyeOutlined = function EyeOutlined(props, ref) {
  return react__WEBPACK_IMPORTED_MODULE_0__.createElement(_components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__.default, Object.assign({}, props, {
    ref: ref,
    icon: _ant_design_icons_svg_es_asn_EyeOutlined__WEBPACK_IMPORTED_MODULE_2__.default
  }));
};

EyeOutlined.displayName = 'EyeOutlined';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (react__WEBPACK_IMPORTED_MODULE_0__.forwardRef(EyeOutlined));

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/icons/LoadingOutlined.js":
/*!************************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/icons/LoadingOutlined.js ***!
  \************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ant_design_icons_svg_es_asn_LoadingOutlined__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons-svg/es/asn/LoadingOutlined */ "../../node_modules/@ant-design/icons-svg/es/asn/LoadingOutlined.js");
/* harmony import */ var _components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/AntdIcon */ "../../node_modules/@ant-design/icons/es/components/AntdIcon.js");
// GENERATE BY ./scripts/generate.ts
// DON NOT EDIT IT MANUALLY




var LoadingOutlined = function LoadingOutlined(props, ref) {
  return react__WEBPACK_IMPORTED_MODULE_0__.createElement(_components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__.default, Object.assign({}, props, {
    ref: ref,
    icon: _ant_design_icons_svg_es_asn_LoadingOutlined__WEBPACK_IMPORTED_MODULE_2__.default
  }));
};

LoadingOutlined.displayName = 'LoadingOutlined';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (react__WEBPACK_IMPORTED_MODULE_0__.forwardRef(LoadingOutlined));

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/icons/PlusOutlined.js":
/*!*********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/icons/PlusOutlined.js ***!
  \*********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ant_design_icons_svg_es_asn_PlusOutlined__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons-svg/es/asn/PlusOutlined */ "../../node_modules/@ant-design/icons-svg/es/asn/PlusOutlined.js");
/* harmony import */ var _components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/AntdIcon */ "../../node_modules/@ant-design/icons/es/components/AntdIcon.js");
// GENERATE BY ./scripts/generate.ts
// DON NOT EDIT IT MANUALLY




var PlusOutlined = function PlusOutlined(props, ref) {
  return react__WEBPACK_IMPORTED_MODULE_0__.createElement(_components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__.default, Object.assign({}, props, {
    ref: ref,
    icon: _ant_design_icons_svg_es_asn_PlusOutlined__WEBPACK_IMPORTED_MODULE_2__.default
  }));
};

PlusOutlined.displayName = 'PlusOutlined';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (react__WEBPACK_IMPORTED_MODULE_0__.forwardRef(PlusOutlined));

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/icons/QuestionCircleOutlined.js":
/*!*******************************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/icons/QuestionCircleOutlined.js ***!
  \*******************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ant_design_icons_svg_es_asn_QuestionCircleOutlined__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons-svg/es/asn/QuestionCircleOutlined */ "../../node_modules/@ant-design/icons-svg/es/asn/QuestionCircleOutlined.js");
/* harmony import */ var _components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/AntdIcon */ "../../node_modules/@ant-design/icons/es/components/AntdIcon.js");
// GENERATE BY ./scripts/generate.ts
// DON NOT EDIT IT MANUALLY




var QuestionCircleOutlined = function QuestionCircleOutlined(props, ref) {
  return react__WEBPACK_IMPORTED_MODULE_0__.createElement(_components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__.default, Object.assign({}, props, {
    ref: ref,
    icon: _ant_design_icons_svg_es_asn_QuestionCircleOutlined__WEBPACK_IMPORTED_MODULE_2__.default
  }));
};

QuestionCircleOutlined.displayName = 'QuestionCircleOutlined';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (react__WEBPACK_IMPORTED_MODULE_0__.forwardRef(QuestionCircleOutlined));

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/icons/ReloadOutlined.js":
/*!***********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/icons/ReloadOutlined.js ***!
  \***********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ant_design_icons_svg_es_asn_ReloadOutlined__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons-svg/es/asn/ReloadOutlined */ "../../node_modules/@ant-design/icons-svg/es/asn/ReloadOutlined.js");
/* harmony import */ var _components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/AntdIcon */ "../../node_modules/@ant-design/icons/es/components/AntdIcon.js");
// GENERATE BY ./scripts/generate.ts
// DON NOT EDIT IT MANUALLY




var ReloadOutlined = function ReloadOutlined(props, ref) {
  return react__WEBPACK_IMPORTED_MODULE_0__.createElement(_components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__.default, Object.assign({}, props, {
    ref: ref,
    icon: _ant_design_icons_svg_es_asn_ReloadOutlined__WEBPACK_IMPORTED_MODULE_2__.default
  }));
};

ReloadOutlined.displayName = 'ReloadOutlined';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (react__WEBPACK_IMPORTED_MODULE_0__.forwardRef(ReloadOutlined));

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/icons/SearchOutlined.js":
/*!***********************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/icons/SearchOutlined.js ***!
  \***********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ant_design_icons_svg_es_asn_SearchOutlined__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons-svg/es/asn/SearchOutlined */ "../../node_modules/@ant-design/icons-svg/es/asn/SearchOutlined.js");
/* harmony import */ var _components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/AntdIcon */ "../../node_modules/@ant-design/icons/es/components/AntdIcon.js");
// GENERATE BY ./scripts/generate.ts
// DON NOT EDIT IT MANUALLY




var SearchOutlined = function SearchOutlined(props, ref) {
  return react__WEBPACK_IMPORTED_MODULE_0__.createElement(_components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__.default, Object.assign({}, props, {
    ref: ref,
    icon: _ant_design_icons_svg_es_asn_SearchOutlined__WEBPACK_IMPORTED_MODULE_2__.default
  }));
};

SearchOutlined.displayName = 'SearchOutlined';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (react__WEBPACK_IMPORTED_MODULE_0__.forwardRef(SearchOutlined));

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/icons/UpOutlined.js":
/*!*******************************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/icons/UpOutlined.js ***!
  \*******************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ant_design_icons_svg_es_asn_UpOutlined__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons-svg/es/asn/UpOutlined */ "../../node_modules/@ant-design/icons-svg/es/asn/UpOutlined.js");
/* harmony import */ var _components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../components/AntdIcon */ "../../node_modules/@ant-design/icons/es/components/AntdIcon.js");
// GENERATE BY ./scripts/generate.ts
// DON NOT EDIT IT MANUALLY




var UpOutlined = function UpOutlined(props, ref) {
  return react__WEBPACK_IMPORTED_MODULE_0__.createElement(_components_AntdIcon__WEBPACK_IMPORTED_MODULE_1__.default, Object.assign({}, props, {
    ref: ref,
    icon: _ant_design_icons_svg_es_asn_UpOutlined__WEBPACK_IMPORTED_MODULE_2__.default
  }));
};

UpOutlined.displayName = 'UpOutlined';
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (react__WEBPACK_IMPORTED_MODULE_0__.forwardRef(UpOutlined));

/***/ }),

/***/ "../../node_modules/@ant-design/icons/es/utils.js":
/*!********************************************************!*\
  !*** ../../node_modules/@ant-design/icons/es/utils.js ***!
  \********************************************************/
/*! namespace exports */
/*! export generate [provided] [used] [could be renamed] */
/*! export getSecondaryColor [provided] [used] [could be renamed] */
/*! export iconStyles [provided] [unused] [could be renamed] */
/*! export isIconDefinition [provided] [used] [could be renamed] */
/*! export normalizeAttrs [provided] [unused] [could be renamed] */
/*! export normalizeTwoToneColors [provided] [used] [could be renamed] */
/*! export svgBaseProps [provided] [used] [could be renamed] */
/*! export useInsertStyles [provided] [used] [could be renamed] */
/*! export warning [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "warning": () => /* binding */ warning,
/* harmony export */   "isIconDefinition": () => /* binding */ isIconDefinition,
/* harmony export */   "generate": () => /* binding */ generate,
/* harmony export */   "getSecondaryColor": () => /* binding */ getSecondaryColor,
/* harmony export */   "normalizeTwoToneColors": () => /* binding */ normalizeTwoToneColors,
/* harmony export */   "svgBaseProps": () => /* binding */ svgBaseProps,
/* harmony export */   "useInsertStyles": () => /* binding */ useInsertStyles
/* harmony export */ });
/* unused harmony exports normalizeAttrs, iconStyles */
/* harmony import */ var _babel_runtime_helpers_esm_defineProperty__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @babel/runtime/helpers/esm/defineProperty */ "../../node_modules/@babel/runtime/helpers/esm/defineProperty.js");
/* harmony import */ var _babel_runtime_helpers_esm_typeof__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @babel/runtime/helpers/esm/typeof */ "../../node_modules/@babel/runtime/helpers/esm/typeof.js");
/* harmony import */ var _ant_design_colors__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/colors */ "../../node_modules/@ant-design/colors/lib/index.js");
/* harmony import */ var _ant_design_colors__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_ant_design_colors__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var rc_util_es_warning__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! rc-util/es/warning */ "../../node_modules/rc-util/es/warning.js");
/* harmony import */ var insert_css__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! insert-css */ "../../node_modules/insert-css/index.js");
/* harmony import */ var insert_css__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(insert_css__WEBPACK_IMPORTED_MODULE_5__);



function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0,_babel_runtime_helpers_esm_defineProperty__WEBPACK_IMPORTED_MODULE_0__.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }





function warning(valid, message) {
  (0,rc_util_es_warning__WEBPACK_IMPORTED_MODULE_4__.default)(valid, "[@ant-design/icons] ".concat(message));
}
function isIconDefinition(target) {
  return (0,_babel_runtime_helpers_esm_typeof__WEBPACK_IMPORTED_MODULE_1__.default)(target) === 'object' && typeof target.name === 'string' && typeof target.theme === 'string' && ((0,_babel_runtime_helpers_esm_typeof__WEBPACK_IMPORTED_MODULE_1__.default)(target.icon) === 'object' || typeof target.icon === 'function');
}
function normalizeAttrs() {
  var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return Object.keys(attrs).reduce(function (acc, key) {
    var val = attrs[key];

    switch (key) {
      case 'class':
        acc.className = val;
        delete acc.class;
        break;

      default:
        acc[key] = val;
    }

    return acc;
  }, {});
}
function generate(node, key, rootProps) {
  if (!rootProps) {
    return react__WEBPACK_IMPORTED_MODULE_3___default().createElement(node.tag, _objectSpread({
      key: key
    }, normalizeAttrs(node.attrs)), (node.children || []).map(function (child, index) {
      return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
    }));
  }

  return react__WEBPACK_IMPORTED_MODULE_3___default().createElement(node.tag, _objectSpread(_objectSpread({
    key: key
  }, normalizeAttrs(node.attrs)), rootProps), (node.children || []).map(function (child, index) {
    return generate(child, "".concat(key, "-").concat(node.tag, "-").concat(index));
  }));
}
function getSecondaryColor(primaryColor) {
  // choose the second color
  return (0,_ant_design_colors__WEBPACK_IMPORTED_MODULE_2__.generate)(primaryColor)[0];
}
function normalizeTwoToneColors(twoToneColor) {
  if (!twoToneColor) {
    return [];
  }

  return Array.isArray(twoToneColor) ? twoToneColor : [twoToneColor];
} // These props make sure that the SVG behaviours like general text.
// Reference: https://blog.prototypr.io/align-svg-icons-to-text-and-say-goodbye-to-font-icons-d44b3d7b26b4

var svgBaseProps = {
  width: '1em',
  height: '1em',
  fill: 'currentColor',
  'aria-hidden': 'true',
  focusable: 'false'
};
var iconStyles = "\n.anticon {\n  display: inline-block;\n  color: inherit;\n  font-style: normal;\n  line-height: 0;\n  text-align: center;\n  text-transform: none;\n  vertical-align: -0.125em;\n  text-rendering: optimizeLegibility;\n  -webkit-font-smoothing: antialiased;\n  -moz-osx-font-smoothing: grayscale;\n}\n\n.anticon > * {\n  line-height: 1;\n}\n\n.anticon svg {\n  display: inline-block;\n}\n\n.anticon::before {\n  display: none;\n}\n\n.anticon .anticon-icon {\n  display: block;\n}\n\n.anticon[tabindex] {\n  cursor: pointer;\n}\n\n.anticon-spin::before,\n.anticon-spin {\n  display: inline-block;\n  -webkit-animation: loadingCircle 1s infinite linear;\n  animation: loadingCircle 1s infinite linear;\n}\n\n@-webkit-keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n\n@keyframes loadingCircle {\n  100% {\n    -webkit-transform: rotate(360deg);\n    transform: rotate(360deg);\n  }\n}\n";
var cssInjectedFlag = false;
var useInsertStyles = function useInsertStyles() {
  var styleStr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : iconStyles;
  (0,react__WEBPACK_IMPORTED_MODULE_3__.useEffect)(function () {
    if (!cssInjectedFlag) {
      (0,insert_css__WEBPACK_IMPORTED_MODULE_5__.insertCss)(styleStr, {
        prepend: true
      });
      cssInjectedFlag = true;
    }
  }, []);
};

/***/ }),

/***/ "../../node_modules/@babel/runtime/helpers/esm/arrayLikeToArray.js":
/*!*************************************************************************!*\
  !*** ../../node_modules/@babel/runtime/helpers/esm/arrayLikeToArray.js ***!
  \*************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _arrayLikeToArray
/* harmony export */ });
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

/***/ }),

/***/ "../../node_modules/@babel/runtime/helpers/esm/arrayWithHoles.js":
/*!***********************************************************************!*\
  !*** ../../node_modules/@babel/runtime/helpers/esm/arrayWithHoles.js ***!
  \***********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _arrayWithHoles
/* harmony export */ });
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

/***/ }),

/***/ "../../node_modules/@babel/runtime/helpers/esm/defineProperty.js":
/*!***********************************************************************!*\
  !*** ../../node_modules/@babel/runtime/helpers/esm/defineProperty.js ***!
  \***********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _defineProperty
/* harmony export */ });
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

/***/ }),

/***/ "../../node_modules/@babel/runtime/helpers/esm/iterableToArrayLimit.js":
/*!*****************************************************************************!*\
  !*** ../../node_modules/@babel/runtime/helpers/esm/iterableToArrayLimit.js ***!
  \*****************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _iterableToArrayLimit
/* harmony export */ });
function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

/***/ }),

/***/ "../../node_modules/@babel/runtime/helpers/esm/nonIterableRest.js":
/*!************************************************************************!*\
  !*** ../../node_modules/@babel/runtime/helpers/esm/nonIterableRest.js ***!
  \************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _nonIterableRest
/* harmony export */ });
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

/***/ }),

/***/ "../../node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js":
/*!********************************************************************************!*\
  !*** ../../node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js ***!
  \********************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _objectWithoutProperties
/* harmony export */ });
/* harmony import */ var _objectWithoutPropertiesLoose__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./objectWithoutPropertiesLoose */ "../../node_modules/@babel/runtime/helpers/esm/objectWithoutPropertiesLoose.js");

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = (0,_objectWithoutPropertiesLoose__WEBPACK_IMPORTED_MODULE_0__.default)(source, excluded);
  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

/***/ }),

/***/ "../../node_modules/@babel/runtime/helpers/esm/objectWithoutPropertiesLoose.js":
/*!*************************************************************************************!*\
  !*** ../../node_modules/@babel/runtime/helpers/esm/objectWithoutPropertiesLoose.js ***!
  \*************************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _objectWithoutPropertiesLoose
/* harmony export */ });
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

/***/ }),

/***/ "../../node_modules/@babel/runtime/helpers/esm/slicedToArray.js":
/*!**********************************************************************!*\
  !*** ../../node_modules/@babel/runtime/helpers/esm/slicedToArray.js ***!
  \**********************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _slicedToArray
/* harmony export */ });
/* harmony import */ var _arrayWithHoles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./arrayWithHoles */ "../../node_modules/@babel/runtime/helpers/esm/arrayWithHoles.js");
/* harmony import */ var _iterableToArrayLimit__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./iterableToArrayLimit */ "../../node_modules/@babel/runtime/helpers/esm/iterableToArrayLimit.js");
/* harmony import */ var _unsupportedIterableToArray__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./unsupportedIterableToArray */ "../../node_modules/@babel/runtime/helpers/esm/unsupportedIterableToArray.js");
/* harmony import */ var _nonIterableRest__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./nonIterableRest */ "../../node_modules/@babel/runtime/helpers/esm/nonIterableRest.js");




function _slicedToArray(arr, i) {
  return (0,_arrayWithHoles__WEBPACK_IMPORTED_MODULE_0__.default)(arr) || (0,_iterableToArrayLimit__WEBPACK_IMPORTED_MODULE_1__.default)(arr, i) || (0,_unsupportedIterableToArray__WEBPACK_IMPORTED_MODULE_2__.default)(arr, i) || (0,_nonIterableRest__WEBPACK_IMPORTED_MODULE_3__.default)();
}

/***/ }),

/***/ "../../node_modules/@babel/runtime/helpers/esm/typeof.js":
/*!***************************************************************!*\
  !*** ../../node_modules/@babel/runtime/helpers/esm/typeof.js ***!
  \***************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _typeof
/* harmony export */ });
function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

/***/ }),

/***/ "../../node_modules/@babel/runtime/helpers/esm/unsupportedIterableToArray.js":
/*!***********************************************************************************!*\
  !*** ../../node_modules/@babel/runtime/helpers/esm/unsupportedIterableToArray.js ***!
  \***********************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _unsupportedIterableToArray
/* harmony export */ });
/* harmony import */ var _arrayLikeToArray__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./arrayLikeToArray */ "../../node_modules/@babel/runtime/helpers/esm/arrayLikeToArray.js");

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return (0,_arrayLikeToArray__WEBPACK_IMPORTED_MODULE_0__.default)(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return (0,_arrayLikeToArray__WEBPACK_IMPORTED_MODULE_0__.default)(o, minLen);
}

/***/ }),

/***/ "../../node_modules/classnames/index.js":
/*!**********************************************!*\
  !*** ../../node_modules/classnames/index.js ***!
  \**********************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_exports__ */
/***/ ((module, exports) => {

var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*!
  Copyright (c) 2017 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
/* global define */

(function () {
	'use strict';

	var hasOwn = {}.hasOwnProperty;

	function classNames () {
		var classes = [];

		for (var i = 0; i < arguments.length; i++) {
			var arg = arguments[i];
			if (!arg) continue;

			var argType = typeof arg;

			if (argType === 'string' || argType === 'number') {
				classes.push(arg);
			} else if (Array.isArray(arg) && arg.length) {
				var inner = classNames.apply(null, arg);
				if (inner) {
					classes.push(inner);
				}
			} else if (argType === 'object') {
				for (var key in arg) {
					if (hasOwn.call(arg, key) && arg[key]) {
						classes.push(key);
					}
				}
			}
		}

		return classes.join(' ');
	}

	if ( true && module.exports) {
		classNames.default = classNames;
		module.exports = classNames;
	} else if (true) {
		// register as 'classnames', consistent with npm package name
		!(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_RESULT__ = (function () {
			return classNames;
		}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	} else {}
}());


/***/ }),

/***/ "../../node_modules/insert-css/index.js":
/*!**********************************************!*\
  !*** ../../node_modules/insert-css/index.js ***!
  \**********************************************/
/*! unknown exports (runtime-defined) */
/*! export insertCss [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! other exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module */
/***/ ((module) => {

var containers = []; // will store container HTMLElement references
var styleElements = []; // will store {prepend: HTMLElement, append: HTMLElement}

var usage = 'insert-css: You need to provide a CSS string. Usage: insertCss(cssString[, options]).';

function insertCss(css, options) {
    options = options || {};

    if (css === undefined) {
        throw new Error(usage);
    }

    var position = options.prepend === true ? 'prepend' : 'append';
    var container = options.container !== undefined ? options.container : document.querySelector('head');
    var containerId = containers.indexOf(container);

    // first time we see this container, create the necessary entries
    if (containerId === -1) {
        containerId = containers.push(container) - 1;
        styleElements[containerId] = {};
    }

    // try to get the correponding container + position styleElement, create it otherwise
    var styleElement;

    if (styleElements[containerId] !== undefined && styleElements[containerId][position] !== undefined) {
        styleElement = styleElements[containerId][position];
    } else {
        styleElement = styleElements[containerId][position] = createStyleElement();

        if (position === 'prepend') {
            container.insertBefore(styleElement, container.childNodes[0]);
        } else {
            container.appendChild(styleElement);
        }
    }

    // strip potential UTF-8 BOM if css was read from a file
    if (css.charCodeAt(0) === 0xFEFF) { css = css.substr(1, css.length); }

    // actually add the stylesheet
    if (styleElement.styleSheet) {
        styleElement.styleSheet.cssText += css
    } else {
        styleElement.textContent += css;
    }

    return styleElement;
};

function createStyleElement() {
    var styleElement = document.createElement('style');
    styleElement.setAttribute('type', 'text/css');
    return styleElement;
}

module.exports = insertCss;
module.exports.insertCss = insertCss;


/***/ }),

/***/ "../../node_modules/qs/lib/formats.js":
/*!********************************************!*\
  !*** ../../node_modules/qs/lib/formats.js ***!
  \********************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module */
/***/ ((module) => {

"use strict";


var replace = String.prototype.replace;
var percentTwenties = /%20/g;

module.exports = {
    'default': 'RFC3986',
    formatters: {
        RFC1738: function (value) {
            return replace.call(value, percentTwenties, '+');
        },
        RFC3986: function (value) {
            return value;
        }
    },
    RFC1738: 'RFC1738',
    RFC3986: 'RFC3986'
};


/***/ }),

/***/ "../../node_modules/qs/lib/index.js":
/*!******************************************!*\
  !*** ../../node_modules/qs/lib/index.js ***!
  \******************************************/
/*! unknown exports (runtime-defined) */
/*! export parse [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export stringify [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! other exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__ */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var stringify = __webpack_require__(/*! ./stringify */ "../../node_modules/qs/lib/stringify.js");
var parse = __webpack_require__(/*! ./parse */ "../../node_modules/qs/lib/parse.js");
var formats = __webpack_require__(/*! ./formats */ "../../node_modules/qs/lib/formats.js");

module.exports = {
    formats: formats,
    parse: parse,
    stringify: stringify
};


/***/ }),

/***/ "../../node_modules/qs/lib/parse.js":
/*!******************************************!*\
  !*** ../../node_modules/qs/lib/parse.js ***!
  \******************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__ */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(/*! ./utils */ "../../node_modules/qs/lib/utils.js");

var has = Object.prototype.hasOwnProperty;

var defaults = {
    allowDots: false,
    allowPrototypes: false,
    arrayLimit: 20,
    charset: 'utf-8',
    charsetSentinel: false,
    comma: false,
    decoder: utils.decode,
    delimiter: '&',
    depth: 5,
    ignoreQueryPrefix: false,
    interpretNumericEntities: false,
    parameterLimit: 1000,
    parseArrays: true,
    plainObjects: false,
    strictNullHandling: false
};

var interpretNumericEntities = function (str) {
    return str.replace(/&#(\d+);/g, function ($0, numberStr) {
        return String.fromCharCode(parseInt(numberStr, 10));
    });
};

// This is what browsers will submit when the ✓ character occurs in an
// application/x-www-form-urlencoded body and the encoding of the page containing
// the form is iso-8859-1, or when the submitted form has an accept-charset
// attribute of iso-8859-1. Presumably also with other charsets that do not contain
// the ✓ character, such as us-ascii.
var isoSentinel = 'utf8=%26%2310003%3B'; // encodeURIComponent('&#10003;')

// These are the percent-encoded utf-8 octets representing a checkmark, indicating that the request actually is utf-8 encoded.
var charsetSentinel = 'utf8=%E2%9C%93'; // encodeURIComponent('✓')

var parseValues = function parseQueryStringValues(str, options) {
    var obj = {};
    var cleanStr = options.ignoreQueryPrefix ? str.replace(/^\?/, '') : str;
    var limit = options.parameterLimit === Infinity ? undefined : options.parameterLimit;
    var parts = cleanStr.split(options.delimiter, limit);
    var skipIndex = -1; // Keep track of where the utf8 sentinel was found
    var i;

    var charset = options.charset;
    if (options.charsetSentinel) {
        for (i = 0; i < parts.length; ++i) {
            if (parts[i].indexOf('utf8=') === 0) {
                if (parts[i] === charsetSentinel) {
                    charset = 'utf-8';
                } else if (parts[i] === isoSentinel) {
                    charset = 'iso-8859-1';
                }
                skipIndex = i;
                i = parts.length; // The eslint settings do not allow break;
            }
        }
    }

    for (i = 0; i < parts.length; ++i) {
        if (i === skipIndex) {
            continue;
        }
        var part = parts[i];

        var bracketEqualsPos = part.indexOf(']=');
        var pos = bracketEqualsPos === -1 ? part.indexOf('=') : bracketEqualsPos + 1;

        var key, val;
        if (pos === -1) {
            key = options.decoder(part, defaults.decoder, charset);
            val = options.strictNullHandling ? null : '';
        } else {
            key = options.decoder(part.slice(0, pos), defaults.decoder, charset);
            val = options.decoder(part.slice(pos + 1), defaults.decoder, charset);
        }

        if (val && options.interpretNumericEntities && charset === 'iso-8859-1') {
            val = interpretNumericEntities(val);
        }

        if (val && options.comma && val.indexOf(',') > -1) {
            val = val.split(',');
        }

        if (has.call(obj, key)) {
            obj[key] = utils.combine(obj[key], val);
        } else {
            obj[key] = val;
        }
    }

    return obj;
};

var parseObject = function (chain, val, options) {
    var leaf = val;

    for (var i = chain.length - 1; i >= 0; --i) {
        var obj;
        var root = chain[i];

        if (root === '[]' && options.parseArrays) {
            obj = [].concat(leaf);
        } else {
            obj = options.plainObjects ? Object.create(null) : {};
            var cleanRoot = root.charAt(0) === '[' && root.charAt(root.length - 1) === ']' ? root.slice(1, -1) : root;
            var index = parseInt(cleanRoot, 10);
            if (!options.parseArrays && cleanRoot === '') {
                obj = { 0: leaf };
            } else if (
                !isNaN(index)
                && root !== cleanRoot
                && String(index) === cleanRoot
                && index >= 0
                && (options.parseArrays && index <= options.arrayLimit)
            ) {
                obj = [];
                obj[index] = leaf;
            } else {
                obj[cleanRoot] = leaf;
            }
        }

        leaf = obj;
    }

    return leaf;
};

var parseKeys = function parseQueryStringKeys(givenKey, val, options) {
    if (!givenKey) {
        return;
    }

    // Transform dot notation to bracket notation
    var key = options.allowDots ? givenKey.replace(/\.([^.[]+)/g, '[$1]') : givenKey;

    // The regex chunks

    var brackets = /(\[[^[\]]*])/;
    var child = /(\[[^[\]]*])/g;

    // Get the parent

    var segment = brackets.exec(key);
    var parent = segment ? key.slice(0, segment.index) : key;

    // Stash the parent if it exists

    var keys = [];
    if (parent) {
        // If we aren't using plain objects, optionally prefix keys that would overwrite object prototype properties
        if (!options.plainObjects && has.call(Object.prototype, parent)) {
            if (!options.allowPrototypes) {
                return;
            }
        }

        keys.push(parent);
    }

    // Loop through children appending to the array until we hit depth

    var i = 0;
    while ((segment = child.exec(key)) !== null && i < options.depth) {
        i += 1;
        if (!options.plainObjects && has.call(Object.prototype, segment[1].slice(1, -1))) {
            if (!options.allowPrototypes) {
                return;
            }
        }
        keys.push(segment[1]);
    }

    // If there's a remainder, just add whatever is left

    if (segment) {
        keys.push('[' + key.slice(segment.index) + ']');
    }

    return parseObject(keys, val, options);
};

var normalizeParseOptions = function normalizeParseOptions(opts) {
    if (!opts) {
        return defaults;
    }

    if (opts.decoder !== null && opts.decoder !== undefined && typeof opts.decoder !== 'function') {
        throw new TypeError('Decoder has to be a function.');
    }

    if (typeof opts.charset !== 'undefined' && opts.charset !== 'utf-8' && opts.charset !== 'iso-8859-1') {
        throw new Error('The charset option must be either utf-8, iso-8859-1, or undefined');
    }
    var charset = typeof opts.charset === 'undefined' ? defaults.charset : opts.charset;

    return {
        allowDots: typeof opts.allowDots === 'undefined' ? defaults.allowDots : !!opts.allowDots,
        allowPrototypes: typeof opts.allowPrototypes === 'boolean' ? opts.allowPrototypes : defaults.allowPrototypes,
        arrayLimit: typeof opts.arrayLimit === 'number' ? opts.arrayLimit : defaults.arrayLimit,
        charset: charset,
        charsetSentinel: typeof opts.charsetSentinel === 'boolean' ? opts.charsetSentinel : defaults.charsetSentinel,
        comma: typeof opts.comma === 'boolean' ? opts.comma : defaults.comma,
        decoder: typeof opts.decoder === 'function' ? opts.decoder : defaults.decoder,
        delimiter: typeof opts.delimiter === 'string' || utils.isRegExp(opts.delimiter) ? opts.delimiter : defaults.delimiter,
        depth: typeof opts.depth === 'number' ? opts.depth : defaults.depth,
        ignoreQueryPrefix: opts.ignoreQueryPrefix === true,
        interpretNumericEntities: typeof opts.interpretNumericEntities === 'boolean' ? opts.interpretNumericEntities : defaults.interpretNumericEntities,
        parameterLimit: typeof opts.parameterLimit === 'number' ? opts.parameterLimit : defaults.parameterLimit,
        parseArrays: opts.parseArrays !== false,
        plainObjects: typeof opts.plainObjects === 'boolean' ? opts.plainObjects : defaults.plainObjects,
        strictNullHandling: typeof opts.strictNullHandling === 'boolean' ? opts.strictNullHandling : defaults.strictNullHandling
    };
};

module.exports = function (str, opts) {
    var options = normalizeParseOptions(opts);

    if (str === '' || str === null || typeof str === 'undefined') {
        return options.plainObjects ? Object.create(null) : {};
    }

    var tempObj = typeof str === 'string' ? parseValues(str, options) : str;
    var obj = options.plainObjects ? Object.create(null) : {};

    // Iterate over the keys and setup the new object

    var keys = Object.keys(tempObj);
    for (var i = 0; i < keys.length; ++i) {
        var key = keys[i];
        var newObj = parseKeys(key, tempObj[key], options);
        obj = utils.merge(obj, newObj, options);
    }

    return utils.compact(obj);
};


/***/ }),

/***/ "../../node_modules/qs/lib/stringify.js":
/*!**********************************************!*\
  !*** ../../node_modules/qs/lib/stringify.js ***!
  \**********************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__ */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(/*! ./utils */ "../../node_modules/qs/lib/utils.js");
var formats = __webpack_require__(/*! ./formats */ "../../node_modules/qs/lib/formats.js");
var has = Object.prototype.hasOwnProperty;

var arrayPrefixGenerators = {
    brackets: function brackets(prefix) { // eslint-disable-line func-name-matching
        return prefix + '[]';
    },
    comma: 'comma',
    indices: function indices(prefix, key) { // eslint-disable-line func-name-matching
        return prefix + '[' + key + ']';
    },
    repeat: function repeat(prefix) { // eslint-disable-line func-name-matching
        return prefix;
    }
};

var isArray = Array.isArray;
var push = Array.prototype.push;
var pushToArray = function (arr, valueOrArray) {
    push.apply(arr, isArray(valueOrArray) ? valueOrArray : [valueOrArray]);
};

var toISO = Date.prototype.toISOString;

var defaults = {
    addQueryPrefix: false,
    allowDots: false,
    charset: 'utf-8',
    charsetSentinel: false,
    delimiter: '&',
    encode: true,
    encoder: utils.encode,
    encodeValuesOnly: false,
    formatter: formats.formatters[formats['default']],
    // deprecated
    indices: false,
    serializeDate: function serializeDate(date) { // eslint-disable-line func-name-matching
        return toISO.call(date);
    },
    skipNulls: false,
    strictNullHandling: false
};

var stringify = function stringify( // eslint-disable-line func-name-matching
    object,
    prefix,
    generateArrayPrefix,
    strictNullHandling,
    skipNulls,
    encoder,
    filter,
    sort,
    allowDots,
    serializeDate,
    formatter,
    encodeValuesOnly,
    charset
) {
    var obj = object;
    if (typeof filter === 'function') {
        obj = filter(prefix, obj);
    } else if (obj instanceof Date) {
        obj = serializeDate(obj);
    } else if (generateArrayPrefix === 'comma' && isArray(obj)) {
        obj = obj.join(',');
    }

    if (obj === null) {
        if (strictNullHandling) {
            return encoder && !encodeValuesOnly ? encoder(prefix, defaults.encoder, charset) : prefix;
        }

        obj = '';
    }

    if (typeof obj === 'string' || typeof obj === 'number' || typeof obj === 'boolean' || utils.isBuffer(obj)) {
        if (encoder) {
            var keyValue = encodeValuesOnly ? prefix : encoder(prefix, defaults.encoder, charset);
            return [formatter(keyValue) + '=' + formatter(encoder(obj, defaults.encoder, charset))];
        }
        return [formatter(prefix) + '=' + formatter(String(obj))];
    }

    var values = [];

    if (typeof obj === 'undefined') {
        return values;
    }

    var objKeys;
    if (isArray(filter)) {
        objKeys = filter;
    } else {
        var keys = Object.keys(obj);
        objKeys = sort ? keys.sort(sort) : keys;
    }

    for (var i = 0; i < objKeys.length; ++i) {
        var key = objKeys[i];

        if (skipNulls && obj[key] === null) {
            continue;
        }

        if (isArray(obj)) {
            pushToArray(values, stringify(
                obj[key],
                typeof generateArrayPrefix === 'function' ? generateArrayPrefix(prefix, key) : prefix,
                generateArrayPrefix,
                strictNullHandling,
                skipNulls,
                encoder,
                filter,
                sort,
                allowDots,
                serializeDate,
                formatter,
                encodeValuesOnly,
                charset
            ));
        } else {
            pushToArray(values, stringify(
                obj[key],
                prefix + (allowDots ? '.' + key : '[' + key + ']'),
                generateArrayPrefix,
                strictNullHandling,
                skipNulls,
                encoder,
                filter,
                sort,
                allowDots,
                serializeDate,
                formatter,
                encodeValuesOnly,
                charset
            ));
        }
    }

    return values;
};

var normalizeStringifyOptions = function normalizeStringifyOptions(opts) {
    if (!opts) {
        return defaults;
    }

    if (opts.encoder !== null && opts.encoder !== undefined && typeof opts.encoder !== 'function') {
        throw new TypeError('Encoder has to be a function.');
    }

    var charset = opts.charset || defaults.charset;
    if (typeof opts.charset !== 'undefined' && opts.charset !== 'utf-8' && opts.charset !== 'iso-8859-1') {
        throw new TypeError('The charset option must be either utf-8, iso-8859-1, or undefined');
    }

    var format = formats['default'];
    if (typeof opts.format !== 'undefined') {
        if (!has.call(formats.formatters, opts.format)) {
            throw new TypeError('Unknown format option provided.');
        }
        format = opts.format;
    }
    var formatter = formats.formatters[format];

    var filter = defaults.filter;
    if (typeof opts.filter === 'function' || isArray(opts.filter)) {
        filter = opts.filter;
    }

    return {
        addQueryPrefix: typeof opts.addQueryPrefix === 'boolean' ? opts.addQueryPrefix : defaults.addQueryPrefix,
        allowDots: typeof opts.allowDots === 'undefined' ? defaults.allowDots : !!opts.allowDots,
        charset: charset,
        charsetSentinel: typeof opts.charsetSentinel === 'boolean' ? opts.charsetSentinel : defaults.charsetSentinel,
        delimiter: typeof opts.delimiter === 'undefined' ? defaults.delimiter : opts.delimiter,
        encode: typeof opts.encode === 'boolean' ? opts.encode : defaults.encode,
        encoder: typeof opts.encoder === 'function' ? opts.encoder : defaults.encoder,
        encodeValuesOnly: typeof opts.encodeValuesOnly === 'boolean' ? opts.encodeValuesOnly : defaults.encodeValuesOnly,
        filter: filter,
        formatter: formatter,
        serializeDate: typeof opts.serializeDate === 'function' ? opts.serializeDate : defaults.serializeDate,
        skipNulls: typeof opts.skipNulls === 'boolean' ? opts.skipNulls : defaults.skipNulls,
        sort: typeof opts.sort === 'function' ? opts.sort : null,
        strictNullHandling: typeof opts.strictNullHandling === 'boolean' ? opts.strictNullHandling : defaults.strictNullHandling
    };
};

module.exports = function (object, opts) {
    var obj = object;
    var options = normalizeStringifyOptions(opts);

    var objKeys;
    var filter;

    if (typeof options.filter === 'function') {
        filter = options.filter;
        obj = filter('', obj);
    } else if (isArray(options.filter)) {
        filter = options.filter;
        objKeys = filter;
    }

    var keys = [];

    if (typeof obj !== 'object' || obj === null) {
        return '';
    }

    var arrayFormat;
    if (opts && opts.arrayFormat in arrayPrefixGenerators) {
        arrayFormat = opts.arrayFormat;
    } else if (opts && 'indices' in opts) {
        arrayFormat = opts.indices ? 'indices' : 'repeat';
    } else {
        arrayFormat = 'indices';
    }

    var generateArrayPrefix = arrayPrefixGenerators[arrayFormat];

    if (!objKeys) {
        objKeys = Object.keys(obj);
    }

    if (options.sort) {
        objKeys.sort(options.sort);
    }

    for (var i = 0; i < objKeys.length; ++i) {
        var key = objKeys[i];

        if (options.skipNulls && obj[key] === null) {
            continue;
        }
        pushToArray(keys, stringify(
            obj[key],
            key,
            generateArrayPrefix,
            options.strictNullHandling,
            options.skipNulls,
            options.encode ? options.encoder : null,
            options.filter,
            options.sort,
            options.allowDots,
            options.serializeDate,
            options.formatter,
            options.encodeValuesOnly,
            options.charset
        ));
    }

    var joined = keys.join(options.delimiter);
    var prefix = options.addQueryPrefix === true ? '?' : '';

    if (options.charsetSentinel) {
        if (options.charset === 'iso-8859-1') {
            // encodeURIComponent('&#10003;'), the "numeric entity" representation of a checkmark
            prefix += 'utf8=%26%2310003%3B&';
        } else {
            // encodeURIComponent('✓')
            prefix += 'utf8=%E2%9C%93&';
        }
    }

    return joined.length > 0 ? prefix + joined : '';
};


/***/ }),

/***/ "../../node_modules/qs/lib/utils.js":
/*!******************************************!*\
  !*** ../../node_modules/qs/lib/utils.js ***!
  \******************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module */
/***/ ((module) => {

"use strict";


var has = Object.prototype.hasOwnProperty;
var isArray = Array.isArray;

var hexTable = (function () {
    var array = [];
    for (var i = 0; i < 256; ++i) {
        array.push('%' + ((i < 16 ? '0' : '') + i.toString(16)).toUpperCase());
    }

    return array;
}());

var compactQueue = function compactQueue(queue) {
    while (queue.length > 1) {
        var item = queue.pop();
        var obj = item.obj[item.prop];

        if (isArray(obj)) {
            var compacted = [];

            for (var j = 0; j < obj.length; ++j) {
                if (typeof obj[j] !== 'undefined') {
                    compacted.push(obj[j]);
                }
            }

            item.obj[item.prop] = compacted;
        }
    }
};

var arrayToObject = function arrayToObject(source, options) {
    var obj = options && options.plainObjects ? Object.create(null) : {};
    for (var i = 0; i < source.length; ++i) {
        if (typeof source[i] !== 'undefined') {
            obj[i] = source[i];
        }
    }

    return obj;
};

var merge = function merge(target, source, options) {
    if (!source) {
        return target;
    }

    if (typeof source !== 'object') {
        if (isArray(target)) {
            target.push(source);
        } else if (target && typeof target === 'object') {
            if ((options && (options.plainObjects || options.allowPrototypes)) || !has.call(Object.prototype, source)) {
                target[source] = true;
            }
        } else {
            return [target, source];
        }

        return target;
    }

    if (!target || typeof target !== 'object') {
        return [target].concat(source);
    }

    var mergeTarget = target;
    if (isArray(target) && !isArray(source)) {
        mergeTarget = arrayToObject(target, options);
    }

    if (isArray(target) && isArray(source)) {
        source.forEach(function (item, i) {
            if (has.call(target, i)) {
                var targetItem = target[i];
                if (targetItem && typeof targetItem === 'object' && item && typeof item === 'object') {
                    target[i] = merge(targetItem, item, options);
                } else {
                    target.push(item);
                }
            } else {
                target[i] = item;
            }
        });
        return target;
    }

    return Object.keys(source).reduce(function (acc, key) {
        var value = source[key];

        if (has.call(acc, key)) {
            acc[key] = merge(acc[key], value, options);
        } else {
            acc[key] = value;
        }
        return acc;
    }, mergeTarget);
};

var assign = function assignSingleSource(target, source) {
    return Object.keys(source).reduce(function (acc, key) {
        acc[key] = source[key];
        return acc;
    }, target);
};

var decode = function (str, decoder, charset) {
    var strWithoutPlus = str.replace(/\+/g, ' ');
    if (charset === 'iso-8859-1') {
        // unescape never throws, no try...catch needed:
        return strWithoutPlus.replace(/%[0-9a-f]{2}/gi, unescape);
    }
    // utf-8
    try {
        return decodeURIComponent(strWithoutPlus);
    } catch (e) {
        return strWithoutPlus;
    }
};

var encode = function encode(str, defaultEncoder, charset) {
    // This code was originally written by Brian White (mscdex) for the io.js core querystring library.
    // It has been adapted here for stricter adherence to RFC 3986
    if (str.length === 0) {
        return str;
    }

    var string = typeof str === 'string' ? str : String(str);

    if (charset === 'iso-8859-1') {
        return escape(string).replace(/%u[0-9a-f]{4}/gi, function ($0) {
            return '%26%23' + parseInt($0.slice(2), 16) + '%3B';
        });
    }

    var out = '';
    for (var i = 0; i < string.length; ++i) {
        var c = string.charCodeAt(i);

        if (
            c === 0x2D // -
            || c === 0x2E // .
            || c === 0x5F // _
            || c === 0x7E // ~
            || (c >= 0x30 && c <= 0x39) // 0-9
            || (c >= 0x41 && c <= 0x5A) // a-z
            || (c >= 0x61 && c <= 0x7A) // A-Z
        ) {
            out += string.charAt(i);
            continue;
        }

        if (c < 0x80) {
            out = out + hexTable[c];
            continue;
        }

        if (c < 0x800) {
            out = out + (hexTable[0xC0 | (c >> 6)] + hexTable[0x80 | (c & 0x3F)]);
            continue;
        }

        if (c < 0xD800 || c >= 0xE000) {
            out = out + (hexTable[0xE0 | (c >> 12)] + hexTable[0x80 | ((c >> 6) & 0x3F)] + hexTable[0x80 | (c & 0x3F)]);
            continue;
        }

        i += 1;
        c = 0x10000 + (((c & 0x3FF) << 10) | (string.charCodeAt(i) & 0x3FF));
        out += hexTable[0xF0 | (c >> 18)]
            + hexTable[0x80 | ((c >> 12) & 0x3F)]
            + hexTable[0x80 | ((c >> 6) & 0x3F)]
            + hexTable[0x80 | (c & 0x3F)];
    }

    return out;
};

var compact = function compact(value) {
    var queue = [{ obj: { o: value }, prop: 'o' }];
    var refs = [];

    for (var i = 0; i < queue.length; ++i) {
        var item = queue[i];
        var obj = item.obj[item.prop];

        var keys = Object.keys(obj);
        for (var j = 0; j < keys.length; ++j) {
            var key = keys[j];
            var val = obj[key];
            if (typeof val === 'object' && val !== null && refs.indexOf(val) === -1) {
                queue.push({ obj: obj, prop: key });
                refs.push(val);
            }
        }
    }

    compactQueue(queue);

    return value;
};

var isRegExp = function isRegExp(obj) {
    return Object.prototype.toString.call(obj) === '[object RegExp]';
};

var isBuffer = function isBuffer(obj) {
    if (!obj || typeof obj !== 'object') {
        return false;
    }

    return !!(obj.constructor && obj.constructor.isBuffer && obj.constructor.isBuffer(obj));
};

var combine = function combine(a, b) {
    return [].concat(a, b);
};

module.exports = {
    arrayToObject: arrayToObject,
    assign: assign,
    combine: combine,
    compact: compact,
    decode: decode,
    encode: encode,
    isBuffer: isBuffer,
    isRegExp: isRegExp,
    merge: merge
};


/***/ }),

/***/ "../../node_modules/rc-util/es/warning.js":
/*!************************************************!*\
  !*** ../../node_modules/rc-util/es/warning.js ***!
  \************************************************/
/*! namespace exports */
/*! export call [provided] [unused] [could be renamed] */
/*! export default [provided] [used] [could be renamed] */
/*! export note [provided] [unused] [could be renamed] */
/*! export noteOnce [provided] [unused] [could be renamed] */
/*! export resetWarned [provided] [unused] [could be renamed] */
/*! export warning [provided] [unused] [could be renamed] */
/*! export warningOnce [provided] [unused] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* unused harmony exports warning, note, resetWarned, call, warningOnce, noteOnce */
/* eslint-disable no-console */
var warned = {};
function warning(valid, message) {
  // Support uglify
  if ( true && !valid && console !== undefined) {
    console.error("Warning: ".concat(message));
  }
}
function note(valid, message) {
  // Support uglify
  if ( true && !valid && console !== undefined) {
    console.warn("Note: ".concat(message));
  }
}
function resetWarned() {
  warned = {};
}
function call(method, valid, message) {
  if (!valid && !warned[message]) {
    method(false, message);
    warned[message] = true;
  }
}
function warningOnce(valid, message) {
  call(warning, valid, message);
}
function noteOnce(valid, message) {
  call(note, valid, message);
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (warningOnce);
/* eslint-enable */

/***/ }),

/***/ "../../node_modules/regenerator-runtime/runtime.js":
/*!*********************************************************!*\
  !*** ../../node_modules/regenerator-runtime/runtime.js ***!
  \*********************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module */
/***/ ((module) => {

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {
  "use strict";

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunctionPrototype[toStringTagSymbol] =
    GeneratorFunction.displayName = "GeneratorFunction";

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      prototype[method] = function(arg) {
        return this._invoke(method, arg);
      };
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      if (!(toStringTagSymbol in genFun)) {
        genFun[toStringTagSymbol] = "GeneratorFunction";
      }
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  Gp[toStringTagSymbol] = "Generator";

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   true ? module.exports : undefined
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}


/***/ }),

/***/ "../../node_modules/tinycolor2/tinycolor.js":
/*!**************************************************!*\
  !*** ../../node_modules/tinycolor2/tinycolor.js ***!
  \**************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__, __webpack_exports__ */
/***/ ((module, exports, __webpack_require__) => {

var __WEBPACK_AMD_DEFINE_RESULT__;// TinyColor v1.4.1
// https://github.com/bgrins/TinyColor
// Brian Grinstead, MIT License

(function(Math) {

var trimLeft = /^\s+/,
    trimRight = /\s+$/,
    tinyCounter = 0,
    mathRound = Math.round,
    mathMin = Math.min,
    mathMax = Math.max,
    mathRandom = Math.random;

function tinycolor (color, opts) {

    color = (color) ? color : '';
    opts = opts || { };

    // If input is already a tinycolor, return itself
    if (color instanceof tinycolor) {
       return color;
    }
    // If we are called as a function, call using new instead
    if (!(this instanceof tinycolor)) {
        return new tinycolor(color, opts);
    }

    var rgb = inputToRGB(color);
    this._originalInput = color,
    this._r = rgb.r,
    this._g = rgb.g,
    this._b = rgb.b,
    this._a = rgb.a,
    this._roundA = mathRound(100*this._a) / 100,
    this._format = opts.format || rgb.format;
    this._gradientType = opts.gradientType;

    // Don't let the range of [0,255] come back in [0,1].
    // Potentially lose a little bit of precision here, but will fix issues where
    // .5 gets interpreted as half of the total, instead of half of 1
    // If it was supposed to be 128, this was already taken care of by `inputToRgb`
    if (this._r < 1) { this._r = mathRound(this._r); }
    if (this._g < 1) { this._g = mathRound(this._g); }
    if (this._b < 1) { this._b = mathRound(this._b); }

    this._ok = rgb.ok;
    this._tc_id = tinyCounter++;
}

tinycolor.prototype = {
    isDark: function() {
        return this.getBrightness() < 128;
    },
    isLight: function() {
        return !this.isDark();
    },
    isValid: function() {
        return this._ok;
    },
    getOriginalInput: function() {
      return this._originalInput;
    },
    getFormat: function() {
        return this._format;
    },
    getAlpha: function() {
        return this._a;
    },
    getBrightness: function() {
        //http://www.w3.org/TR/AERT#color-contrast
        var rgb = this.toRgb();
        return (rgb.r * 299 + rgb.g * 587 + rgb.b * 114) / 1000;
    },
    getLuminance: function() {
        //http://www.w3.org/TR/2008/REC-WCAG20-20081211/#relativeluminancedef
        var rgb = this.toRgb();
        var RsRGB, GsRGB, BsRGB, R, G, B;
        RsRGB = rgb.r/255;
        GsRGB = rgb.g/255;
        BsRGB = rgb.b/255;

        if (RsRGB <= 0.03928) {R = RsRGB / 12.92;} else {R = Math.pow(((RsRGB + 0.055) / 1.055), 2.4);}
        if (GsRGB <= 0.03928) {G = GsRGB / 12.92;} else {G = Math.pow(((GsRGB + 0.055) / 1.055), 2.4);}
        if (BsRGB <= 0.03928) {B = BsRGB / 12.92;} else {B = Math.pow(((BsRGB + 0.055) / 1.055), 2.4);}
        return (0.2126 * R) + (0.7152 * G) + (0.0722 * B);
    },
    setAlpha: function(value) {
        this._a = boundAlpha(value);
        this._roundA = mathRound(100*this._a) / 100;
        return this;
    },
    toHsv: function() {
        var hsv = rgbToHsv(this._r, this._g, this._b);
        return { h: hsv.h * 360, s: hsv.s, v: hsv.v, a: this._a };
    },
    toHsvString: function() {
        var hsv = rgbToHsv(this._r, this._g, this._b);
        var h = mathRound(hsv.h * 360), s = mathRound(hsv.s * 100), v = mathRound(hsv.v * 100);
        return (this._a == 1) ?
          "hsv("  + h + ", " + s + "%, " + v + "%)" :
          "hsva(" + h + ", " + s + "%, " + v + "%, "+ this._roundA + ")";
    },
    toHsl: function() {
        var hsl = rgbToHsl(this._r, this._g, this._b);
        return { h: hsl.h * 360, s: hsl.s, l: hsl.l, a: this._a };
    },
    toHslString: function() {
        var hsl = rgbToHsl(this._r, this._g, this._b);
        var h = mathRound(hsl.h * 360), s = mathRound(hsl.s * 100), l = mathRound(hsl.l * 100);
        return (this._a == 1) ?
          "hsl("  + h + ", " + s + "%, " + l + "%)" :
          "hsla(" + h + ", " + s + "%, " + l + "%, "+ this._roundA + ")";
    },
    toHex: function(allow3Char) {
        return rgbToHex(this._r, this._g, this._b, allow3Char);
    },
    toHexString: function(allow3Char) {
        return '#' + this.toHex(allow3Char);
    },
    toHex8: function(allow4Char) {
        return rgbaToHex(this._r, this._g, this._b, this._a, allow4Char);
    },
    toHex8String: function(allow4Char) {
        return '#' + this.toHex8(allow4Char);
    },
    toRgb: function() {
        return { r: mathRound(this._r), g: mathRound(this._g), b: mathRound(this._b), a: this._a };
    },
    toRgbString: function() {
        return (this._a == 1) ?
          "rgb("  + mathRound(this._r) + ", " + mathRound(this._g) + ", " + mathRound(this._b) + ")" :
          "rgba(" + mathRound(this._r) + ", " + mathRound(this._g) + ", " + mathRound(this._b) + ", " + this._roundA + ")";
    },
    toPercentageRgb: function() {
        return { r: mathRound(bound01(this._r, 255) * 100) + "%", g: mathRound(bound01(this._g, 255) * 100) + "%", b: mathRound(bound01(this._b, 255) * 100) + "%", a: this._a };
    },
    toPercentageRgbString: function() {
        return (this._a == 1) ?
          "rgb("  + mathRound(bound01(this._r, 255) * 100) + "%, " + mathRound(bound01(this._g, 255) * 100) + "%, " + mathRound(bound01(this._b, 255) * 100) + "%)" :
          "rgba(" + mathRound(bound01(this._r, 255) * 100) + "%, " + mathRound(bound01(this._g, 255) * 100) + "%, " + mathRound(bound01(this._b, 255) * 100) + "%, " + this._roundA + ")";
    },
    toName: function() {
        if (this._a === 0) {
            return "transparent";
        }

        if (this._a < 1) {
            return false;
        }

        return hexNames[rgbToHex(this._r, this._g, this._b, true)] || false;
    },
    toFilter: function(secondColor) {
        var hex8String = '#' + rgbaToArgbHex(this._r, this._g, this._b, this._a);
        var secondHex8String = hex8String;
        var gradientType = this._gradientType ? "GradientType = 1, " : "";

        if (secondColor) {
            var s = tinycolor(secondColor);
            secondHex8String = '#' + rgbaToArgbHex(s._r, s._g, s._b, s._a);
        }

        return "progid:DXImageTransform.Microsoft.gradient("+gradientType+"startColorstr="+hex8String+",endColorstr="+secondHex8String+")";
    },
    toString: function(format) {
        var formatSet = !!format;
        format = format || this._format;

        var formattedString = false;
        var hasAlpha = this._a < 1 && this._a >= 0;
        var needsAlphaFormat = !formatSet && hasAlpha && (format === "hex" || format === "hex6" || format === "hex3" || format === "hex4" || format === "hex8" || format === "name");

        if (needsAlphaFormat) {
            // Special case for "transparent", all other non-alpha formats
            // will return rgba when there is transparency.
            if (format === "name" && this._a === 0) {
                return this.toName();
            }
            return this.toRgbString();
        }
        if (format === "rgb") {
            formattedString = this.toRgbString();
        }
        if (format === "prgb") {
            formattedString = this.toPercentageRgbString();
        }
        if (format === "hex" || format === "hex6") {
            formattedString = this.toHexString();
        }
        if (format === "hex3") {
            formattedString = this.toHexString(true);
        }
        if (format === "hex4") {
            formattedString = this.toHex8String(true);
        }
        if (format === "hex8") {
            formattedString = this.toHex8String();
        }
        if (format === "name") {
            formattedString = this.toName();
        }
        if (format === "hsl") {
            formattedString = this.toHslString();
        }
        if (format === "hsv") {
            formattedString = this.toHsvString();
        }

        return formattedString || this.toHexString();
    },
    clone: function() {
        return tinycolor(this.toString());
    },

    _applyModification: function(fn, args) {
        var color = fn.apply(null, [this].concat([].slice.call(args)));
        this._r = color._r;
        this._g = color._g;
        this._b = color._b;
        this.setAlpha(color._a);
        return this;
    },
    lighten: function() {
        return this._applyModification(lighten, arguments);
    },
    brighten: function() {
        return this._applyModification(brighten, arguments);
    },
    darken: function() {
        return this._applyModification(darken, arguments);
    },
    desaturate: function() {
        return this._applyModification(desaturate, arguments);
    },
    saturate: function() {
        return this._applyModification(saturate, arguments);
    },
    greyscale: function() {
        return this._applyModification(greyscale, arguments);
    },
    spin: function() {
        return this._applyModification(spin, arguments);
    },

    _applyCombination: function(fn, args) {
        return fn.apply(null, [this].concat([].slice.call(args)));
    },
    analogous: function() {
        return this._applyCombination(analogous, arguments);
    },
    complement: function() {
        return this._applyCombination(complement, arguments);
    },
    monochromatic: function() {
        return this._applyCombination(monochromatic, arguments);
    },
    splitcomplement: function() {
        return this._applyCombination(splitcomplement, arguments);
    },
    triad: function() {
        return this._applyCombination(triad, arguments);
    },
    tetrad: function() {
        return this._applyCombination(tetrad, arguments);
    }
};

// If input is an object, force 1 into "1.0" to handle ratios properly
// String input requires "1.0" as input, so 1 will be treated as 1
tinycolor.fromRatio = function(color, opts) {
    if (typeof color == "object") {
        var newColor = {};
        for (var i in color) {
            if (color.hasOwnProperty(i)) {
                if (i === "a") {
                    newColor[i] = color[i];
                }
                else {
                    newColor[i] = convertToPercentage(color[i]);
                }
            }
        }
        color = newColor;
    }

    return tinycolor(color, opts);
};

// Given a string or object, convert that input to RGB
// Possible string inputs:
//
//     "red"
//     "#f00" or "f00"
//     "#ff0000" or "ff0000"
//     "#ff000000" or "ff000000"
//     "rgb 255 0 0" or "rgb (255, 0, 0)"
//     "rgb 1.0 0 0" or "rgb (1, 0, 0)"
//     "rgba (255, 0, 0, 1)" or "rgba 255, 0, 0, 1"
//     "rgba (1.0, 0, 0, 1)" or "rgba 1.0, 0, 0, 1"
//     "hsl(0, 100%, 50%)" or "hsl 0 100% 50%"
//     "hsla(0, 100%, 50%, 1)" or "hsla 0 100% 50%, 1"
//     "hsv(0, 100%, 100%)" or "hsv 0 100% 100%"
//
function inputToRGB(color) {

    var rgb = { r: 0, g: 0, b: 0 };
    var a = 1;
    var s = null;
    var v = null;
    var l = null;
    var ok = false;
    var format = false;

    if (typeof color == "string") {
        color = stringInputToObject(color);
    }

    if (typeof color == "object") {
        if (isValidCSSUnit(color.r) && isValidCSSUnit(color.g) && isValidCSSUnit(color.b)) {
            rgb = rgbToRgb(color.r, color.g, color.b);
            ok = true;
            format = String(color.r).substr(-1) === "%" ? "prgb" : "rgb";
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.v)) {
            s = convertToPercentage(color.s);
            v = convertToPercentage(color.v);
            rgb = hsvToRgb(color.h, s, v);
            ok = true;
            format = "hsv";
        }
        else if (isValidCSSUnit(color.h) && isValidCSSUnit(color.s) && isValidCSSUnit(color.l)) {
            s = convertToPercentage(color.s);
            l = convertToPercentage(color.l);
            rgb = hslToRgb(color.h, s, l);
            ok = true;
            format = "hsl";
        }

        if (color.hasOwnProperty("a")) {
            a = color.a;
        }
    }

    a = boundAlpha(a);

    return {
        ok: ok,
        format: color.format || format,
        r: mathMin(255, mathMax(rgb.r, 0)),
        g: mathMin(255, mathMax(rgb.g, 0)),
        b: mathMin(255, mathMax(rgb.b, 0)),
        a: a
    };
}


// Conversion Functions
// --------------------

// `rgbToHsl`, `rgbToHsv`, `hslToRgb`, `hsvToRgb` modified from:
// <http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript>

// `rgbToRgb`
// Handle bounds / percentage checking to conform to CSS color spec
// <http://www.w3.org/TR/css3-color/>
// *Assumes:* r, g, b in [0, 255] or [0, 1]
// *Returns:* { r, g, b } in [0, 255]
function rgbToRgb(r, g, b){
    return {
        r: bound01(r, 255) * 255,
        g: bound01(g, 255) * 255,
        b: bound01(b, 255) * 255
    };
}

// `rgbToHsl`
// Converts an RGB color value to HSL.
// *Assumes:* r, g, and b are contained in [0, 255] or [0, 1]
// *Returns:* { h, s, l } in [0,1]
function rgbToHsl(r, g, b) {

    r = bound01(r, 255);
    g = bound01(g, 255);
    b = bound01(b, 255);

    var max = mathMax(r, g, b), min = mathMin(r, g, b);
    var h, s, l = (max + min) / 2;

    if(max == min) {
        h = s = 0; // achromatic
    }
    else {
        var d = max - min;
        s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
        switch(max) {
            case r: h = (g - b) / d + (g < b ? 6 : 0); break;
            case g: h = (b - r) / d + 2; break;
            case b: h = (r - g) / d + 4; break;
        }

        h /= 6;
    }

    return { h: h, s: s, l: l };
}

// `hslToRgb`
// Converts an HSL color value to RGB.
// *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
// *Returns:* { r, g, b } in the set [0, 255]
function hslToRgb(h, s, l) {
    var r, g, b;

    h = bound01(h, 360);
    s = bound01(s, 100);
    l = bound01(l, 100);

    function hue2rgb(p, q, t) {
        if(t < 0) t += 1;
        if(t > 1) t -= 1;
        if(t < 1/6) return p + (q - p) * 6 * t;
        if(t < 1/2) return q;
        if(t < 2/3) return p + (q - p) * (2/3 - t) * 6;
        return p;
    }

    if(s === 0) {
        r = g = b = l; // achromatic
    }
    else {
        var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
        var p = 2 * l - q;
        r = hue2rgb(p, q, h + 1/3);
        g = hue2rgb(p, q, h);
        b = hue2rgb(p, q, h - 1/3);
    }

    return { r: r * 255, g: g * 255, b: b * 255 };
}

// `rgbToHsv`
// Converts an RGB color value to HSV
// *Assumes:* r, g, and b are contained in the set [0, 255] or [0, 1]
// *Returns:* { h, s, v } in [0,1]
function rgbToHsv(r, g, b) {

    r = bound01(r, 255);
    g = bound01(g, 255);
    b = bound01(b, 255);

    var max = mathMax(r, g, b), min = mathMin(r, g, b);
    var h, s, v = max;

    var d = max - min;
    s = max === 0 ? 0 : d / max;

    if(max == min) {
        h = 0; // achromatic
    }
    else {
        switch(max) {
            case r: h = (g - b) / d + (g < b ? 6 : 0); break;
            case g: h = (b - r) / d + 2; break;
            case b: h = (r - g) / d + 4; break;
        }
        h /= 6;
    }
    return { h: h, s: s, v: v };
}

// `hsvToRgb`
// Converts an HSV color value to RGB.
// *Assumes:* h is contained in [0, 1] or [0, 360] and s and v are contained in [0, 1] or [0, 100]
// *Returns:* { r, g, b } in the set [0, 255]
 function hsvToRgb(h, s, v) {

    h = bound01(h, 360) * 6;
    s = bound01(s, 100);
    v = bound01(v, 100);

    var i = Math.floor(h),
        f = h - i,
        p = v * (1 - s),
        q = v * (1 - f * s),
        t = v * (1 - (1 - f) * s),
        mod = i % 6,
        r = [v, q, p, p, t, v][mod],
        g = [t, v, v, q, p, p][mod],
        b = [p, p, t, v, v, q][mod];

    return { r: r * 255, g: g * 255, b: b * 255 };
}

// `rgbToHex`
// Converts an RGB color to hex
// Assumes r, g, and b are contained in the set [0, 255]
// Returns a 3 or 6 character hex
function rgbToHex(r, g, b, allow3Char) {

    var hex = [
        pad2(mathRound(r).toString(16)),
        pad2(mathRound(g).toString(16)),
        pad2(mathRound(b).toString(16))
    ];

    // Return a 3 character hex if possible
    if (allow3Char && hex[0].charAt(0) == hex[0].charAt(1) && hex[1].charAt(0) == hex[1].charAt(1) && hex[2].charAt(0) == hex[2].charAt(1)) {
        return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0);
    }

    return hex.join("");
}

// `rgbaToHex`
// Converts an RGBA color plus alpha transparency to hex
// Assumes r, g, b are contained in the set [0, 255] and
// a in [0, 1]. Returns a 4 or 8 character rgba hex
function rgbaToHex(r, g, b, a, allow4Char) {

    var hex = [
        pad2(mathRound(r).toString(16)),
        pad2(mathRound(g).toString(16)),
        pad2(mathRound(b).toString(16)),
        pad2(convertDecimalToHex(a))
    ];

    // Return a 4 character hex if possible
    if (allow4Char && hex[0].charAt(0) == hex[0].charAt(1) && hex[1].charAt(0) == hex[1].charAt(1) && hex[2].charAt(0) == hex[2].charAt(1) && hex[3].charAt(0) == hex[3].charAt(1)) {
        return hex[0].charAt(0) + hex[1].charAt(0) + hex[2].charAt(0) + hex[3].charAt(0);
    }

    return hex.join("");
}

// `rgbaToArgbHex`
// Converts an RGBA color to an ARGB Hex8 string
// Rarely used, but required for "toFilter()"
function rgbaToArgbHex(r, g, b, a) {

    var hex = [
        pad2(convertDecimalToHex(a)),
        pad2(mathRound(r).toString(16)),
        pad2(mathRound(g).toString(16)),
        pad2(mathRound(b).toString(16))
    ];

    return hex.join("");
}

// `equals`
// Can be called with any tinycolor input
tinycolor.equals = function (color1, color2) {
    if (!color1 || !color2) { return false; }
    return tinycolor(color1).toRgbString() == tinycolor(color2).toRgbString();
};

tinycolor.random = function() {
    return tinycolor.fromRatio({
        r: mathRandom(),
        g: mathRandom(),
        b: mathRandom()
    });
};


// Modification Functions
// ----------------------
// Thanks to less.js for some of the basics here
// <https://github.com/cloudhead/less.js/blob/master/lib/less/functions.js>

function desaturate(color, amount) {
    amount = (amount === 0) ? 0 : (amount || 10);
    var hsl = tinycolor(color).toHsl();
    hsl.s -= amount / 100;
    hsl.s = clamp01(hsl.s);
    return tinycolor(hsl);
}

function saturate(color, amount) {
    amount = (amount === 0) ? 0 : (amount || 10);
    var hsl = tinycolor(color).toHsl();
    hsl.s += amount / 100;
    hsl.s = clamp01(hsl.s);
    return tinycolor(hsl);
}

function greyscale(color) {
    return tinycolor(color).desaturate(100);
}

function lighten (color, amount) {
    amount = (amount === 0) ? 0 : (amount || 10);
    var hsl = tinycolor(color).toHsl();
    hsl.l += amount / 100;
    hsl.l = clamp01(hsl.l);
    return tinycolor(hsl);
}

function brighten(color, amount) {
    amount = (amount === 0) ? 0 : (amount || 10);
    var rgb = tinycolor(color).toRgb();
    rgb.r = mathMax(0, mathMin(255, rgb.r - mathRound(255 * - (amount / 100))));
    rgb.g = mathMax(0, mathMin(255, rgb.g - mathRound(255 * - (amount / 100))));
    rgb.b = mathMax(0, mathMin(255, rgb.b - mathRound(255 * - (amount / 100))));
    return tinycolor(rgb);
}

function darken (color, amount) {
    amount = (amount === 0) ? 0 : (amount || 10);
    var hsl = tinycolor(color).toHsl();
    hsl.l -= amount / 100;
    hsl.l = clamp01(hsl.l);
    return tinycolor(hsl);
}

// Spin takes a positive or negative amount within [-360, 360] indicating the change of hue.
// Values outside of this range will be wrapped into this range.
function spin(color, amount) {
    var hsl = tinycolor(color).toHsl();
    var hue = (hsl.h + amount) % 360;
    hsl.h = hue < 0 ? 360 + hue : hue;
    return tinycolor(hsl);
}

// Combination Functions
// ---------------------
// Thanks to jQuery xColor for some of the ideas behind these
// <https://github.com/infusion/jQuery-xcolor/blob/master/jquery.xcolor.js>

function complement(color) {
    var hsl = tinycolor(color).toHsl();
    hsl.h = (hsl.h + 180) % 360;
    return tinycolor(hsl);
}

function triad(color) {
    var hsl = tinycolor(color).toHsl();
    var h = hsl.h;
    return [
        tinycolor(color),
        tinycolor({ h: (h + 120) % 360, s: hsl.s, l: hsl.l }),
        tinycolor({ h: (h + 240) % 360, s: hsl.s, l: hsl.l })
    ];
}

function tetrad(color) {
    var hsl = tinycolor(color).toHsl();
    var h = hsl.h;
    return [
        tinycolor(color),
        tinycolor({ h: (h + 90) % 360, s: hsl.s, l: hsl.l }),
        tinycolor({ h: (h + 180) % 360, s: hsl.s, l: hsl.l }),
        tinycolor({ h: (h + 270) % 360, s: hsl.s, l: hsl.l })
    ];
}

function splitcomplement(color) {
    var hsl = tinycolor(color).toHsl();
    var h = hsl.h;
    return [
        tinycolor(color),
        tinycolor({ h: (h + 72) % 360, s: hsl.s, l: hsl.l}),
        tinycolor({ h: (h + 216) % 360, s: hsl.s, l: hsl.l})
    ];
}

function analogous(color, results, slices) {
    results = results || 6;
    slices = slices || 30;

    var hsl = tinycolor(color).toHsl();
    var part = 360 / slices;
    var ret = [tinycolor(color)];

    for (hsl.h = ((hsl.h - (part * results >> 1)) + 720) % 360; --results; ) {
        hsl.h = (hsl.h + part) % 360;
        ret.push(tinycolor(hsl));
    }
    return ret;
}

function monochromatic(color, results) {
    results = results || 6;
    var hsv = tinycolor(color).toHsv();
    var h = hsv.h, s = hsv.s, v = hsv.v;
    var ret = [];
    var modification = 1 / results;

    while (results--) {
        ret.push(tinycolor({ h: h, s: s, v: v}));
        v = (v + modification) % 1;
    }

    return ret;
}

// Utility Functions
// ---------------------

tinycolor.mix = function(color1, color2, amount) {
    amount = (amount === 0) ? 0 : (amount || 50);

    var rgb1 = tinycolor(color1).toRgb();
    var rgb2 = tinycolor(color2).toRgb();

    var p = amount / 100;

    var rgba = {
        r: ((rgb2.r - rgb1.r) * p) + rgb1.r,
        g: ((rgb2.g - rgb1.g) * p) + rgb1.g,
        b: ((rgb2.b - rgb1.b) * p) + rgb1.b,
        a: ((rgb2.a - rgb1.a) * p) + rgb1.a
    };

    return tinycolor(rgba);
};


// Readability Functions
// ---------------------
// <http://www.w3.org/TR/2008/REC-WCAG20-20081211/#contrast-ratiodef (WCAG Version 2)

// `contrast`
// Analyze the 2 colors and returns the color contrast defined by (WCAG Version 2)
tinycolor.readability = function(color1, color2) {
    var c1 = tinycolor(color1);
    var c2 = tinycolor(color2);
    return (Math.max(c1.getLuminance(),c2.getLuminance())+0.05) / (Math.min(c1.getLuminance(),c2.getLuminance())+0.05);
};

// `isReadable`
// Ensure that foreground and background color combinations meet WCAG2 guidelines.
// The third argument is an optional Object.
//      the 'level' property states 'AA' or 'AAA' - if missing or invalid, it defaults to 'AA';
//      the 'size' property states 'large' or 'small' - if missing or invalid, it defaults to 'small'.
// If the entire object is absent, isReadable defaults to {level:"AA",size:"small"}.

// *Example*
//    tinycolor.isReadable("#000", "#111") => false
//    tinycolor.isReadable("#000", "#111",{level:"AA",size:"large"}) => false
tinycolor.isReadable = function(color1, color2, wcag2) {
    var readability = tinycolor.readability(color1, color2);
    var wcag2Parms, out;

    out = false;

    wcag2Parms = validateWCAG2Parms(wcag2);
    switch (wcag2Parms.level + wcag2Parms.size) {
        case "AAsmall":
        case "AAAlarge":
            out = readability >= 4.5;
            break;
        case "AAlarge":
            out = readability >= 3;
            break;
        case "AAAsmall":
            out = readability >= 7;
            break;
    }
    return out;

};

// `mostReadable`
// Given a base color and a list of possible foreground or background
// colors for that base, returns the most readable color.
// Optionally returns Black or White if the most readable color is unreadable.
// *Example*
//    tinycolor.mostReadable(tinycolor.mostReadable("#123", ["#124", "#125"],{includeFallbackColors:false}).toHexString(); // "#112255"
//    tinycolor.mostReadable(tinycolor.mostReadable("#123", ["#124", "#125"],{includeFallbackColors:true}).toHexString();  // "#ffffff"
//    tinycolor.mostReadable("#a8015a", ["#faf3f3"],{includeFallbackColors:true,level:"AAA",size:"large"}).toHexString(); // "#faf3f3"
//    tinycolor.mostReadable("#a8015a", ["#faf3f3"],{includeFallbackColors:true,level:"AAA",size:"small"}).toHexString(); // "#ffffff"
tinycolor.mostReadable = function(baseColor, colorList, args) {
    var bestColor = null;
    var bestScore = 0;
    var readability;
    var includeFallbackColors, level, size ;
    args = args || {};
    includeFallbackColors = args.includeFallbackColors ;
    level = args.level;
    size = args.size;

    for (var i= 0; i < colorList.length ; i++) {
        readability = tinycolor.readability(baseColor, colorList[i]);
        if (readability > bestScore) {
            bestScore = readability;
            bestColor = tinycolor(colorList[i]);
        }
    }

    if (tinycolor.isReadable(baseColor, bestColor, {"level":level,"size":size}) || !includeFallbackColors) {
        return bestColor;
    }
    else {
        args.includeFallbackColors=false;
        return tinycolor.mostReadable(baseColor,["#fff", "#000"],args);
    }
};


// Big List of Colors
// ------------------
// <http://www.w3.org/TR/css3-color/#svg-color>
var names = tinycolor.names = {
    aliceblue: "f0f8ff",
    antiquewhite: "faebd7",
    aqua: "0ff",
    aquamarine: "7fffd4",
    azure: "f0ffff",
    beige: "f5f5dc",
    bisque: "ffe4c4",
    black: "000",
    blanchedalmond: "ffebcd",
    blue: "00f",
    blueviolet: "8a2be2",
    brown: "a52a2a",
    burlywood: "deb887",
    burntsienna: "ea7e5d",
    cadetblue: "5f9ea0",
    chartreuse: "7fff00",
    chocolate: "d2691e",
    coral: "ff7f50",
    cornflowerblue: "6495ed",
    cornsilk: "fff8dc",
    crimson: "dc143c",
    cyan: "0ff",
    darkblue: "00008b",
    darkcyan: "008b8b",
    darkgoldenrod: "b8860b",
    darkgray: "a9a9a9",
    darkgreen: "006400",
    darkgrey: "a9a9a9",
    darkkhaki: "bdb76b",
    darkmagenta: "8b008b",
    darkolivegreen: "556b2f",
    darkorange: "ff8c00",
    darkorchid: "9932cc",
    darkred: "8b0000",
    darksalmon: "e9967a",
    darkseagreen: "8fbc8f",
    darkslateblue: "483d8b",
    darkslategray: "2f4f4f",
    darkslategrey: "2f4f4f",
    darkturquoise: "00ced1",
    darkviolet: "9400d3",
    deeppink: "ff1493",
    deepskyblue: "00bfff",
    dimgray: "696969",
    dimgrey: "696969",
    dodgerblue: "1e90ff",
    firebrick: "b22222",
    floralwhite: "fffaf0",
    forestgreen: "228b22",
    fuchsia: "f0f",
    gainsboro: "dcdcdc",
    ghostwhite: "f8f8ff",
    gold: "ffd700",
    goldenrod: "daa520",
    gray: "808080",
    green: "008000",
    greenyellow: "adff2f",
    grey: "808080",
    honeydew: "f0fff0",
    hotpink: "ff69b4",
    indianred: "cd5c5c",
    indigo: "4b0082",
    ivory: "fffff0",
    khaki: "f0e68c",
    lavender: "e6e6fa",
    lavenderblush: "fff0f5",
    lawngreen: "7cfc00",
    lemonchiffon: "fffacd",
    lightblue: "add8e6",
    lightcoral: "f08080",
    lightcyan: "e0ffff",
    lightgoldenrodyellow: "fafad2",
    lightgray: "d3d3d3",
    lightgreen: "90ee90",
    lightgrey: "d3d3d3",
    lightpink: "ffb6c1",
    lightsalmon: "ffa07a",
    lightseagreen: "20b2aa",
    lightskyblue: "87cefa",
    lightslategray: "789",
    lightslategrey: "789",
    lightsteelblue: "b0c4de",
    lightyellow: "ffffe0",
    lime: "0f0",
    limegreen: "32cd32",
    linen: "faf0e6",
    magenta: "f0f",
    maroon: "800000",
    mediumaquamarine: "66cdaa",
    mediumblue: "0000cd",
    mediumorchid: "ba55d3",
    mediumpurple: "9370db",
    mediumseagreen: "3cb371",
    mediumslateblue: "7b68ee",
    mediumspringgreen: "00fa9a",
    mediumturquoise: "48d1cc",
    mediumvioletred: "c71585",
    midnightblue: "191970",
    mintcream: "f5fffa",
    mistyrose: "ffe4e1",
    moccasin: "ffe4b5",
    navajowhite: "ffdead",
    navy: "000080",
    oldlace: "fdf5e6",
    olive: "808000",
    olivedrab: "6b8e23",
    orange: "ffa500",
    orangered: "ff4500",
    orchid: "da70d6",
    palegoldenrod: "eee8aa",
    palegreen: "98fb98",
    paleturquoise: "afeeee",
    palevioletred: "db7093",
    papayawhip: "ffefd5",
    peachpuff: "ffdab9",
    peru: "cd853f",
    pink: "ffc0cb",
    plum: "dda0dd",
    powderblue: "b0e0e6",
    purple: "800080",
    rebeccapurple: "663399",
    red: "f00",
    rosybrown: "bc8f8f",
    royalblue: "4169e1",
    saddlebrown: "8b4513",
    salmon: "fa8072",
    sandybrown: "f4a460",
    seagreen: "2e8b57",
    seashell: "fff5ee",
    sienna: "a0522d",
    silver: "c0c0c0",
    skyblue: "87ceeb",
    slateblue: "6a5acd",
    slategray: "708090",
    slategrey: "708090",
    snow: "fffafa",
    springgreen: "00ff7f",
    steelblue: "4682b4",
    tan: "d2b48c",
    teal: "008080",
    thistle: "d8bfd8",
    tomato: "ff6347",
    turquoise: "40e0d0",
    violet: "ee82ee",
    wheat: "f5deb3",
    white: "fff",
    whitesmoke: "f5f5f5",
    yellow: "ff0",
    yellowgreen: "9acd32"
};

// Make it easy to access colors via `hexNames[hex]`
var hexNames = tinycolor.hexNames = flip(names);


// Utilities
// ---------

// `{ 'name1': 'val1' }` becomes `{ 'val1': 'name1' }`
function flip(o) {
    var flipped = { };
    for (var i in o) {
        if (o.hasOwnProperty(i)) {
            flipped[o[i]] = i;
        }
    }
    return flipped;
}

// Return a valid alpha value [0,1] with all invalid values being set to 1
function boundAlpha(a) {
    a = parseFloat(a);

    if (isNaN(a) || a < 0 || a > 1) {
        a = 1;
    }

    return a;
}

// Take input from [0, n] and return it as [0, 1]
function bound01(n, max) {
    if (isOnePointZero(n)) { n = "100%"; }

    var processPercent = isPercentage(n);
    n = mathMin(max, mathMax(0, parseFloat(n)));

    // Automatically convert percentage into number
    if (processPercent) {
        n = parseInt(n * max, 10) / 100;
    }

    // Handle floating point rounding errors
    if ((Math.abs(n - max) < 0.000001)) {
        return 1;
    }

    // Convert into [0, 1] range if it isn't already
    return (n % max) / parseFloat(max);
}

// Force a number between 0 and 1
function clamp01(val) {
    return mathMin(1, mathMax(0, val));
}

// Parse a base-16 hex value into a base-10 integer
function parseIntFromHex(val) {
    return parseInt(val, 16);
}

// Need to handle 1.0 as 100%, since once it is a number, there is no difference between it and 1
// <http://stackoverflow.com/questions/7422072/javascript-how-to-detect-number-as-a-decimal-including-1-0>
function isOnePointZero(n) {
    return typeof n == "string" && n.indexOf('.') != -1 && parseFloat(n) === 1;
}

// Check to see if string passed in is a percentage
function isPercentage(n) {
    return typeof n === "string" && n.indexOf('%') != -1;
}

// Force a hex value to have 2 characters
function pad2(c) {
    return c.length == 1 ? '0' + c : '' + c;
}

// Replace a decimal with it's percentage value
function convertToPercentage(n) {
    if (n <= 1) {
        n = (n * 100) + "%";
    }

    return n;
}

// Converts a decimal to a hex value
function convertDecimalToHex(d) {
    return Math.round(parseFloat(d) * 255).toString(16);
}
// Converts a hex value to a decimal
function convertHexToDecimal(h) {
    return (parseIntFromHex(h) / 255);
}

var matchers = (function() {

    // <http://www.w3.org/TR/css3-values/#integers>
    var CSS_INTEGER = "[-\\+]?\\d+%?";

    // <http://www.w3.org/TR/css3-values/#number-value>
    var CSS_NUMBER = "[-\\+]?\\d*\\.\\d+%?";

    // Allow positive/negative integer/number.  Don't capture the either/or, just the entire outcome.
    var CSS_UNIT = "(?:" + CSS_NUMBER + ")|(?:" + CSS_INTEGER + ")";

    // Actual matching.
    // Parentheses and commas are optional, but not required.
    // Whitespace can take the place of commas or opening paren
    var PERMISSIVE_MATCH3 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";
    var PERMISSIVE_MATCH4 = "[\\s|\\(]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")[,|\\s]+(" + CSS_UNIT + ")\\s*\\)?";

    return {
        CSS_UNIT: new RegExp(CSS_UNIT),
        rgb: new RegExp("rgb" + PERMISSIVE_MATCH3),
        rgba: new RegExp("rgba" + PERMISSIVE_MATCH4),
        hsl: new RegExp("hsl" + PERMISSIVE_MATCH3),
        hsla: new RegExp("hsla" + PERMISSIVE_MATCH4),
        hsv: new RegExp("hsv" + PERMISSIVE_MATCH3),
        hsva: new RegExp("hsva" + PERMISSIVE_MATCH4),
        hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
        hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,
        hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,
        hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/
    };
})();

// `isValidCSSUnit`
// Take in a single string / number and check to see if it looks like a CSS unit
// (see `matchers` above for definition).
function isValidCSSUnit(color) {
    return !!matchers.CSS_UNIT.exec(color);
}

// `stringInputToObject`
// Permissive string parsing.  Take in a number of formats, and output an object
// based on detected format.  Returns `{ r, g, b }` or `{ h, s, l }` or `{ h, s, v}`
function stringInputToObject(color) {

    color = color.replace(trimLeft,'').replace(trimRight, '').toLowerCase();
    var named = false;
    if (names[color]) {
        color = names[color];
        named = true;
    }
    else if (color == 'transparent') {
        return { r: 0, g: 0, b: 0, a: 0, format: "name" };
    }

    // Try to match string input using regular expressions.
    // Keep most of the number bounding out of this function - don't worry about [0,1] or [0,100] or [0,360]
    // Just return an object and let the conversion functions handle that.
    // This way the result will be the same whether the tinycolor is initialized with string or object.
    var match;
    if ((match = matchers.rgb.exec(color))) {
        return { r: match[1], g: match[2], b: match[3] };
    }
    if ((match = matchers.rgba.exec(color))) {
        return { r: match[1], g: match[2], b: match[3], a: match[4] };
    }
    if ((match = matchers.hsl.exec(color))) {
        return { h: match[1], s: match[2], l: match[3] };
    }
    if ((match = matchers.hsla.exec(color))) {
        return { h: match[1], s: match[2], l: match[3], a: match[4] };
    }
    if ((match = matchers.hsv.exec(color))) {
        return { h: match[1], s: match[2], v: match[3] };
    }
    if ((match = matchers.hsva.exec(color))) {
        return { h: match[1], s: match[2], v: match[3], a: match[4] };
    }
    if ((match = matchers.hex8.exec(color))) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            a: convertHexToDecimal(match[4]),
            format: named ? "name" : "hex8"
        };
    }
    if ((match = matchers.hex6.exec(color))) {
        return {
            r: parseIntFromHex(match[1]),
            g: parseIntFromHex(match[2]),
            b: parseIntFromHex(match[3]),
            format: named ? "name" : "hex"
        };
    }
    if ((match = matchers.hex4.exec(color))) {
        return {
            r: parseIntFromHex(match[1] + '' + match[1]),
            g: parseIntFromHex(match[2] + '' + match[2]),
            b: parseIntFromHex(match[3] + '' + match[3]),
            a: convertHexToDecimal(match[4] + '' + match[4]),
            format: named ? "name" : "hex8"
        };
    }
    if ((match = matchers.hex3.exec(color))) {
        return {
            r: parseIntFromHex(match[1] + '' + match[1]),
            g: parseIntFromHex(match[2] + '' + match[2]),
            b: parseIntFromHex(match[3] + '' + match[3]),
            format: named ? "name" : "hex"
        };
    }

    return false;
}

function validateWCAG2Parms(parms) {
    // return valid WCAG2 parms for isReadable.
    // If input parms are invalid, return {"level":"AA", "size":"small"}
    var level, size;
    parms = parms || {"level":"AA", "size":"small"};
    level = (parms.level || "AA").toUpperCase();
    size = (parms.size || "small").toLowerCase();
    if (level !== "AA" && level !== "AAA") {
        level = "AA";
    }
    if (size !== "small" && size !== "large") {
        size = "small";
    }
    return {"level":level, "size":size};
}

// Node: Export function
if ( true && module.exports) {
    module.exports = tinycolor;
}
// AMD/requirejs: Define the module
else if (true) {
    !(__WEBPACK_AMD_DEFINE_RESULT__ = (function () {return tinycolor;}).call(exports, __webpack_require__, exports, module),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
}
// Browser: Expose to window
else {}

})(Math);


/***/ }),

/***/ "../../node_modules/uppercamelcase/index.js":
/*!**************************************************!*\
  !*** ../../node_modules/uppercamelcase/index.js ***!
  \**************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__ */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";

const camelCase = __webpack_require__(/*! camelcase */ "../../node_modules/uppercamelcase/node_modules/camelcase/index.js");

module.exports = function () {
	const cased = camelCase.apply(camelCase, arguments);
	return cased.charAt(0).toUpperCase() + cased.slice(1);
};


/***/ }),

/***/ "../../node_modules/uppercamelcase/node_modules/camelcase/index.js":
/*!*************************************************************************!*\
  !*** ../../node_modules/uppercamelcase/node_modules/camelcase/index.js ***!
  \*************************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module */
/***/ ((module) => {

"use strict";


function preserveCamelCase(str) {
	let isLastCharLower = false;
	let isLastCharUpper = false;
	let isLastLastCharUpper = false;

	for (let i = 0; i < str.length; i++) {
		const c = str[i];

		if (isLastCharLower && /[a-zA-Z]/.test(c) && c.toUpperCase() === c) {
			str = str.substr(0, i) + '-' + str.substr(i);
			isLastCharLower = false;
			isLastLastCharUpper = isLastCharUpper;
			isLastCharUpper = true;
			i++;
		} else if (isLastCharUpper && isLastLastCharUpper && /[a-zA-Z]/.test(c) && c.toLowerCase() === c) {
			str = str.substr(0, i - 1) + '-' + str.substr(i - 1);
			isLastLastCharUpper = isLastCharUpper;
			isLastCharUpper = false;
			isLastCharLower = true;
		} else {
			isLastCharLower = c.toLowerCase() === c;
			isLastLastCharUpper = isLastCharUpper;
			isLastCharUpper = c.toUpperCase() === c;
		}
	}

	return str;
}

module.exports = function (str) {
	if (arguments.length > 1) {
		str = Array.from(arguments)
			.map(x => x.trim())
			.filter(x => x.length)
			.join('-');
	} else {
		str = str.trim();
	}

	if (str.length === 0) {
		return '';
	}

	if (str.length === 1) {
		return str.toLowerCase();
	}

	if (/^[a-z0-9]+$/.test(str)) {
		return str;
	}

	const hasUpperCase = str !== str.toLowerCase();

	if (hasUpperCase) {
		str = preserveCamelCase(str);
	}

	return str
		.replace(/^[_.\- ]+/, '')
		.toLowerCase()
		.replace(/[_.\- ]+(\w|$)/g, (m, p1) => p1.toUpperCase());
};


/***/ }),

/***/ "../block-sdk/lib/enum.js":
/*!********************************!*\
  !*** ../block-sdk/lib/enum.js ***!
  \********************************/
/*! flagged exports */
/*! export AssetType [provided] [used] [could be renamed] */
/*! export DEPS_TYPE [provided] [unused] [could be renamed] */
/*! export PKG_ASSETS_META [provided] [unused] [could be renamed] */
/*! export ResourceType [provided] [used] [could be renamed] */
/*! export Type [provided] [unused] [could be renamed] */
/*! export UIAssetType [provided] [unused] [could be renamed] */
/*! export __esModule [provided] [unused] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__ */
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";
var __webpack_unused_export__;


__webpack_unused_export__ = ({
  value: true
});
__webpack_unused_export__ = exports.AssetType = __webpack_unused_export__ = __webpack_unused_export__ = __webpack_unused_export__ = exports.ResourceType = void 0;

function _react() {
  const data = _interopRequireDefault(__webpack_require__(/*! react */ "react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 资产类型：
 * 在 umi ui 中，类型有两个维度：
 * 1、资源类型 ResourceType ：从资产的来源来分类，目前有 dumi 资产、git 资产、...
 * 2、资产类型 AssetType：从资产中包括的类型，目前是有 component、block、template
 */
var ResourceType;
exports.ResourceType = ResourceType;

(function (ResourceType) {
  ResourceType["dumi"] = "dumi";
  ResourceType["git"] = "git";
})(ResourceType || (exports.ResourceType = ResourceType = {}));

const PKG_ASSETS_META = 'dumiAssets';
__webpack_unused_export__ = PKG_ASSETS_META;
var DEPS_TYPE;
__webpack_unused_export__ = DEPS_TYPE;

(function (DEPS_TYPE) {
  DEPS_TYPE["FILE"] = "FILE";
  DEPS_TYPE["NPM"] = "NPM";
})(DEPS_TYPE || (__webpack_unused_export__ = DEPS_TYPE = {}));

var UIAssetType;
__webpack_unused_export__ = UIAssetType;

(function (UIAssetType) {
  UIAssetType["component"] = "component";
  UIAssetType["block"] = "block";
  UIAssetType["template"] = "template";
})(UIAssetType || (__webpack_unused_export__ = UIAssetType = {}));

var AssetType;
exports.AssetType = AssetType;

(function (AssetType) {
  AssetType["COMPONENT"] = "component";
  AssetType["BLOCK"] = "block";
  AssetType["TEMPLATE"] = "template";
})(AssetType || (exports.AssetType = AssetType = {}));

var Type;
__webpack_unused_export__ = Type;

(function (Type) {
  Type["File"] = "FILE";
  Type["Npm"] = "NPM";
})(Type || (__webpack_unused_export__ = Type = {}));

/***/ }),

/***/ "./ui/locales/en-US.js":
/*!*****************************!*\
  !*** ./ui/locales/en-US.js ***!
  \*****************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
  'org.umi.ui.blocks.content.title': 'Assets',
  'org.umi.ui.blocks.content.search_block': 'Search Assets',
  'org.umi.ui.blocks.actions.clear': 'Clear blocks local cache',
  'org.umi.ui.blocks.actions.submit': 'Submit new block',
  'org.umi.ui.blocks.actions.reload': 'Reload list',
  'org.umi.ui.blocks.tabs.blocks': 'Blocks',
  'org.umi.ui.blocks.tabs.templates': 'Templates',
  'org.umi.ui.blocks.list.nodata': 'No Data',
  'org.umi.ui.blocks.list.nofound': 'No data found',
  'org.umi.ui.blocks.list.viewlog': 'Log',
  'org.umi.ui.blocks.list.add': 'Add',
  'org.umi.ui.blocks.list.preview.demo': 'Preview Demo',
  'org.umi.ui.blocks.tag.all': 'All',
  'org.umi.ui.blocks.tag.collapse': 'Collapse',
  'org.umi.ui.blocks.tag.expand': 'Expand',
  'org.umi.ui.blocks.adder.failed': 'Add failed, please retry!',
  'org.umi.ui.blocks.adder.title.template': 'Add Template',
  'org.umi.ui.blocks.adder.title.block': 'Add Block',
  'org.umi.ui.blocks.adder.stop': 'Stop',
  'org.umi.ui.blocks.adder.ok': 'OK',
  'org.umi.ui.blocks.adder.stop.title': 'Stop add',
  'org.umi.ui.blocks.adder.stop.content': 'Are you sure you want to stop adding the block?',
  'org.umi.ui.blocks.adder.stop.okText': 'Confirm',
  'org.umi.ui.blocks.adder.stop.cancelText': 'Cancle',
  'org.umi.ui.blocks.adder.js': 'Transform to JS',
  'org.umi.ui.blocks.adder.branch': 'Choosing a technology',
  'org.umi.ui.blocks.adder.uni18n': 'Remove i18n',
  'org.umi.ui.blocks.adder.npmClient': 'Package Manage Client',
  'org.umi.ui.blocks.adder.npmClient.required': 'Please select a package manage client',
  'org.umi.ui.blocks.adder.minirecommend': 'Open in mini ui for add, get a better experience.',
  'org.umi.ui.blocks.adder.path.label': 'Blocks will be installed to',
  'org.umi.ui.blocks.adder.path': 'Add to',
  'org.umi.ui.blocks.adder.path.tooltip':
    'Select route in config.js, umi will find the file with route path!',
  'org.umi.ui.blocks.adder.path.minitooltip': 'The path of current select page',
  'org.umi.ui.blocks.adder.path.rule': 'Route is required',
  'org.umi.ui.blocks.adder.name': 'Variable Name',
  'org.umi.ui.blocks.adder.name.tooltip':
    'The source code of the block will be placed in the [Add Path][Variable Name] location and will be added to the page as a variable name.',
  'org.umi.ui.blocks.adder.name.required': 'Variable name is required',
  'org.umi.ui.blocks.adder.name.placeholder': 'Please input name!',
  'org.umi.ui.blocks.adder.name.illegal': 'Variable name is illegal!',
  'org.umi.ui.blocks.adder.name.illegalReact': 'Variable name is a illegal React Component name!',
  'org.umi.ui.blocks.adder.pathexist': 'Target path already exist file!',
  'org.umi.ui.blocks.adder.varexist': 'Variable already exits in target page!',
  'org.umi.ui.blocks.adder.disabledTitle': 'Only one adding task can be performed at the same time',
  'org.umi.ui.blocks.adder.routePath': 'Route Path',
  'org.umi.ui.blocks.adder.routePath.placeholder':
    'The route path represents the path you access through the URL to this page, which is written to config.ts.',
  'org.umi.ui.blocks.adder.routePath.required': 'Route path is required',
  'org.umi.ui.blocks.adder.routePath.exist': 'Route path is already exist',
  'org.umi.ui.blocks.adder.templatePath': 'Add To',
  'org.umi.ui.blocks.adder.templatePath.tooltip':
    'Represents the file path of the block relative to src/pages, where the source code for the block will be placed.',
  'org.umi.ui.blocks.adder.templatePath.required': 'Add path is required',
  'org.umi.ui.blocks.adder.templatePath.root': 'Add folder cannot be the root directory!',
  'org.umi.ui.blocks.adder.templatePath.exist': 'The target file path already exists!',
  'org.umi.ui.blocks.adder.templatePath.uppercamelcase':
    'Page filename please use camelcase, for example FooBar',
  'org.umi.ui.blocks.adder.result.success': 'Add Success!',
  'org.umi.ui.blocks.adder.result.subTitle':
    'The code has been inserted into the page. The page will refresh automatically after compilation.',
  'org.umi.ui.blocks.adder.result.done': 'Done',
  'org.umi.ui.blocks.adder.result.preview': 'Preview',
});


/***/ }),

/***/ "./ui/locales/zh-CN.js":
/*!*****************************!*\
  !*** ./ui/locales/zh-CN.js ***!
  \*****************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
  'org.umi.ui.blocks.content.title': '资产',
  'org.umi.ui.blocks.content.search_block': '搜索资产',
  'org.umi.ui.blocks.actions.clear': '清除区块的本地缓存',
  'org.umi.ui.blocks.actions.submit': '提交新的区块',
  'org.umi.ui.blocks.actions.reload': '重新加载列表',
  'org.umi.ui.blocks.tabs.blocks': '区块',
  'org.umi.ui.blocks.tabs.templates': '模板',
  'org.umi.ui.blocks.list.nodata': '暂无数据',
  'org.umi.ui.blocks.list.nofound': '未搜索到任何数据',
  'org.umi.ui.blocks.list.viewlog': '查看日志',
  'org.umi.ui.blocks.list.add': '添加到项目',
  'org.umi.ui.blocks.list.preview.demo': '查看 demo 文档',
  'org.umi.ui.blocks.tag.all': '全部',
  'org.umi.ui.blocks.tag.collapse': '收起',
  'org.umi.ui.blocks.tag.expand': '展开',
  'org.umi.ui.blocks.adder.failed': '添加失败，请重试！',
  'org.umi.ui.blocks.adder.title.template': '添加 {name} 模板',
  'org.umi.ui.blocks.adder.title.block': '添加区块',
  'org.umi.ui.blocks.adder.stop': '停止',
  'org.umi.ui.blocks.adder.ok': '确认',
  'org.umi.ui.blocks.adder.stop.title': '停止安装',
  'org.umi.ui.blocks.adder.stop.content': '确定要停止安装区块吗？',
  'org.umi.ui.blocks.adder.stop.okText': '确认',
  'org.umi.ui.blocks.adder.stop.cancelText': '取消',
  'org.umi.ui.blocks.adder.js': '编译为 JS',
  'org.umi.ui.blocks.adder.branch': '选择依赖版本',
  'org.umi.ui.blocks.adder.uni18n': '移除国际化',
  'org.umi.ui.blocks.adder.npmClient': '包管理器',
  'org.umi.ui.blocks.adder.npmClient.required': '请选择包管理器',
  'org.umi.ui.blocks.adder.minirecommend': '在 mini ui 中添加，获取更好的使用体验。',
  'org.umi.ui.blocks.adder.path.label': '区块将被安装到',
  'org.umi.ui.blocks.adder.path': '添加到',
  'org.umi.ui.blocks.adder.path.tooltip':
    '此处选择的是 config.js 中的路由，他会根据路由来找到需要添加到的文件！',
  'org.umi.ui.blocks.adder.path.minitooltip': '当前选中页面的路径',
  'org.umi.ui.blocks.adder.path.rule': '添加路由为必填项！',
  'org.umi.ui.blocks.adder.name': '变量名',
  'org.umi.ui.blocks.adder.name.tooltip':
    '区块的源代码将会放在 [添加路径][变量名]的位置，并且将作为变量名加入页面中。',
  'org.umi.ui.blocks.adder.name.required': '变量名为必填项!',
  'org.umi.ui.blocks.adder.name.placeholder': '请输入变量名！',
  'org.umi.ui.blocks.adder.name.illegal': '变量名不合法!',
  'org.umi.ui.blocks.adder.name.illegalReact': '变量名不是一个合法的 React 组件名!',
  'org.umi.ui.blocks.adder.pathexist': '目标路径已存在文件!',
  'org.umi.ui.blocks.adder.varexist': '变量已存在于目标页面!',
  'org.umi.ui.blocks.adder.disabledTitle': '同一时间只能进行一个添加任务',
  'org.umi.ui.blocks.adder.routePath': '路由路径',
  'org.umi.ui.blocks.adder.routePath.placeholder':
    '路由路径代表你通过 url 访问到这个页面的路径，会写入 config.ts 中。',
  'org.umi.ui.blocks.adder.routePath.required': '路由必选',
  'org.umi.ui.blocks.adder.routePath.exist': '路由路径已存在',
  'org.umi.ui.blocks.adder.templatePath': '添加到',
  'org.umi.ui.blocks.adder.templatePath.tooltip':
    '表示相对于 src/pages 的文件路径，区块的源码将放在这个地方。',
  'org.umi.ui.blocks.adder.templatePath.required': '添加路径为必填项！',
  'org.umi.ui.blocks.adder.templatePath.root': '安装文件夹不能为根目录！',
  'org.umi.ui.blocks.adder.templatePath.exist': '安装文件路径已存在文件！',
  'org.umi.ui.blocks.adder.templatePath.uppercamelcase': '页面文件名请使用驼峰命名，例如 FooBar',
  'org.umi.ui.blocks.adder.result.success': '安装成功！',
  'org.umi.ui.blocks.adder.result.subTitle': '代码已插入页面。编译完成后页面将会自动刷新。',
  'org.umi.ui.blocks.adder.result.done': '完成',
  'org.umi.ui.blocks.adder.result.preview': '预览',
});


/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/helpers/esm/arrayWithHoles.js":
/*!*******************************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/helpers/esm/arrayWithHoles.js ***!
  \*******************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _arrayWithHoles
/* harmony export */ });
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js":
/*!*********************************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js ***!
  \*********************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _asyncToGenerator
/* harmony export */ });
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/helpers/esm/defineProperty.js":
/*!*******************************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/helpers/esm/defineProperty.js ***!
  \*******************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _defineProperty
/* harmony export */ });
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js":
/*!************************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js ***!
  \************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _extends
/* harmony export */ });
function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/helpers/esm/iterableToArrayLimit.js":
/*!*************************************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/helpers/esm/iterableToArrayLimit.js ***!
  \*************************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _iterableToArrayLimit
/* harmony export */ });
function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/helpers/esm/nonIterableRest.js":
/*!********************************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/helpers/esm/nonIterableRest.js ***!
  \********************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _nonIterableRest
/* harmony export */ });
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2.js":
/*!******************************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2.js ***!
  \******************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _objectSpread2
/* harmony export */ });
/* harmony import */ var _defineProperty__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./defineProperty */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/defineProperty.js");


function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        (0,_defineProperty__WEBPACK_IMPORTED_MODULE_0__.default)(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js":
/*!****************************************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js ***!
  \****************************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _objectWithoutProperties
/* harmony export */ });
/* harmony import */ var _objectWithoutPropertiesLoose__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./objectWithoutPropertiesLoose */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutPropertiesLoose.js");

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = (0,_objectWithoutPropertiesLoose__WEBPACK_IMPORTED_MODULE_0__.default)(source, excluded);
  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutPropertiesLoose.js":
/*!*********************************************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutPropertiesLoose.js ***!
  \*********************************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _objectWithoutPropertiesLoose
/* harmony export */ });
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js":
/*!******************************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js ***!
  \******************************************************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => /* binding */ _slicedToArray
/* harmony export */ });
/* harmony import */ var _arrayWithHoles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./arrayWithHoles */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/arrayWithHoles.js");
/* harmony import */ var _iterableToArrayLimit__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./iterableToArrayLimit */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/iterableToArrayLimit.js");
/* harmony import */ var _nonIterableRest__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./nonIterableRest */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/nonIterableRest.js");



function _slicedToArray(arr, i) {
  return (0,_arrayWithHoles__WEBPACK_IMPORTED_MODULE_0__.default)(arr) || (0,_iterableToArrayLimit__WEBPACK_IMPORTED_MODULE_1__.default)(arr, i) || (0,_nonIterableRest__WEBPACK_IMPORTED_MODULE_2__.default)();
}

/***/ }),

/***/ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js":
/*!**********************************************************************!*\
  !*** ../ui-builder/node_modules/@babel/runtime/regenerator/index.js ***!
  \**********************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__ */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(/*! regenerator-runtime */ "../../node_modules/regenerator-runtime/runtime.js");


/***/ }),

/***/ "../block-sdk/lib/data.d.ts":
/*!**********************************!*\
  !*** ../block-sdk/lib/data.d.ts ***!
  \**********************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [unused] */
/*! runtime requirements:  */
/***/ (() => {



/***/ }),

/***/ "./ui/Adder/AddBlockForm.tsx":
/*!***********************************!*\
  !*** ./ui/Adder/AddBlockForm.tsx ***!
  \***********************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");
/* harmony import */ var _InfoToolTip__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./InfoToolTip */ "./ui/Adder/InfoToolTip.tsx");
/* harmony import */ var _RouteFilesTreeData__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./RouteFilesTreeData */ "./ui/Adder/RouteFilesTreeData.tsx");
/* harmony import */ var _BlockList_BlockItem__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../BlockList/BlockItem */ "./ui/BlockList/BlockItem.tsx");



/**
 *  在 umi ui 中添加区块
 *  需要选择安装的具体文件位置
 */







var AddBlockForm = (_ref) => {
  var form = _ref.form,
      visible = _ref.visible;

  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_2__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_4__.default),
      api = _useContext.api;

  var useIntl = api.useIntl;

  var _useIntl = useIntl(),
      intl = _useIntl.formatMessage;

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement((react__WEBPACK_IMPORTED_MODULE_2___default().Fragment), null, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement("div", {
    style: {
      display: 'flex',
      marginBottom: 24
    }
  }, intl({
    id: 'org.umi.ui.blocks.adder.minirecommend'
  })), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(antd__WEBPACK_IMPORTED_MODULE_3__.Form.Item, {
    name: "path",
    label: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_InfoToolTip__WEBPACK_IMPORTED_MODULE_5__.default, {
      title: intl({
        id: 'org.umi.ui.blocks.adder.path'
      }),
      placeholder: intl({
        id: 'org.umi.ui.blocks.adder.path.tooltip'
      })
    }),
    rules: [{
      required: true,
      message: intl({
        id: 'org.umi.ui.blocks.adder.path.rule'
      })
    }]
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_RouteFilesTreeData__WEBPACK_IMPORTED_MODULE_6__.default, {
    visible: visible
  })), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(antd__WEBPACK_IMPORTED_MODULE_3__.Form.Item, {
    name: "name",
    label: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_InfoToolTip__WEBPACK_IMPORTED_MODULE_5__.default, {
      title: intl({
        id: 'org.umi.ui.blocks.adder.name'
      }),
      placeholder: intl({
        id: 'org.umi.ui.blocks.adder.name.tooltip'
      })
    }),
    rules: [{
      validator: function () {
        var _validator = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee(rule, name) {
          var filePath, _ref2, exists, blockFileTarget, _ref3, varExists;

          return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (name) {
                    _context.next = 2;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.name.required'
                  }));

                case 2:
                  if (/^[a-zA-Z$_][a-zA-Z\d_]*$/.test(name)) {
                    _context.next = 4;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.name.illegal'
                  }));

                case 4:
                  if (/^(?:[A-Z][a-z]+)+$/.test(name)) {
                    _context.next = 6;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.name.illegalReact'
                  }));

                case 6:
                  _context.next = 8;
                  return (0,_BlockList_BlockItem__WEBPACK_IMPORTED_MODULE_7__.getPathFromFilename)(api, form.getFieldValue('path'));

                case 8:
                  filePath = _context.sent;
                  _context.next = 11;
                  return api.callRemote({
                    type: 'org.umi.block.checkExistFilePath',
                    payload: {
                      path: "".concat(filePath, "/").concat(name)
                    }
                  });

                case 11:
                  _ref2 = _context.sent;
                  exists = _ref2.exists;

                  if (!exists) {
                    _context.next = 15;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.pathexist'
                  }));

                case 15:
                  blockFileTarget = form.getFieldValue('path');
                  _context.next = 18;
                  return api.callRemote({
                    type: 'org.umi.block.checkBindingInFile',
                    payload: {
                      path: blockFileTarget,
                      name
                    }
                  });

                case 18:
                  _ref3 = _context.sent;
                  varExists = _ref3.exists;

                  if (!varExists) {
                    _context.next = 22;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.varexist'
                  }));

                case 22:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function validator(_x, _x2) {
          return _validator.apply(this, arguments);
        }

        return validator;
      }()
    }]
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(antd__WEBPACK_IMPORTED_MODULE_3__.Input, {
    placeholder: intl({
      id: 'org.umi.ui.blocks.adder.name.placeholder'
    })
  })));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (AddBlockForm);

/***/ }),

/***/ "./ui/Adder/AddBlockFormForUI.tsx":
/*!****************************************!*\
  !*** ./ui/Adder/AddBlockFormForUI.tsx ***!
  \****************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");
/* harmony import */ var _InfoToolTip__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./InfoToolTip */ "./ui/Adder/InfoToolTip.tsx");




/**
 *  在 umi ui 中添加区块
 *  不需要选择安装的具体文件位置
 *  min ui 提供了可视化的方案来选择
 */





var PathLabel = (_ref) => {
  var value = _ref.value,
      name = _ref.name,
      intl = _ref.intl;
  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement("div", {
    style: {
      display: 'flex',
      marginBottom: 24
    }
  }, intl({
    id: 'org.umi.ui.blocks.adder.path.label'
  }), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement("code", {
    style: {
      backgroundColor: '#3b3b4d',
      margin: '0 8px',
      padding: '0 8px',
      borderRadius: 4
    }
  }, "".concat(value).concat(name ? "/".concat(name) : '').replace(/\//g, '/').replace(/\/\//g, '/')));
};

var AddBlockFormForUI = (_ref2) => {
  var blockTarget = _ref2.blockTarget,
      form = _ref2.form;

  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_3__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_5__.default),
      api = _useContext.api;

  var useIntl = api.useIntl;

  var _useIntl = useIntl(),
      intl = _useIntl.formatMessage;

  var _useState = (0,react__WEBPACK_IMPORTED_MODULE_3__.useState)(form.getFieldValue('name')),
      _useState2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_2__.default)(_useState, 2),
      varName = _useState2[0],
      setValueName = _useState2[1];

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement((react__WEBPACK_IMPORTED_MODULE_3___default().Fragment), null, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(antd__WEBPACK_IMPORTED_MODULE_4__.Form.Item, {
    noStyle: true,
    name: "path",
    label: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_InfoToolTip__WEBPACK_IMPORTED_MODULE_6__.default, {
      title: intl({
        id: 'org.umi.ui.blocks.adder.path'
      }),
      placeholder: intl({
        id: 'org.umi.ui.blocks.adder.path.minitooltip'
      })
    }),
    rules: [{
      required: true,
      message: intl({
        id: 'org.umi.ui.blocks.adder.path.rule'
      })
    }]
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(PathLabel, {
    name: varName,
    intl: intl
  })), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(antd__WEBPACK_IMPORTED_MODULE_4__.Form.Item, {
    name: "name",
    label: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_InfoToolTip__WEBPACK_IMPORTED_MODULE_6__.default, {
      title: intl({
        id: 'org.umi.ui.blocks.adder.name'
      }),
      placeholder: intl({
        id: 'org.umi.ui.blocks.adder.name.tooltip'
      })
    }),
    rules: [{
      validator: function () {
        var _validator = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee(rule, name) {
          var _ref3, exists, blockFileTarget, _ref4, varExists;

          return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (name) {
                    _context.next = 2;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.name.required'
                  }));

                case 2:
                  if (/^[a-zA-Z$_][a-zA-Z\d_]*$/.test(name)) {
                    _context.next = 4;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.name.illegal'
                  }));

                case 4:
                  if (/^(?:[A-Z][a-z\d]+)+$/.test(name)) {
                    _context.next = 6;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.name.illegalReact'
                  }));

                case 6:
                  _context.next = 8;
                  return api.callRemote({
                    type: 'org.umi.block.checkExistFilePath',
                    payload: {
                      path: "".concat(blockTarget, "/").concat(name)
                    }
                  });

                case 8:
                  _ref3 = _context.sent;
                  exists = _ref3.exists;

                  if (!exists) {
                    _context.next = 12;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.pathexist'
                  }));

                case 12:
                  blockFileTarget = form.getFieldValue('path');
                  _context.next = 15;
                  return api.callRemote({
                    type: 'org.umi.block.checkBindingInFile',
                    payload: {
                      path: blockFileTarget,
                      name
                    }
                  });

                case 15:
                  _ref4 = _context.sent;
                  varExists = _ref4.exists;

                  if (!varExists) {
                    _context.next = 19;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.varexist'
                  }));

                case 19:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function validator(_x, _x2) {
          return _validator.apply(this, arguments);
        }

        return validator;
      }()
    }]
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(antd__WEBPACK_IMPORTED_MODULE_4__.Input, {
    placeholder: intl({
      id: 'org.umi.ui.blocks.adder.name.placeholder'
    }),
    onChange: e => {
      setValueName(e.target.value);
    }
  })));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (AddBlockFormForUI);

/***/ }),

/***/ "./ui/Adder/AddTemplateForm.tsx":
/*!**************************************!*\
  !*** ./ui/Adder/AddTemplateForm.tsx ***!
  \**************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var uppercamelcase__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! uppercamelcase */ "../../node_modules/uppercamelcase/index.js");
/* harmony import */ var uppercamelcase__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(uppercamelcase__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");
/* harmony import */ var _RoutePathTree__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./RoutePathTree */ "./ui/Adder/RoutePathTree.tsx");
/* harmony import */ var _PageFoldersTreeData__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./PageFoldersTreeData */ "./ui/Adder/PageFoldersTreeData.tsx");
/* harmony import */ var _InfoToolTip__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./InfoToolTip */ "./ui/Adder/InfoToolTip.tsx");




/**
 * 添加模板的表单，选择路径和文件夹
 */








var AddBlockForm = (_ref) => {
  var visible = _ref.visible;

  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_3__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_6__.default),
      api = _useContext.api;

  var useIntl = api.useIntl;

  var _useIntl = useIntl(),
      intl = _useIntl.formatMessage;

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement((react__WEBPACK_IMPORTED_MODULE_3___default().Fragment), null, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(antd__WEBPACK_IMPORTED_MODULE_4__.Form.Item, {
    name: "routePath",
    label: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_InfoToolTip__WEBPACK_IMPORTED_MODULE_9__.default, {
      title: intl({
        id: 'org.umi.ui.blocks.adder.routePath'
      }),
      placeholder: intl({
        id: 'org.umi.ui.blocks.adder.routePath.placeholder'
      })
    }),
    rules: [{
      required: true,
      message: intl({
        id: 'org.umi.ui.blocks.adder.routePath.required'
      })
    }, {
      validator: function () {
        var _validator = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default().mark(function _callee(rule, value) {
          var _ref2, exists;

          return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default().wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!(value === '/')) {
                    _context.next = 2;
                    break;
                  }

                  return _context.abrupt("return");

                case 2:
                  _context.next = 4;
                  return api.callRemote({
                    type: 'org.umi.block.checkExistRoute',
                    payload: {
                      path: value.toLowerCase()
                    }
                  });

                case 4:
                  _ref2 = _context.sent;
                  exists = _ref2.exists;

                  if (!exists) {
                    _context.next = 8;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.routePath.exist'
                  }));

                case 8:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function validator(_x, _x2) {
          return _validator.apply(this, arguments);
        }

        return validator;
      }()
    }]
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_RoutePathTree__WEBPACK_IMPORTED_MODULE_7__.default, {
    visible: visible
  })), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(antd__WEBPACK_IMPORTED_MODULE_4__.Form.Item, {
    name: "path",
    label: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_InfoToolTip__WEBPACK_IMPORTED_MODULE_9__.default, {
      title: intl({
        id: 'org.umi.ui.blocks.adder.templatePath'
      }),
      placeholder: intl({
        id: 'org.umi.ui.blocks.adder.templatePath.tooltip'
      })
    }),
    rules: [{
      required: true,
      message: intl({
        id: 'org.umi.ui.blocks.adder.templatePath.required'
      })
    }, {
      validator: function () {
        var _validator2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default().mark(function _callee2(rule, filePath) {
          var _filePath$split;

          var _filePath$split$slice, _filePath$split$slice2, _filePath$split$slice3, pageName, _ref3, exists;

          return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default().wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  if (!(filePath === '/')) {
                    _context2.next = 2;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.templatePath.root'
                  }));

                case 2:
                  _filePath$split$slice = filePath === null || filePath === void 0 ? void 0 : (_filePath$split = filePath.split('/')) === null || _filePath$split === void 0 ? void 0 : _filePath$split.slice(-1), _filePath$split$slice2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__.default)(_filePath$split$slice, 1), _filePath$split$slice3 = _filePath$split$slice2[0], pageName = _filePath$split$slice3 === void 0 ? '' : _filePath$split$slice3;

                  if (!(pageName !== uppercamelcase__WEBPACK_IMPORTED_MODULE_5___default()(pageName))) {
                    _context2.next = 5;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.templatePath.uppercamelcase'
                  }));

                case 5:
                  _context2.next = 7;
                  return api.callRemote({
                    type: 'org.umi.block.checkExistFilePath',
                    payload: {
                      path: filePath
                    }
                  });

                case 7:
                  _ref3 = _context2.sent;
                  exists = _ref3.exists;

                  if (!exists) {
                    _context2.next = 11;
                    break;
                  }

                  throw new Error(intl({
                    id: 'org.umi.ui.blocks.adder.templatePath.exist'
                  }));

                case 11:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        function validator(_x3, _x4) {
          return _validator2.apply(this, arguments);
        }

        return validator;
      }()
    }]
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_3___default().createElement(_PageFoldersTreeData__WEBPACK_IMPORTED_MODULE_8__.default, {
    visible: visible
  })));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (AddBlockForm);

/***/ }),

/***/ "./ui/Adder/InfoToolTip.tsx":
/*!**********************************!*\
  !*** ./ui/Adder/InfoToolTip.tsx ***!
  \**********************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/icons/QuestionCircleOutlined.js");




var InfoToolTip = (_ref) => {
  var title = _ref.title,
      placeholder = _ref.placeholder;
  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement(antd__WEBPACK_IMPORTED_MODULE_1__.Tooltip, {
    title: placeholder
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
    style: {
      display: "flex",
      alignItems: "center"
    }
  }, title, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_2__.default, {
    style: {
      marginLeft: 8
    }
  })));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (InfoToolTip);

/***/ }),

/***/ "./ui/Adder/PageFoldersTreeData.tsx":
/*!******************************************!*\
  !*** ./ui/Adder/PageFoldersTreeData.tsx ***!
  \******************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/extends */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _CustomTreeSelect__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../CustomTreeSelect */ "./ui/CustomTreeSelect/index.tsx");
/* harmony import */ var _hooks_useCallData__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../hooks/useCallData */ "./ui/hooks/useCallData.ts");
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");









var RoutePathTree = props => {
  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_4__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_7__.default),
      api = _useContext.api;

  var visible = props.visible,
      restProps = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_3__.default)(props, ["visible"]);
  /**
   * 这两个在 visible 的时候回重新加载一下
   */


  var _useCallData = (0,_hooks_useCallData__WEBPACK_IMPORTED_MODULE_6__.default)( /*#__PURE__*/(0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default().mark(function _callee() {
    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!visible) {
              _context.next = 2;
              break;
            }

            return _context.abrupt("return", api.callRemote({
              type: "org.umi.block.pageFolders"
            }));

          case 2:
            return _context.abrupt("return", pageFoldersTreeData);

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })), [visible], {
    defaultData: []
  }),
      pageFoldersTreeData = _useCallData.data;

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_CustomTreeSelect__WEBPACK_IMPORTED_MODULE_5__.default, (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
    treeData: pageFoldersTreeData
  }, restProps));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (RoutePathTree);

/***/ }),

/***/ "./ui/Adder/ResultPanel.tsx":
/*!**********************************!*\
  !*** ./ui/Adder/ResultPanel.tsx ***!
  \**********************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");
/* harmony import */ var _ResultPanel_module_less_modules__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./ResultPanel.module.less?modules */ "./ui/Adder/ResultPanel.module.less?modules");
/* harmony import */ var _ResultPanel_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_ResultPanel_module_less_modules__WEBPACK_IMPORTED_MODULE_3__);




/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((_ref) => {
  var name = _ref.name,
      onFinish = _ref.onFinish;

  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_0__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_2__.default),
      api = _useContext.api;

  var useIntl = api.useIntl;

  var _useIntl = useIntl(),
      intl = _useIntl.formatMessage; // const [alive, setAlive] = useState<boolean>(false);
  // const isMini = api.isMini();
  // useEffect(() => {
  //   (async () => {
  //     const msg = (await api.callRemote({
  //       type: 'tasks/is_dev_server_alive',
  //     })) as {
  //       alive: boolean;
  //     };
  //     setAlive(msg.alive);
  //   })();
  // }, []);


  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
    className: (_ResultPanel_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().result)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement(antd__WEBPACK_IMPORTED_MODULE_1__.Result, {
    status: "success",
    title: "".concat(name, " ").concat(intl({
      id: 'org.umi.ui.blocks.adder.result.success'
    })),
    subTitle: intl({
      id: 'org.umi.ui.blocks.adder.result.subTitle'
    }),
    extra: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement(antd__WEBPACK_IMPORTED_MODULE_1__.Button, {
      type: "primary",
      key: "preview",
      onClick: () => onFinish()
    }, intl({
      id: 'org.umi.ui.blocks.adder.result.done'
    })) // isMini || !alive
    //   ? [
    //       <Button type="primary" key="preview" onClick={() => onFinish()}>
    //         {intl({ id: 'org.umi.ui.blocks.adder.result.done' })}
    //       </Button>,
    //     ]
    //   : [
    //       <Button
    //         type="primary"
    //         key="preview"
    //         onClick={() => {
    //           window.open(url);
    //           onFinish();
    //         }}
    //       >
    //         {intl({ id: 'org.umi.ui.blocks.adder.result.preview' })}
    //       </Button>,
    //     ]

  }));
});

/***/ }),

/***/ "./ui/Adder/RouteFilesTreeData.tsx":
/*!*****************************************!*\
  !*** ./ui/Adder/RouteFilesTreeData.tsx ***!
  \*****************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/extends */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _CustomTreeSelect__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../CustomTreeSelect */ "./ui/CustomTreeSelect/index.tsx");
/* harmony import */ var _hooks_useCallData__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../hooks/useCallData */ "./ui/hooks/useCallData.ts");
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");









var RoutePathTree = props => {
  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_4__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_7__.default),
      api = _useContext.api;

  var visible = props.visible,
      resetProps = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_3__.default)(props, ["visible"]);
  /**
   * 这两个在 visible 的时候回重新加载一下
   */


  var _useCallData = (0,_hooks_useCallData__WEBPACK_IMPORTED_MODULE_6__.default)( /*#__PURE__*/(0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default().mark(function _callee() {
    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!visible) {
              _context.next = 2;
              break;
            }

            return _context.abrupt("return", api.callRemote({
              type: "org.umi.block.routeFiles"
            }));

          case 2:
            return _context.abrupt("return", pageFoldersTreeData);

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })), [visible], {
    defaultData: []
  }),
      pageFoldersTreeData = _useCallData.data;

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_CustomTreeSelect__WEBPACK_IMPORTED_MODULE_5__.default // index.js -> index
  , (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
    onlySelectLeaf: true,
    treeData: pageFoldersTreeData
  }, resetProps));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (RoutePathTree);

/***/ }),

/***/ "./ui/Adder/RoutePathTree.tsx":
/*!************************************!*\
  !*** ./ui/Adder/RoutePathTree.tsx ***!
  \************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/extends */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _CustomTreeSelect__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../CustomTreeSelect */ "./ui/CustomTreeSelect/index.tsx");
/* harmony import */ var _hooks_useCallData__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../hooks/useCallData */ "./ui/hooks/useCallData.ts");
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");









var RoutePathTree = props => {
  var visible = props.visible,
      resetProps = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_3__.default)(props, ["visible"]);

  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_4__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_7__.default),
      api = _useContext.api;
  /**
   * 这两个在 visible 的时候回重新加载一下
   */


  var _useCallData = (0,_hooks_useCallData__WEBPACK_IMPORTED_MODULE_6__.default)( /*#__PURE__*/(0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default().mark(function _callee() {
    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_1___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!visible) {
              _context.next = 2;
              break;
            }

            return _context.abrupt("return", api.callRemote({
              type: "org.umi.block.routes"
            }));

          case 2:
            return _context.abrupt("return", routePathTreeData);

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })), [visible], {
    defaultData: []
  }),
      routePathTreeData = _useCallData.data;

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_CustomTreeSelect__WEBPACK_IMPORTED_MODULE_5__.default, (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
    treeData: routePathTreeData
  }, resetProps));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (RoutePathTree);

/***/ }),

/***/ "./ui/Adder/index.tsx":
/*!****************************!*\
  !*** ./ui/Adder/index.tsx ***!
  \****************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2 */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var uppercamelcase__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! uppercamelcase */ "../../node_modules/uppercamelcase/index.js");
/* harmony import */ var uppercamelcase__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(uppercamelcase__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @radjs/block-sdk/lib/enum */ "../block-sdk/lib/enum.js");
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");
/* harmony import */ var _hooks_useCallData__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ../hooks/useCallData */ "./ui/hooks/useCallData.ts");
/* harmony import */ var _LogPanel__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ../LogPanel */ "./ui/LogPanel/index.tsx");
/* harmony import */ var _ResultPanel__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./ResultPanel */ "./ui/Adder/ResultPanel.tsx");
/* harmony import */ var _AddTemplateForm__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./AddTemplateForm */ "./ui/Adder/AddTemplateForm.tsx");
/* harmony import */ var _AddBlockFormForUI__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./AddBlockFormForUI */ "./ui/Adder/AddBlockFormForUI.tsx");
/* harmony import */ var _AddBlockForm__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./AddBlockForm */ "./ui/Adder/AddBlockForm.tsx");
/* harmony import */ var _components_BlockContext__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ../components/BlockContext */ "./ui/components/BlockContext.tsx");
/* harmony import */ var _BlockList_BlockItem__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ../BlockList/BlockItem */ "./ui/BlockList/BlockItem.tsx");
/* harmony import */ var _util__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ../util */ "./ui/util.ts");



















/**
 * 安装区块
 * @param api
 * @param params
 */
var addBlock = /*#__PURE__*/function () {
  var _ref = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee(api, params) {
    var _ref2, _ref2$data, info;

    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return api.callRemote({
              type: 'org.umi.block.add',
              payload: params
            });

          case 2:
            _ref2 = _context.sent;
            _ref2$data = _ref2.data;
            info = _ref2$data === void 0 ? {
              message: ''
            } : _ref2$data;
            return _context.abrupt("return", info.message);

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function addBlock(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var cancelAddBlockTask = api => api.callRemote({
  type: 'org.umi.block.cancel'
});

var Adder = props => {
  var visible = props.visible,
      blockTarget = props.blockTarget,
      onAddBlockChange = props.onAddBlockChange,
      onHideModal = props.onHideModal,
      index = props.index,
      _props$block = props.block,
      block = _props$block === void 0 ? {
    url: ''
  } : _props$block,
      blockType = props.blockType;

  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_4__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_8__.default),
      api = _useContext.api;

  var _useContext2 = (0,react__WEBPACK_IMPORTED_MODULE_4__.useContext)(_components_BlockContext__WEBPACK_IMPORTED_MODULE_15__.default),
      currentResource = _useContext2.currentResource;

  var callRemote = api.callRemote,
      useIntl = api.useIntl,
      _analyze = api._analyze;

  var _useIntl = useIntl(),
      intl = _useIntl.formatMessage;

  var gtag = _analyze.gtag;

  var _useState = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(false),
      _useState2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState, 2),
      taskLoading = _useState2[0],
      setTaskLoading = _useState2[1]; // 防止重复提交


  var _useState3 = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(false),
      _useState4 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState3, 2),
      fromCheck = _useState4[0],
      setFromCheck = _useState4[1];

  var _Form$useForm = antd__WEBPACK_IMPORTED_MODULE_5__.Form.useForm(),
      _Form$useForm2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_Form$useForm, 1),
      form = _Form$useForm2[0]; // 展示哪个界面
  // log 日志  form 表单


  var _useState5 = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)('form'),
      _useState6 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState5, 2),
      addStatus = _useState6[0],
      setAddStatus = _useState6[1]; // 预览界面需要消费的日志


  var _useState7 = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(undefined),
      _useState8 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState7, 2),
      succeededBlock = _useState8[0],
      setSucceededBlock = _useState8[1];

  var _useCallData = (0,_hooks_useCallData__WEBPACK_IMPORTED_MODULE_9__.default)(() => callRemote({
    type: '@@project/getNpmClients'
  }), [], {
    defaultData: ['npm']
  }),
      _useCallData$data = _useCallData.data,
      npmClients = _useCallData$data === void 0 ? [] : _useCallData$data;

  (0,react__WEBPACK_IMPORTED_MODULE_4__.useEffect)(() => {
    if (api.detectNpmClients) {
      api.detectNpmClients().then(clients => {
        form.setFieldsValue({
          npmClient: clients.find(c => npmClients.includes(c))
        });
      });
    }
  }, [npmClients]);
  (0,react__WEBPACK_IMPORTED_MODULE_4__.useEffect)(() => {
    /**
     * 成功之后清理状态
     */
    api.listenRemote({
      type: 'org.umi.block.add-blocks-success',
      onMessage: msg => {
        setTaskLoading(false);
        onAddBlockChange(undefined); // 如果标签页不激活，不处理它

        if (document.visibilityState !== 'hidden') {
          // 设置预览界面
          setAddStatus('result');
          setSucceededBlock(msg.data);
        } else {
          setAddStatus('form');
        }

        gtag('event', 'add-blocks-success', {
          event_category: 'block',
          event_label: msg.data && msg.data.path ? msg.data.path : ''
        });
      }
    });
    /**
     * 失败之后清理状态
     * 应该保留日志，所以进行页面的切换
     */

    api.listenRemote({
      type: 'org.umi.block.add-blocks-fail',
      onMessage: msg => {
        setTaskLoading(false);
        onAddBlockChange(undefined); // 如果标签页不激活，不处理它

        if (document.visibilityState !== 'hidden') {
          antd__WEBPACK_IMPORTED_MODULE_5__.message.error(intl({
            id: 'org.umi.ui.blocks.adder.failed'
          }));
        }

        gtag('event', 'add-blocks-fail', {
          event_category: 'block',
          event_label: msg.data && msg.data.path ? msg.data.path : ''
        });
      }
    });
    /**
     * 获取上次的安装的区块 url
     */

    callRemote({
      type: 'org.umi.block.get-adding-block-url'
    }).then((_ref3) => {
      var data = _ref3.data;

      if (data) {
        // 如果有安装未完成的区块，设置显示页面为log
        // 并打开loading
        setAddStatus('log');
        setTaskLoading(true);
      }
    }); // detect language

    if (api.detectLanguage) {
      api.detectLanguage().then(language => {
        form.setFieldsValue({
          js: language === 'JavaScript'
        });
      });
    }
  }, []);
  (0,react__WEBPACK_IMPORTED_MODULE_4__.useEffect)(() => {
    var _block$url, _block$url$split;

    if (!block) {
      return;
    } // 生成 defaultName


    var gitBlockUrlName = ((block === null || block === void 0 ? void 0 : block.url) ? block === null || block === void 0 ? void 0 : (_block$url = block.url) === null || _block$url === void 0 ? void 0 : (_block$url$split = _block$url.split('/')) === null || _block$url$split === void 0 ? void 0 : _block$url$split.pop() : block === null || block === void 0 ? void 0 : block.key) || ''; // 默认使用 Demo

    var defaultName = ((currentResource === null || currentResource === void 0 ? void 0 : currentResource.resourceType) === _radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_7__.ResourceType.dumi ? block === null || block === void 0 ? void 0 : block.identifier : gitBlockUrlName) || 'Demo';
    var initPath = blockType !== 'template' ? '/' : "/".concat(defaultName);

    var resetInitialValues = /*#__PURE__*/function () {
      var _ref4 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee2() {
        var noExitVar, initialValues;
        return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return (0,_util__WEBPACK_IMPORTED_MODULE_17__.getNoExitVar)({
                  name: uppercamelcase__WEBPACK_IMPORTED_MODULE_6___default()(defaultName),
                  path: blockTarget || initPath,
                  api,
                  need: !!blockTarget
                });

              case 2:
                noExitVar = _context2.sent;
                _context2.next = 5;
                return (0,_util__WEBPACK_IMPORTED_MODULE_17__.getNoExitPath)({
                  path: blockTarget || initPath,
                  api,
                  need: blockType === 'template'
                });

              case 5:
                _context2.t0 = _context2.sent;
                _context2.next = 8;
                return (0,_util__WEBPACK_IMPORTED_MODULE_17__.getNoExitRoute)({
                  path: "/".concat(defaultName.toLocaleLowerCase()),
                  api,
                  need: blockType === 'template'
                });

              case 8:
                _context2.t1 = _context2.sent;
                _context2.t2 = noExitVar;
                initialValues = {
                  path: _context2.t0,
                  routePath: _context2.t1,
                  name: _context2.t2
                };
                form.setFieldsValue(initialValues);

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function resetInitialValues() {
        return _ref4.apply(this, arguments);
      };
    }();

    resetInitialValues();
  }, [block, blockTarget || '']);
  (0,react__WEBPACK_IMPORTED_MODULE_4__.useEffect)(() => {
    if (index !== null && index !== undefined) {
      form.setFieldsValue({
        index
      });
    }
  }, [index]);

  if (!block) {
    return null;
  }

  if ((currentResource === null || currentResource === void 0 ? void 0 : currentResource.resourceType) === _radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_7__.ResourceType.dumi) {
    // dumi 资产类型
    if (!block.dependencies) {
      return null;
    } // git 资产类型

  } else if (!block.url) {
    return null;
  }
  /**
   * 计算初始值
   */


  var initialValues = {
    js: false,
    uni18n: localStorage.getItem('umi-ui-block-removeLocale') === 'true',
    npmClient: 'npm'
  };

  var renderOkText = (status, loading) => {
    if (status === 'log' && !loading) {
      return intl({
        id: 'org.umi.ui.blocks.adder.stop'
      });
    }

    if (status === 'log') {
      return intl({
        id: 'org.umi.ui.blocks.adder.stop'
      });
    }

    return intl({
      id: 'org.umi.ui.blocks.adder.ok'
    });
  };

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Modal, {
    title: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("div", {
      style: {
        display: 'flex'
      }
    }, intl({
      id: "org.umi.ui.blocks.adder.title.".concat(blockType)
    }, {
      name: block.name
    })),
    closable: true,
    visible: visible,
    destroyOnClose: true,
    onCancel: () => {
      onHideModal();

      if (!taskLoading) {
        setAddStatus('form');
      }
    },
    footer: addStatus === 'result' ? null : undefined,
    confirmLoading: fromCheck,
    bodyStyle: {
      height: '60vh',
      overflow: 'auto',
      transition: '.3s'
    },
    centered: true,
    okText: renderOkText(addStatus, taskLoading),
    onOk: () => {
      if (addStatus === 'log' && !taskLoading) {
        onHideModal();
        setAddStatus('form');
        setSucceededBlock(undefined);
        return;
      }

      if (addStatus === 'log') {
        antd__WEBPACK_IMPORTED_MODULE_5__.Modal.confirm({
          title: intl({
            id: 'org.umi.ui.blocks.adder.stop.title'
          }),
          content: intl({
            id: 'org.umi.ui.blocks.adder.stop.content'
          }),
          okType: 'danger',
          okText: intl({
            id: 'org.umi.ui.blocks.adder.stop.okText'
          }),
          cancelText: intl({
            id: 'org.umi.ui.blocks.adder.stop.cancelText'
          }),
          onOk: function () {
            var _onOk = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee3() {
              return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee3$(_context3) {
                while (1) {
                  switch (_context3.prev = _context3.next) {
                    case 0:
                      _context3.next = 2;
                      return cancelAddBlockTask(api);

                    case 2:
                      setTaskLoading(false);
                      onAddBlockChange(undefined);

                    case 4:
                    case "end":
                      return _context3.stop();
                  }
                }
              }, _callee3);
            }));

            function onOk() {
              return _onOk.apply(this, arguments);
            }

            return onOk;
          }()
        });
        return;
      } // loading 状态更新


      setTaskLoading(true);
      setFromCheck(true);
      form.validateFields().then( /*#__PURE__*/function () {
        var _ref5 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee4(values) {
          var params;
          return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  setAddStatus('log');
                  _context4.prev = 1;
                  _context4.t0 = F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_0__.default;
                  _context4.t1 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_0__.default)((0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_0__.default)({}, values), block);
                  _context4.t2 = {};
                  _context4.t3 = block.name;
                  _context4.t4 = currentResource === null || currentResource === void 0 ? void 0 : currentResource.resourceType;
                  _context4.next = 9;
                  return (0,_BlockList_BlockItem__WEBPACK_IMPORTED_MODULE_16__.getPathFromFilename)(api, values.path);

                case 9:
                  _context4.t5 = _context4.sent;
                  _context4.t6 = blockType === 'template' ? values.routePath : undefined;
                  _context4.t7 = blockType === 'template';
                  _context4.t8 = blockType;
                  _context4.t9 = values.index && values.index.startsWith('l-') ? values.index : parseInt(values.index || '0', 10);
                  _context4.t10 = blockType === 'template' ? block.name : values.name;
                  _context4.t11 = {
                    blockName: _context4.t3,
                    resourceType: _context4.t4,
                    path: _context4.t5,
                    routePath: _context4.t6,
                    page: _context4.t7,
                    blockType: _context4.t8,
                    index: _context4.t9,
                    name: _context4.t10
                  };
                  params = (0, _context4.t0)(_context4.t1, _context4.t2, _context4.t11);
                  addBlock(api, params);
                  localStorage.setItem('umi-ui-block-removeLocale', values.uni18n);
                  onAddBlockChange(block);
                  gtag('event', 'install-block', {
                    event_category: 'block',
                    event_label: params && params.path ? params.path : ''
                  });
                  _context4.next = 26;
                  break;

                case 23:
                  _context4.prev = 23;
                  _context4.t12 = _context4["catch"](1);
                  antd__WEBPACK_IMPORTED_MODULE_5__.message.error(_context4.t12.message);

                case 26:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, null, [[1, 23]]);
        }));

        return function (_x3) {
          return _ref5.apply(this, arguments);
        };
      }()).catch(() => setTaskLoading(false)).finally(() => setFromCheck(false));
    }
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Form, {
    hideRequiredMark: true,
    initialValues: initialValues,
    layout: "vertical",
    form: form,
    style: {
      display: addStatus !== 'form' && 'none'
    }
  }, blockType === 'template' && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_AddTemplateForm__WEBPACK_IMPORTED_MODULE_12__.default, {
    visible: visible,
    blockType: blockType
  }), blockType === 'block' && !api.isMini() && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_AddBlockForm__WEBPACK_IMPORTED_MODULE_14__.default, {
    form: form,
    visible: visible
  }), blockType === 'block' && api.isMini() && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_AddBlockFormForUI__WEBPACK_IMPORTED_MODULE_13__.default, {
    form: form,
    blockTarget: blockTarget
  }), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Form.Item, {
    name: "js",
    label: intl({
      id: 'org.umi.ui.blocks.adder.js'
    }),
    valuePropName: "checked"
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Switch, {
    size: "small"
  })), blockType === 'template' && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Form.Item, {
    name: "uni18n",
    label: intl({
      id: 'org.umi.ui.blocks.adder.uni18n'
    }),
    valuePropName: "checked"
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Switch, {
    size: "small"
  })), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Form.Item, {
    name: "npmClient",
    label: intl({
      id: 'org.umi.ui.blocks.adder.npmClient'
    }),
    rules: [{
      required: true,
      message: intl({
        id: 'org.umi.ui.blocks.adder.npmClient.required'
      })
    }]
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Select, null, npmClients.map(client => /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Select.Option, {
    key: client,
    value: client
  }, client)))), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Form.Item, {
    name: "index"
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("input", {
    type: "hidden"
  }))), addStatus === 'log' && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_LogPanel__WEBPACK_IMPORTED_MODULE_10__.default, {
    loading: taskLoading
  }), addStatus === 'result' && succeededBlock && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_ResultPanel__WEBPACK_IMPORTED_MODULE_11__.default, {
    onFinish: () => {
      onHideModal();
      setAddStatus('form');
      setSucceededBlock(undefined);
      api.hideMini();
    },
    name: succeededBlock.name || block.name,
    url: succeededBlock.previewUrl
  }));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Adder);

/***/ }),

/***/ "./ui/AssetsMenu/index.tsx":
/*!*********************************!*\
  !*** ./ui/AssetsMenu/index.tsx ***!
  \*********************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/icons/UpOutlined.js");
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/icons/DownOutlined.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! classnames */ "../../node_modules/classnames/index.js");
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _index_module_less_modules__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./index.module.less?modules */ "./ui/AssetsMenu/index.module.less?modules");
/* harmony import */ var _index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");






/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (props => {
  var type = props.type,
      matchedResources = props.matchedResources,
      current = props.current,
      setActiveResource = props.setActiveResource,
      updateUrlQuery = props.updateUrlQuery,
      blocks = props.blocks,
      selectedTag = props.selectedTag,
      setSelectedTag = props.setSelectedTag,
      loading = props.loading;

  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_0__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_4__.default),
      api = _useContext.api;

  var _api$_ = api._,
      uniq = _api$_.uniq,
      flatten = _api$_.flatten;
  var tags = (0,react__WEBPACK_IMPORTED_MODULE_0__.useMemo)(() => uniq(flatten(blocks.map(item => (item === null || item === void 0 ? void 0 : item.category) ? [item === null || item === void 0 ? void 0 : item.category] : item === null || item === void 0 ? void 0 : item.tags))).filter(Boolean), [blocks]);

  function renderCats() {
    if (loading) {
      return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
        className: "".concat((_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().cats), " ").concat(loading ? (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().catsLoading) : '')
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Spin, {
        size: "large"
      }));
    }

    var getTagCls = selected => classnames__WEBPACK_IMPORTED_MODULE_1___default()((_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().cat), {
      [(_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().current)]: selectedTag === selected
    });

    return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
      className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().cats)
    }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
      key: "\u5168\u90E8",
      className: getTagCls(''),
      onClick: () => setSelectedTag('')
    }, "\u5168\u90E8"), tags // .sort(sortTag)
    .filter(tag => tag !== '废弃').map(tag => /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
      key: tag,
      className: getTagCls(tag),
      onClick: () => setSelectedTag(tag)
    }, tag)));
  }

  function renderResources() {
    function resourceSwitchHandler(r) {
      if (r.id === current.id) {
        setActiveResource({
          id: null
        });
        return;
      }

      setActiveResource(r);
      updateUrlQuery({
        type,
        resource: r.id
      });
    }

    return matchedResources.map(r => {
      var isCurrent = current.id === r.id;
      var resourceCls = classnames__WEBPACK_IMPORTED_MODULE_1___default()((_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().resource), {
        [(_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().current)]: !!isCurrent
      });
      return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), {
        key: r.id
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
        className: resourceCls,
        onClick: resourceSwitchHandler.bind(null, r)
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
        className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().icon)
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("img", {
        src: r.icon,
        style: {
          width: '32px',
          height: '32px'
        }
      })), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
        className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().titleAndDescription)
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
        className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().title)
      }, r.name), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
        className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().description)
      }, r.description)), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("div", {
        className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_3___default().switcher)
      }, isCurrent ? /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_5__.default, {
        style: {
          fontSize: '12px'
        }
      }) : /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_6__.default, {
        style: {
          fontSize: '12px'
        }
      }))), isCurrent ? renderCats() : null);
    });
  }

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, renderResources());
});

/***/ }),

/***/ "./ui/BlockList/BlockItem.tsx":
/*!************************************!*\
  !*** ./ui/BlockList/BlockItem.tsx ***!
  \************************************/
/*! namespace exports */
/*! export Meats [provided] [unused] [could be renamed] */
/*! export default [provided] [used] [could be renamed] */
/*! export getPathFromFilename [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getPathFromFilename": () => /* binding */ getPathFromFilename,
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* unused harmony export Meats */
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/extends */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/icons/ExportOutlined.js");
/* harmony import */ var _radjs_block_sdk_lib_data_d__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! @radjs/block-sdk/lib/data.d */ "../block-sdk/lib/data.d.ts");
/* harmony import */ var _radjs_block_sdk_lib_data_d__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(_radjs_block_sdk_lib_data_d__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @radjs/block-sdk/lib/enum */ "../block-sdk/lib/enum.js");
/* harmony import */ var _index_module_less_modules__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./index.module.less?modules */ "./ui/BlockList/index.module.less?modules");
/* harmony import */ var _index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8__);
/* harmony import */ var _HighlightedText__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./HighlightedText */ "./ui/BlockList/HighlightedText.tsx");
/* harmony import */ var _getInsertPosition__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./getInsertPosition */ "./ui/BlockList/getInsertPosition.tsx");
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");
/* harmony import */ var _components_BlockContext__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ../components/BlockContext */ "./ui/components/BlockContext.tsx");
/* harmony import */ var _ImageLoad__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./ImageLoad */ "./ui/BlockList/ImageLoad.tsx");
/* harmony import */ var _ImagePreview__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./ImagePreview */ "./ui/BlockList/ImagePreview.tsx");
















/**
 * 子区块 的 tag
 * @param
 */

var Meats = (_ref) => {
  var item = _ref.item,
      keyword = _ref.keyword;
  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("div", {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().meats)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("span", {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().tags)
  }, item.tags && item.tags.map(tag => /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("span", {
    key: tag,
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().tagInCard)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_HighlightedText__WEBPACK_IMPORTED_MODULE_9__.default, {
    text: tag,
    highlight: keyword
  })))));
};

/**
 * 将绝对路径转化为相对路径
 * @param api
 * @param filenamePath
 */
var getPathFromFilename = /*#__PURE__*/function () {
  var _ref2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee(api, filenamePath) {
    var _ref3, data;

    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return api.callRemote({
              type: 'org.umi.block.getRelativePagesPath',
              payload: {
                path: filenamePath
              }
            });

          case 2:
            _ref3 = _context.sent;
            data = _ref3.data;
            return _context.abrupt("return", data.replace(/(index)?((\.js?)|(\.tsx?)|(\.jsx?))$/, ''));

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getPathFromFilename(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();
/**
 * 打开 modal 框之前的一些处理
 * @param api  umi ui 的 api 全局对象
 * @param param 参数
 */

var onBeforeOpenModal = /*#__PURE__*/function () {
  var _ref5 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee2(api, _ref4) {
    var item, type, onShowModal, currentResource, isBlock, position, targetPath, _option;

    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            item = _ref4.item, type = _ref4.type, onShowModal = _ref4.onShowModal, currentResource = _ref4.currentResource;
            _context2.prev = 1;
            _context2.next = 4;
            return api.callRemote({
              type: 'org.umi.block.checkIfCanAdd',
              payload: {
                item,
                type,
                currentResource
              }
            });

          case 4:
            _context2.next = 10;
            break;

          case 6:
            _context2.prev = 6;
            _context2.t0 = _context2["catch"](1);
            antd__WEBPACK_IMPORTED_MODULE_5__.message.error(_context2.t0.message);
            return _context2.abrupt("return");

          case 10:
            isBlock = (currentResource === null || currentResource === void 0 ? void 0 : currentResource.resourceType) === _radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_7__.ResourceType.dumi ? type === _radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_7__.AssetType.BLOCK : type === 'block';

            if (!(api.isMini() && isBlock)) {
              _context2.next = 29;
              break;
            }

            _context2.prev = 12;
            _context2.next = 15;
            return (0,_getInsertPosition__WEBPACK_IMPORTED_MODULE_10__.default)(api);

          case 15:
            position = _context2.sent;
            console.log('position', position);
            _context2.next = 19;
            return getPathFromFilename(api, position.filename);

          case 19:
            targetPath = _context2.sent;
            _option = {
              path: targetPath,
              filename: position.filename,
              index: position.index,
              blockTarget: targetPath
            };
            onShowModal(item, _option);
            _context2.next = 28;
            break;

          case 24:
            _context2.prev = 24;
            _context2.t1 = _context2["catch"](12);
            console.error('BlockItem error', _context2.t1);
            antd__WEBPACK_IMPORTED_MODULE_5__.message.error(_context2.t1.message);

          case 28:
            return _context2.abrupt("return");

          case 29:
            onShowModal(item, {});

          case 30:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[1, 6], [12, 24]]);
  }));

  return function onBeforeOpenModal(_x3, _x4) {
    return _ref5.apply(this, arguments);
  };
}();

var ToolTipAddButton = (_ref6) => {
  var disabledTitle = _ref6.disabledTitle,
      disabled = _ref6.disabled,
      children = _ref6.children,
      reset = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_1__.default)(_ref6, ["disabledTitle", "disabled", "children"]);

  if (disabled) {
    return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
      title: disabledTitle
    }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Button, (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
      className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().addBtn),
      type: "primary",
      disabled: disabled
    }, reset), children));
  }

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Button, (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().addBtn),
    type: "primary",
    disabled: disabled
  }, reset), children);
};

var BlockItem = (_ref7) => {
  var type = _ref7.type,
      item = _ref7.item,
      _ref7$loading = _ref7.loading,
      loading = _ref7$loading === void 0 ? false : _ref7$loading,
      disabled = _ref7.disabled,
      onShowModal = _ref7.onShowModal,
      keyword = _ref7.keyword,
      selectedTag = _ref7.selectedTag;

  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_4__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_11__.default),
      api = _useContext.api;

  var _useContext2 = (0,react__WEBPACK_IMPORTED_MODULE_4__.useContext)(_components_BlockContext__WEBPACK_IMPORTED_MODULE_12__.default),
      currentResource = _useContext2.currentResource;

  var useIntl = api.useIntl;

  var _useIntl = useIntl(),
      intl = _useIntl.formatMessage;

  var isMini = api.isMini();
  var img = item.img || item.thumbnail;

  var handleAddButtonClick = /*#__PURE__*/function () {
    var _ref8 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee3() {
      return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return onBeforeOpenModal(api, {
                type,
                item,
                onShowModal,
                currentResource
              });

            case 2:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function handleAddButtonClick() {
      return _ref8.apply(this, arguments);
    };
  }();

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Col, {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().col),
    key: item.url
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("div", {
    id: item.url,
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().templateCard),
    onClick: () => {
      if (loading) {
        onShowModal(item, {});
      }
    }
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Spin, {
    spinning: loading,
    tip: "\u6DFB\u52A0\u4E2D..."
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("div", {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().demo)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("div", {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().addProject)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(ToolTipAddButton, {
    type: "primary",
    disabled: disabled,
    disabledTitle: intl({
      id: 'org.umi.ui.blocks.adder.disabledTitle'
    }),
    onClick: handleAddButtonClick
  }, loading ? intl({
    id: 'org.umi.ui.blocks.list.viewlog'
  }) : intl({
    id: 'org.umi.ui.blocks.list.add'
  })), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("div", {
    className: "".concat((_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().btnGroup), " ").concat(item.previewUrl ? (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().hasPreview) : '')
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_ImagePreview__WEBPACK_IMPORTED_MODULE_14__.default, {
    img: img,
    cls: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().previewBtn)
  }), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("div", {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().btnSep)
  }), item.previewUrl && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Tooltip, {
    title: intl({
      id: 'org.umi.ui.blocks.list.preview.demo'
    }),
    placement: "bottom"
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Button, {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().previewBtn),
    target: "_blank",
    href: item.previewUrl
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_15__.default, null))))), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_ImageLoad__WEBPACK_IMPORTED_MODULE_13__.default, {
    src: img
  }))), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("div", {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().content)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement("div", {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().title)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_HighlightedText__WEBPACK_IMPORTED_MODULE_9__.default, {
    text: item.name,
    highlight: keyword
  })), item.description && !isMini && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(antd__WEBPACK_IMPORTED_MODULE_5__.Typography.Paragraph, {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_8___default().description),
    ellipsis: {
      rows: 2,
      expandable: false
    }
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(_HighlightedText__WEBPACK_IMPORTED_MODULE_9__.default, {
    text: item.description,
    highlight: keyword
  })), !isMini && selectedTag === '' && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_4___default().createElement(Meats, {
    item: item,
    keyword: keyword
  }))));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (BlockItem);

/***/ }),

/***/ "./ui/BlockList/HighlightedText.tsx":
/*!******************************************!*\
  !*** ./ui/BlockList/HighlightedText.tsx ***!
  \******************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);


var HighlightedText = (_ref) => {
  var _ref$text = _ref.text,
      text = _ref$text === void 0 ? "" : _ref$text,
      _ref$highlight = _ref.highlight,
      highlight = _ref$highlight === void 0 ? "" : _ref$highlight;

  if (!text || !highlight) {
    return text;
  }

  var parts = text.split(new RegExp("(".concat(highlight, ")"), "gi"));
  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, parts.map((part, i) => /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement("span", {
    key: i,
    style: part.toLowerCase() === highlight.toLowerCase() ? {
      fontWeight: "bold",
      color: "#2688F9"
    } : {}
  }, part)));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (HighlightedText);

/***/ }),

/***/ "./ui/BlockList/ImageLoad.tsx":
/*!************************************!*\
  !*** ./ui/BlockList/ImageLoad.tsx ***!
  \************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _index_module_less_modules__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./index.module.less?modules */ "./ui/BlockList/index.module.less?modules");
/* harmony import */ var _index_module_less_modules__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_index_module_less_modules__WEBPACK_IMPORTED_MODULE_2__);



var DEFAULT_IMG = "https://gw.alipayobjects.com/mdn/rms_4f0d74/afts/img/A*I0RVS41yx2sAAAAAAAAAAABkARQnAQ";

var ImageLoad = (_ref) => {
  var src = _ref.src;

  var _useState = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(DEFAULT_IMG),
      _useState2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__.default)(_useState, 2),
      imgSrc = _useState2[0],
      setSrc = _useState2[1];

  (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
    var img = new Image();
    img.src = imgSrc;

    img.onload = () => {
      setSrc(src);
    };
  }, [src]);
  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement("div", {
    className: imgSrc === DEFAULT_IMG ? (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_2___default().defaultImg) : (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_2___default().img),
    style: {
      backgroundImage: "url(".concat(imgSrc, ")")
    }
  });
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (ImageLoad);

/***/ }),

/***/ "./ui/BlockList/ImagePreview.tsx":
/*!***************************************!*\
  !*** ./ui/BlockList/ImagePreview.tsx ***!
  \***************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/icons/EyeOutlined.js");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_2__);




/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (props => {
  var cls = props.cls,
      img = props.img;

  var _useState = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(true),
      _useState2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__.default)(_useState, 2),
      loading = _useState2[0],
      setLoading = _useState2[1];

  var handleImgLoad = () => {
    setLoading(false);
  };

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Tooltip, {
    title: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement("div", {
      style: {
        width: 450
      }
    }, loading && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Spin, null), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement("img", {
      style: {
        display: loading ? 'none' : 'block'
      },
      onLoad: handleImgLoad,
      width: "100%",
      alt: "img",
      draggable: "false",
      src: img
    }))
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Button, {
    className: cls
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_3__.default, null))));
});

/***/ }),

/***/ "./ui/BlockList/getInsertPosition.tsx":
/*!********************************************!*\
  !*** ./ui/BlockList/getInsertPosition.tsx ***!
  \********************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
// Open editor mode and get the insert poision
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (api => {
  window.parent.postMessage(JSON.stringify({
    action: 'umi.ui.enable.GUmiUIFlag'
  }), '*');
  window.parent.postMessage(JSON.stringify({
    action: 'umi.ui.checkValidEditSection'
  }), '*');
  return new Promise((resolve, reject) => {
    var messageHandler = e => {
      console.log('getInsertPosition e', e);
      console.log('[Block] Received message', e.data);

      try {
        var _JSON$parse = JSON.parse(e.data),
            action = _JSON$parse.action,
            payload = _JSON$parse.payload;

        if (action === 'umi.ui.block.addBlock') {
          var position = payload;
          window.removeEventListener('message', messageHandler);
          api.showMini();
          resolve(position);
          window.parent.postMessage(JSON.stringify({
            action: 'umi.ui.disableBlockEditMode'
          }), '*');
        } else if (action === 'umi.ui.checkValidEditSection.success') {
          if (payload.haveValid) {
            api.hideMini();
            window.parent.postMessage(JSON.stringify({
              action: 'umi.ui.enableBlockEditMode'
            }), '*');
            window.parent.postMessage(JSON.stringify({
              action: 'umi.ui.changeEdit',
              payload: {
                'zh-CN': '取消编辑',
                'en-US': 'Cancel Edit'
              }
            }), '*');
          } else {
            reject(new Error('只有 pages 或 page 目录下的页面才能插入资产'));
          }
        }
      } catch (error) {
        console.error('[Block] parse message error', error);
      }
    };

    window.addEventListener('message', messageHandler);
  });
});

/***/ }),

/***/ "./ui/BlockList/index.tsx":
/*!********************************!*\
  !*** ./ui/BlockList/index.tsx ***!
  \********************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/extends */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _radjs_block_sdk_lib_data_d__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @radjs/block-sdk/lib/data.d */ "../block-sdk/lib/data.d.ts");
/* harmony import */ var _radjs_block_sdk_lib_data_d__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_radjs_block_sdk_lib_data_d__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @radjs/block-sdk/lib/enum */ "../block-sdk/lib/enum.js");
/* harmony import */ var _index_module_less_modules__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./index.module.less?modules */ "./ui/BlockList/index.module.less?modules");
/* harmony import */ var _index_module_less_modules__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(_index_module_less_modules__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");
/* harmony import */ var _components_BlockContext__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ../components/BlockContext */ "./ui/components/BlockContext.tsx");
/* harmony import */ var _BlockItem__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./BlockItem */ "./ui/BlockList/BlockItem.tsx");











var BlockList = props => {
  var _props$list = props.list,
      list = _props$list === void 0 ? [] : _props$list,
      setSelectedTag = props.setSelectedTag,
      selectedTag = props.selectedTag,
      addingBlock = props.addingBlock,
      keyword = props.keyword,
      loading = props.loading;

  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_2__.useContext)(_components_BlockContext__WEBPACK_IMPORTED_MODULE_8__.default),
      currentResource = _useContext.currentResource;

  var _useContext2 = (0,react__WEBPACK_IMPORTED_MODULE_2__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_7__.default),
      api = _useContext2.api;

  var useIntl = api.useIntl;

  var _useIntl = useIntl(),
      intl = _useIntl.formatMessage;

  var isMini = api.isMini();
  var pageSize = isMini ? 6 : 8;

  var _useState = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(1),
      _useState2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState, 2),
      currentPage = _useState2[0],
      setCurrentPage = _useState2[1];

  (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
    setSelectedTag('');
    setCurrentPage(1);
  }, [list]);
  (0,react__WEBPACK_IMPORTED_MODULE_2__.useEffect)(() => {
    setCurrentPage(1);
  }, [selectedTag]);
  /**
   * 筛选区块列表
   */

  var filteredList = list.filter((_ref) => {
    var _ref$name = _ref.name,
        name = _ref$name === void 0 ? '' : _ref$name,
        url = _ref.url,
        _ref$description = _ref.description,
        description = _ref$description === void 0 ? '' : _ref$description,
        category = _ref.category,
        _ref$tags = _ref.tags,
        listTags = _ref$tags === void 0 ? [] : _ref$tags;
    return (!selectedTag || (category ? category === selectedTag : listTags.join('').includes(selectedTag))) && (!keyword || name.toLocaleLowerCase().includes(keyword) || description.toLocaleLowerCase().includes(keyword) || url.toLocaleLowerCase().includes(keyword));
  });
  /**
   * 当前的列表项目，区块分页就是在这里做
   */

  var currentPageList = filteredList.slice((currentPage - 1) * pageSize, currentPage * pageSize > filteredList.length ? filteredList.length : currentPage * pageSize).filter(Boolean);
  /**
   * 是不是数据为空
   */

  var isEmpty = !currentPageList || currentPageList.length === 0;
  var contents;

  if (loading) {
    contents = /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement("div", {
      className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_6___default().emptyWrapper)
    }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(antd__WEBPACK_IMPORTED_MODULE_3__.Spin, {
      size: "large"
    }));
  } else if (isEmpty) {
    // 切换为黑色背景图片
    contents = /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement("div", {
      className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_6___default().emptyWrapper)
    }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(antd__WEBPACK_IMPORTED_MODULE_3__.Empty, {
      imageStyle: {
        width: 64,
        height: 41,
        margin: '8px auto'
      },
      image: "https://gw.alipayobjects.com/mdn/rms_4f0d74/afts/img/A*LinHSLLEHUAAAAAAAAAAAABkARQnAQ",
      description: keyword ? intl({
        id: 'org.umi.ui.blocks.list.nofound'
      }) : intl({
        id: 'org.umi.ui.blocks.list.nodata'
      })
    }));
  } else {
    contents = /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement("div", {
      style: {
        display: 'flex',
        height: '100%',
        flexDirection: 'column'
      }
    }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(antd__WEBPACK_IMPORTED_MODULE_3__.Row, {
      gutter: [20, 20],
      type: "flex"
    }, currentPageList.map(item => {
      var blockItemPropsMap = {
        [_radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_5__.ResourceType.dumi]: {
          key: item.identifier,
          loading: addingBlock && item.identifier === addingBlock.identifier,
          disabled: addingBlock && item.identifier === addingBlock.identifier
        },
        default: {
          key: item.url,
          loading: addingBlock && item.url === addingBlock.url,
          disabled: addingBlock && addingBlock.url && item.url !== addingBlock.url
        }
      };
      return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_BlockItem__WEBPACK_IMPORTED_MODULE_9__.default, (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({}, props, blockItemPropsMap[currentResource === null || currentResource === void 0 ? void 0 : currentResource.resourceType] || blockItemPropsMap.default, {
        item: item,
        selectedTag: selectedTag
      }));
    })), filteredList.length > pageSize && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(antd__WEBPACK_IMPORTED_MODULE_3__.Row, {
      className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_6___default().pagination),
      type: "flex",
      justify: "end"
    }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(antd__WEBPACK_IMPORTED_MODULE_3__.Pagination, {
      size: isMini ? 'small' : undefined,
      current: currentPage,
      onChange: setCurrentPage,
      total: filteredList.length,
      pageSize: pageSize
    })));
  }

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement("div", {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_6___default().cardContainer)
  }, contents);
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (BlockList);

/***/ }),

/***/ "./ui/BlocksViewer.tsx":
/*!*****************************!*\
  !*** ./ui/BlocksViewer.tsx ***!
  \*****************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! export scrollToById [provided] [unused] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* unused harmony export scrollToById */
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/extends */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2 */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/icons/ReloadOutlined.js");
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/icons/PlusOutlined.js");
/* harmony import */ var _radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! @radjs/block-sdk/lib/enum */ "../block-sdk/lib/enum.js");
/* harmony import */ var qs__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! qs */ "../../node_modules/qs/lib/index.js");
/* harmony import */ var qs__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(qs__WEBPACK_IMPORTED_MODULE_8__);
/* harmony import */ var _icon__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./icon */ "./ui/icon.tsx");
/* harmony import */ var _BlockList__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./BlockList */ "./ui/BlockList/index.tsx");
/* harmony import */ var _GlobalSearch__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./GlobalSearch */ "./ui/GlobalSearch.tsx");
/* harmony import */ var _components_BlockContext__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./components/BlockContext */ "./ui/components/BlockContext.tsx");
/* harmony import */ var _BlocksViewer_module_less_modules__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./BlocksViewer.module.less?modules */ "./ui/BlocksViewer.module.less?modules");
/* harmony import */ var _BlocksViewer_module_less_modules__WEBPACK_IMPORTED_MODULE_13___default = /*#__PURE__*/__webpack_require__.n(_BlocksViewer_module_less_modules__WEBPACK_IMPORTED_MODULE_13__);
/* harmony import */ var _Adder__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./Adder */ "./ui/Adder/index.tsx");
/* harmony import */ var _AssetsMenu__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./AssetsMenu */ "./ui/AssetsMenu/index.tsx");
/* harmony import */ var _Container__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./Container */ "./ui/Container.ts");


















/**
 * get substr from url
 */

var getQueryConfig = () => (0,qs__WEBPACK_IMPORTED_MODULE_8__.parse)(window.location.search.substr(1));
/**
 *  更新 search
 * @param params
 */


var updateUrlQuery = params => {
  var defaultParas = getQueryConfig();
  window.history.pushState({}, '', "?".concat((0,qs__WEBPACK_IMPORTED_MODULE_8__.stringify)((0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_4__.default)((0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_4__.default)({}, defaultParas), params))));
};

var clearCache = /*#__PURE__*/function () {
  var _ref = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee(api) {
    var hide, _ref2, data;

    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            hide = antd__WEBPACK_IMPORTED_MODULE_6__.message.loading('缓存清理中！');
            _context.next = 4;
            return api.callRemote({
              type: 'org.umi.block.clear'
            });

          case 4:
            _ref2 = _context.sent;
            data = _ref2.data;
            // 用户记忆的参数
            localStorage.removeItem('umi-ui-block-removeLocale');
            hide(); // 等动画播放完

            setTimeout(() => {
              antd__WEBPACK_IMPORTED_MODULE_6__.message.success(data);
            }, 30);
            _context.next = 14;
            break;

          case 11:
            _context.prev = 11;
            _context.t0 = _context["catch"](0);
            antd__WEBPACK_IMPORTED_MODULE_6__.message.error(_context.t0.message);

          case 14:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 11]]);
  }));

  return function clearCache(_x) {
    return _ref.apply(this, arguments);
  };
}();

var openUmiBlocks = () => {
  window.open('https://github.com/umijs/umi-blocks');
};
/**
 * 从 id 的 dom 滚动到 target 的 dom
 * @param id
 * @param target
 */


var scrollToById = (id, target) => {
  var dom = document.getElementById(id);
  var targetDom = document.getElementById(target);

  if (dom && targetDom) {
    var axis = dom.getBoundingClientRect();
    targetDom.scrollTop = axis.top + axis.height / 2;
  }
};

/**
 * 渲染 数据源选择器
 * @param param0
 */
var renderActiveResourceTag = (_ref3) => {
  var type = _ref3.type,
      _ref3$matchedResource = _ref3.matchedResources,
      matchedResources = _ref3$matchedResource === void 0 ? [] : _ref3$matchedResource,
      _ref3$current = _ref3.current,
      current = _ref3$current === void 0 ? {
    id: ''
  } : _ref3$current,
      setActiveResource = _ref3.setActiveResource;

  if (matchedResources.length > 1) {
    return /*#__PURE__*/React.createElement(Radio.Group, {
      value: current.id,
      size: "small",
      onChange: e => {
        var resource = matchedResources.find(r => r.id === e.target.value);
        setActiveResource(resource);
        updateUrlQuery({
          type,
          resource: resource.id
        });
      }
    }, matchedResources.map(r => /*#__PURE__*/React.createElement(Radio.Button, {
      key: r.id,
      value: r.id
    }, r.name)));
  }

  if (matchedResources.length === 1) {
    return /*#__PURE__*/React.createElement("h3", {
      style: {
        marginTop: 8
      }
    }, matchedResources[0].name);
  }

  return null;
};
/**
 * 资产 主入口
 * @param props
 */


var BlocksViewer = () => {
  var _Container$useContain = _Container__WEBPACK_IMPORTED_MODULE_16__.default.useContainer(),
      api = _Container$useContain.api,
      type = _Container$useContain.type,
      setType = _Container$useContain.setType,
      activeResource = _Container$useContain.activeResource,
      setActiveResource = _Container$useContain.setActiveResource;

  var callRemote = api.callRemote,
      useIntl = api.useIntl,
      hooks = api.hooks;
  var useRequest = hooks.useRequest;

  var _useIntl = useIntl(),
      intl = _useIntl.formatMessage;
  /**
   * 是不是 mini
   */


  var isMini = api.isMini();
  /**
   * 用到的各种状态
   */

  var _useState = (0,react__WEBPACK_IMPORTED_MODULE_5__.useState)(null),
      _useState2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState, 2),
      willAddBlock = _useState2[0],
      setWillAddBlock = _useState2[1];

  var _useState3 = (0,react__WEBPACK_IMPORTED_MODULE_5__.useState)(null),
      _useState4 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState3, 2),
      addingBlock = _useState4[0],
      setAddBlock = _useState4[1];

  var _useState5 = (0,react__WEBPACK_IMPORTED_MODULE_5__.useState)(false),
      _useState6 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState5, 2),
      addModalVisible = _useState6[0],
      setAddModalVisible = _useState6[1];

  var _useState7 = (0,react__WEBPACK_IMPORTED_MODULE_5__.useState)(null),
      _useState8 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState7, 2),
      blockParams = _useState8[0],
      setBlockParams = _useState8[1];

  var _useState9 = (0,react__WEBPACK_IMPORTED_MODULE_5__.useState)(''),
      _useState10 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState9, 2),
      searchValue = _useState10[0],
      setSearchValue = _useState10[1];

  var _useState11 = (0,react__WEBPACK_IMPORTED_MODULE_5__.useState)(''),
      _useState12 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState11, 2),
      selectedTag = _useState12[0],
      setSelectedTag = _useState12[1];

  var _useState13 = (0,react__WEBPACK_IMPORTED_MODULE_5__.useState)({}),
      _useState14 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState13, 2),
      blockData = _useState14[0],
      setBlockData = _useState14[1]; // 获取资产数据源


  var _useRequest = useRequest(() => callRemote({
    type: 'org.umi.block.resource'
  }), {
    cacheKey: 'getResources',
    formatResult: res => (res === null || res === void 0 ? void 0 : res.data) || [],
    initialData: []
  }),
      resources = _useRequest.data,
      error = _useRequest.error,
      fetchResourceLoading = _useRequest.loading; // 当前的数据源列表


  var current = activeResource || resources.filter(item => item.blockType === type)[0]; // 请求资产列表

  var _useRequest2 = useRequest( /*#__PURE__*/(0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_3__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee2() {
    var resourceId, resource, _yield$callRemote, list;

    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            resourceId = current.id;
            resource = resources.find(r => r.id === resourceId);

            if (!((resource === null || resource === void 0 ? void 0 : resource.resourceType) === _radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_7__.ResourceType.dumi && resource.assets)) {
              _context2.next = 4;
              break;
            }

            return _context2.abrupt("return", {
              [resourceId]: resource.assets
            });

          case 4:
            _context2.next = 6;
            return callRemote({
              type: 'org.umi.block.list',
              payload: {
                resourceId,
                force: false
              }
            });

          case 6:
            _yield$callRemote = _context2.sent;
            list = _yield$callRemote.data;
            return _context2.abrupt("return", {
              [resourceId]: list
            });

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })), {
    cacheKey: 'getAssetsList',
    refreshDeps: [current, resources],
    formatResult: res => res,
    onSuccess: data => {
      setBlockData(prevData => (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_4__.default)((0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_4__.default)({}, prevData), data));
    },
    initialData: {}
  }),
      fetchDataLoading = _useRequest2.loading,
      run = _useRequest2.run;
  /**
   * 获取 query 中的设置
   */


  (0,react__WEBPACK_IMPORTED_MODULE_5__.useLayoutEffect)(() => {
    // 更新一下url，让他们同步一下
    if (type) {
      updateUrlQuery({
        type
      });
    }
  }, []); // 计算选中的区块

  var blocks = (0,react__WEBPACK_IMPORTED_MODULE_5__.useMemo)(() => current && blockData[current.id] ? blockData[current.id] : [], [blockData, current]);
  (0,react__WEBPACK_IMPORTED_MODULE_5__.useEffect)(() => {
    var handleMessage = event => {
      try {
        var _JSON$parse = JSON.parse(event.data),
            action = _JSON$parse.action,
            _JSON$parse$payload = _JSON$parse.payload,
            payload = _JSON$parse$payload === void 0 ? {} : _JSON$parse$payload;

        switch (action) {
          // postMessage，ui 与项目的通讯
          case 'umi.ui.block.addTemplate':
            {
              setWillAddBlock(undefined);
              setBlockParams(undefined);

              if (payload) {
                setType('template');
                onShowModal(payload, {});
              }

              break;
            }

          default: // no thing

        }
      } catch (_) {// no thing
      }

      return false;
    };

    window.addEventListener('message', handleMessage, false); // 告知父级页面，资产 准备就绪

    window.parent.postMessage(JSON.stringify({
      action: 'umi.ui.block.addTemplate.ready'
    }), '*');
    return () => {
      window.removeEventListener('message', handleMessage, false);
    };
  }, []); // 如果区块不在屏幕范围内，滚动过去

  (0,react__WEBPACK_IMPORTED_MODULE_5__.useEffect)(() => {
    if (willAddBlock) {
      // 我把每个 item 都加了一个 id，就是他的 url
      scrollToById(willAddBlock.url, 'block-list-view');
    }
  }, [fetchDataLoading]); // 区块右上角的区域 三个按钮

  (0,react__WEBPACK_IMPORTED_MODULE_5__.useEffect)(() => {
    var buttonPadding = isMini ? '0 4px' : '0 8px';

    var handleSearchChange = function handleSearchChange() {
      var _v$toLocaleLowerCase;

      var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      setSearchValue((v === null || v === void 0 ? void 0 : (_v$toLocaleLowerCase = v.toLocaleLowerCase) === null || _v$toLocaleLowerCase === void 0 ? void 0 : _v$toLocaleLowerCase.call(v)) || '');
    };

    if (api.setActionPanel) {
      api.setActionPanel(() => [/*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(_GlobalSearch__WEBPACK_IMPORTED_MODULE_11__.default, {
        key: "global-search",
        onChange: handleSearchChange,
        api: api
      }), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(antd__WEBPACK_IMPORTED_MODULE_6__.Tooltip, {
        title: intl({
          id: 'org.umi.ui.blocks.actions.reload'
        }),
        getPopupContainer: node => node ? node.parentNode : document.body,
        placement: "bottom"
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(antd__WEBPACK_IMPORTED_MODULE_6__.Button, {
        size: isMini ? 'small' : 'default',
        key: "reload",
        style: {
          padding: buttonPadding
        },
        onClick: () => run()
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_17__.default, null))), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(antd__WEBPACK_IMPORTED_MODULE_6__.Tooltip, {
        title: intl({
          id: 'org.umi.ui.blocks.actions.clear'
        }),
        getPopupContainer: node => node ? node.parentNode : document.body,
        placement: "bottom"
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(antd__WEBPACK_IMPORTED_MODULE_6__.Button, {
        size: isMini ? 'small' : 'default',
        key: "clear",
        onClick: () => clearCache(api),
        style: {
          padding: buttonPadding
        }
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(_icon__WEBPACK_IMPORTED_MODULE_9__.Clear, null))), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(antd__WEBPACK_IMPORTED_MODULE_6__.Tooltip, {
        title: intl({
          id: 'org.umi.ui.blocks.actions.submit'
        }),
        getPopupContainer: node => node ? node.parentNode : document.body,
        placement: "bottom"
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(antd__WEBPACK_IMPORTED_MODULE_6__.Button, {
        size: isMini ? 'small' : 'default',
        key: "clear",
        onClick: () => openUmiBlocks(),
        style: {
          padding: buttonPadding
        }
      }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_18__.default, null)))]);
    }
  }, [current]);

  var onShowModal = (currentBlock, option) => {
    setAddModalVisible(true);
    setWillAddBlock(currentBlock);
    setBlockParams(option);
  };

  var onHideModal = () => {
    setAddModalVisible(false);
    setWillAddBlock(undefined);
    setBlockParams(undefined);
  };

  var matchedResources = resources.filter(r => r.blockType === type);
  var currentResource = resources.find(r => r.id === (current === null || current === void 0 ? void 0 : current.id));
  var loading = fetchResourceLoading === true || fetchDataLoading === true;
  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(_components_BlockContext__WEBPACK_IMPORTED_MODULE_12__.default.Provider, {
    value: {
      current,
      resources,
      ResourceType: _radjs_block_sdk_lib_enum__WEBPACK_IMPORTED_MODULE_7__.ResourceType,
      currentResource
    }
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement("div", {
    className: (_BlocksViewer_module_less_modules__WEBPACK_IMPORTED_MODULE_13___default().wrapper)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement("div", {
    className: (_BlocksViewer_module_less_modules__WEBPACK_IMPORTED_MODULE_13___default().side)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(_AssetsMenu__WEBPACK_IMPORTED_MODULE_15__.default, {
    type: type,
    matchedResources: matchedResources,
    setActiveResource: setActiveResource,
    updateUrlQuery: updateUrlQuery,
    setSelectedTag: setSelectedTag,
    selectedTag: selectedTag,
    current: current,
    blocks: blocks,
    loading: loading
  })), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement("div", {
    className: (_BlocksViewer_module_less_modules__WEBPACK_IMPORTED_MODULE_13___default().main)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement("div", {
    className: "".concat((_BlocksViewer_module_less_modules__WEBPACK_IMPORTED_MODULE_13___default().container), " ").concat(isMini && (_BlocksViewer_module_less_modules__WEBPACK_IMPORTED_MODULE_13___default().min)),
    id: "block-list-view"
  }, current ? /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement("div", {
    className: (_BlocksViewer_module_less_modules__WEBPACK_IMPORTED_MODULE_13___default().blockList)
  }, matchedResources.length > 0 && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(_BlockList__WEBPACK_IMPORTED_MODULE_10__.default, {
    type: type,
    keyword: searchValue,
    addingBlock: willAddBlock || addingBlock,
    list: blocks,
    current: current,
    setSelectedTag: setSelectedTag,
    selectedTag: selectedTag,
    onShowModal: onShowModal,
    loading: loading
  }), !loading && !(matchedResources === null || matchedResources === void 0 ? void 0 : matchedResources.length) && /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement("div", null, "\u6CA1\u6709\u627E\u5230\u6570\u636E\u6E90")) : /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement("div", {
    className: (_BlocksViewer_module_less_modules__WEBPACK_IMPORTED_MODULE_13___default().loading)
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(antd__WEBPACK_IMPORTED_MODULE_6__.Spin, null))))), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_5___default().createElement(_Adder__WEBPACK_IMPORTED_MODULE_14__.default, (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
    block: willAddBlock,
    blockType: type
  }, blockParams, {
    visible: addModalVisible,
    onAddBlockChange: addBlock => setAddBlock(addBlock),
    onHideModal: onHideModal
  })));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (BlocksViewer);

/***/ }),

/***/ "./ui/Container.ts":
/*!*************************!*\
  !*** ./ui/Container.ts ***!
  \*************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2 */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var qs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! qs */ "../../node_modules/qs/lib/index.js");
/* harmony import */ var qs__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(qs__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _unstated_next__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./unstated-next */ "./ui/unstated-next.tsx");





/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,_unstated_next__WEBPACK_IMPORTED_MODULE_4__.createContainer)(initialState => {
  var getQueryConfig = () => (0,qs__WEBPACK_IMPORTED_MODULE_3__.parse)(window.location.search.substr(1));

  var query = getQueryConfig();

  var _useState = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(query.type || 'block'),
      _useState2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState, 2),
      type = _useState2[0],
      setType = _useState2[1];

  var _useState3 = (0,react__WEBPACK_IMPORTED_MODULE_2__.useState)(query.resource ? {
    id: query.resource
  } : null),
      _useState4 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_1__.default)(_useState3, 2),
      activeResource = _useState4[0],
      setActiveResource = _useState4[1];

  return (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_0__.default)((0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_0__.default)({}, initialState), {}, {
    type,
    setType,
    activeResource,
    setActiveResource
  });
}));

/***/ }),

/***/ "./ui/CustomTreeSelect/index.tsx":
/*!***************************************!*\
  !*** ./ui/CustomTreeSelect/index.tsx ***!
  \***************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/extends */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_3__);




var InputGroup = antd__WEBPACK_IMPORTED_MODULE_3__.Input.Group;

var CustomTreeSelect = props => {
  var _props$value = props.value,
      value = _props$value === void 0 ? "" : _props$value,
      propOnChange = props.onChange,
      onlySelectLeaf = props.onlySelectLeaf,
      restProps = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_1__.default)(props, ["value", "onChange", "onlySelectLeaf"]);

  var ref = (0,react__WEBPACK_IMPORTED_MODULE_2__.useRef)();

  var _onChange = (path, fileName) => {
    propOnChange("".concat(path, "/").concat(fileName).replace(/\/\//g, "/"));
  };

  var fileArray = value.split("/");
  var name = fileArray.pop();
  var filePath = fileArray.join("/") || "/";
  var realValue = onlySelectLeaf ? value : filePath;
  var selectDom = /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(antd__WEBPACK_IMPORTED_MODULE_3__.TreeSelect, (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
    showSearch: true,
    style: {
      width: onlySelectLeaf ? "100%" : "30%"
    },
    dropdownStyle: {
      backgroundColor: "#23232e"
    },
    labelInValue: true,
    dropdownMatchSelectWidth: onlySelectLeaf ? undefined : 400,
    value: {
      value: realValue
    } // 不加这个不会跟着进度条走
    ,
    getPopupContainer: () => ref.current || document.body,
    onSelect: (_, node) => {
      if (onlySelectLeaf) {
        propOnChange(node.value);
        return;
      }

      if (_onChange) {
        _onChange(node.value, name);
      }
    }
  }, restProps));
  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement("div", {
    ref: ref,
    style: {
      position: "relative"
    }
  }, onlySelectLeaf ? selectDom : /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(InputGroup, {
    compact: true
  }, selectDom, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(antd__WEBPACK_IMPORTED_MODULE_3__.Input, {
    style: {
      width: "70%"
    },
    value: name,
    onChange: e => {
      _onChange(filePath, e.target.value);
    }
  })));
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (CustomTreeSelect);

/***/ }),

/***/ "./ui/GlobalSearch.tsx":
/*!*****************************!*\
  !*** ./ui/GlobalSearch.tsx ***!
  \*****************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/icons/SearchOutlined.js");
/* harmony import */ var _GlobalSearch_module_less_modules__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./GlobalSearch.module.less?modules */ "./ui/GlobalSearch.module.less?modules");
/* harmony import */ var _GlobalSearch_module_less_modules__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_GlobalSearch_module_less_modules__WEBPACK_IMPORTED_MODULE_2__);





var GlobalSearch = props => {
  var onChange = props.onChange,
      api = props.api;
  var useIntl = api.useIntl,
      hooks = api.hooks,
      _ = api._;

  var _useIntl = useIntl(),
      formatMessage = _useIntl.formatMessage;

  var debounceFn = _.debounce; // compatible with prev version umi ui

  if (hooks === null || hooks === void 0 ? void 0 : hooks.useDebounceFn) {
    debounceFn = hooks.useDebounceFn;
  } // 时间太长会造成卡顿的感觉，200-300 比较合适


  var handleChange = debounceFn(value => {
    onChange(value);
  }, 300);
  var handleChangeDebounce = (handleChange === null || handleChange === void 0 ? void 0 : handleChange.run) || handleChange;
  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement(antd__WEBPACK_IMPORTED_MODULE_1__.Input, {
    prefix: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_3__.default, null),
    className: (_GlobalSearch_module_less_modules__WEBPACK_IMPORTED_MODULE_2___default().search),
    allowClear: true,
    size: api.mini ? 'small' : 'middle',
    onChange: e => handleChangeDebounce(e.target.value),
    placeholder: formatMessage({
      id: 'org.umi.ui.blocks.content.search_block'
    })
  });
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (GlobalSearch);

/***/ }),

/***/ "./ui/LogPanel/index.tsx":
/*!*******************************!*\
  !*** ./ui/LogPanel/index.tsx ***!
  \*******************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/icons/LoadingOutlined.js");
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../UIApiContext */ "./ui/UIApiContext.ts");





var LogPanel = (_ref) => {
  var loading = _ref.loading;

  var _useContext = (0,react__WEBPACK_IMPORTED_MODULE_1__.useContext)(_UIApiContext__WEBPACK_IMPORTED_MODULE_2__.default),
      api = _useContext.api;

  var _useState = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)([]),
      _useState2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__.default)(_useState, 2),
      logs = _useState2[0],
      setLogs = _useState2[1];

  var _useState3 = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(null),
      _useState4 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_0__.default)(_useState3, 2),
      terminalRef = _useState4[0],
      setTerminalRef = _useState4[1];

  var Terminal = api.Terminal;
  (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
    if (!terminalRef) {
      return;
    }
    /**
     * 获取上次安装的日志
     * 安装完成会清空
     */


    api.callRemote({
      type: "org.umi.block.get-adding-blocks-log"
    }).then((_ref2) => {
      var data = _ref2.data;

      if (terminalRef) {
        terminalRef.write(data.replace(/\n/g, "\r\n"));
      }
    });
    var tempLogs = [];
    /**
     *监听日志，每次会 push 一条
     */

    api.listenRemote({
      type: "org.umi.block.add-blocks-log",
      onMessage: (_ref3) => {
        var data = _ref3.data;
        tempLogs.push(data);

        if (terminalRef) {
          terminalRef.write(data.replace(/\n/g, "\r\n"));
        }

        setLogs([...tempLogs]);
      }
    });
  }, [terminalRef]);

  if (!Terminal) {
    return null;
  }

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(Terminal, {
    title: loading ? /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_3__.default, null) : " ",
    defaultValue: logs.join(""),
    onInit: terminal => {
      setTerminalRef(terminal);
    },
    config: api.isMini() ? {
      fontSize: 12
    } : {}
  });
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (LogPanel);

/***/ }),

/***/ "./ui/TitleTab/index.tsx":
/*!*******************************!*\
  !*** ./ui/TitleTab/index.tsx ***!
  \*******************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2 */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var qs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! qs */ "../../node_modules/qs/lib/index.js");
/* harmony import */ var qs__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(qs__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _index_module_less_modules__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./index.module.less?modules */ "./ui/TitleTab/index.module.less?modules");
/* harmony import */ var _index_module_less_modules__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_index_module_less_modules__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _Container__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../Container */ "./ui/Container.ts");






var TabPane = antd__WEBPACK_IMPORTED_MODULE_2__.Tabs.TabPane;
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (function (props) {
  var _Container$useContain = _Container__WEBPACK_IMPORTED_MODULE_5__.default.useContainer(),
      api = _Container$useContain.api,
      type = _Container$useContain.type,
      setType = _Container$useContain.setType,
      setActiveResource = _Container$useContain.setActiveResource;

  var useIntl = api.useIntl;

  var _useIntl = useIntl(),
      formatMessage = _useIntl.formatMessage;

  var getQueryConfig = () => (0,qs__WEBPACK_IMPORTED_MODULE_3__.parse)(window.location.search.substr(1));

  var updateUrlQuery = params => {
    var defaultParas = getQueryConfig();
    window.history.pushState({}, '', "?".concat((0,qs__WEBPACK_IMPORTED_MODULE_3__.stringify)((0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_0__.default)((0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_0__.default)({}, defaultParas), params))));
  };

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Tabs, {
    className: (_index_module_less_modules__WEBPACK_IMPORTED_MODULE_4___default().tabs),
    size: "large",
    activeKey: type,
    onChange: activeKey => {
      setType(activeKey);
      setActiveResource(null);
      /**
       * 修改 url 中的参数，数据源改变时
       * 清空 resource
       */

      updateUrlQuery({
        type: activeKey,
        resource: undefined
      });
    }
  }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(TabPane, {
    tab: formatMessage({
      id: 'org.umi.ui.blocks.tabs.blocks'
    }),
    key: "block"
  }), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(TabPane, {
    tab: formatMessage({
      id: 'org.umi.ui.blocks.tabs.templates'
    }),
    key: "template"
  }));
});

/***/ }),

/***/ "./ui/UIApiContext.ts":
/*!****************************!*\
  !*** ./ui/UIApiContext.ts ***!
  \****************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

var UIApiContext = (0,react__WEBPACK_IMPORTED_MODULE_0__.createContext)({});
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (UIApiContext);

/***/ }),

/***/ "./ui/components/BlockContext.tsx":
/*!****************************************!*\
  !*** ./ui/components/BlockContext.tsx ***!
  \****************************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

var BlockContext = (0,react__WEBPACK_IMPORTED_MODULE_0__.createContext)({});
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (BlockContext);

/***/ }),

/***/ "./ui/hooks/useCallData.ts":
/*!*********************************!*\
  !*** ./ui/hooks/useCallData.ts ***!
  \*********************************/
/*! namespace exports */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2 */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectSpread2.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/slicedToArray.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! antd */ "antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_5__);







var useCallData = (getData, effects, options) => {
  var _useState = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(options.defaultData),
      _useState2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_3__.default)(_useState, 2),
      list = _useState2[0],
      setList = _useState2[1];

  var _useState3 = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(true),
      _useState4 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_3__.default)(_useState3, 2),
      loading = _useState4[0],
      setLoading = _useState4[1];

  var _useState5 = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(1),
      _useState6 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_3__.default)(_useState5, 2),
      pageIndex = _useState6[0],
      setPageIndex = _useState6[1];

  var _useState7 = (0,react__WEBPACK_IMPORTED_MODULE_4__.useState)(false),
      _useState8 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_slicedToArray__WEBPACK_IMPORTED_MODULE_3__.default)(_useState7, 2),
      hasMore = _useState8[0],
      setHasMore = _useState8[1];

  var _ref = options || {},
      _ref$manual = _ref.manual,
      manual = _ref$manual === void 0 ? false : _ref$manual;

  var _ref2 = options && options.fetchMore ? options.fetchMore : {},
      _ref2$pageSize = _ref2.pageSize,
      pageSize = _ref2$pageSize === void 0 ? 20 : _ref2$pageSize;

  var fetchList = /*#__PURE__*/function () {
    var _ref3 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_2__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee(isAppend) {
      var _yield$getData, data, success, message, newList, totalCount;

      return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setLoading(true);
              _context.next = 3;
              return getData({
                pageIndex,
                pageSize
              });

            case 3:
              _yield$getData = _context.sent;
              data = _yield$getData.data;
              success = _yield$getData.success;
              message = _yield$getData.message;

              if (success !== false) {
                if (isAppend && list) {
                  newList = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectSpread2__WEBPACK_IMPORTED_MODULE_1__.default)({}, data);
                  Object.keys(data || {}).forEach(key => {
                    // 自动合并返回中的数组
                    if (Array.isArray(data[key]) && list[key]) {
                      newList[key] = list[key].concat(data[key]);
                    }
                  });
                  setList(newList);
                } else {
                  setList(data);
                } // 判断是否还有更多


                totalCount = 0;
                Object.keys(data || {}).forEach(key => {
                  // 后端返回的总数的字段都是类似 totalOrderCount 这样格式的
                  if (/total\S+Count/.test(key) && typeof data[key] === "number") {
                    totalCount = data[key];
                  }
                });

                if (totalCount > pageSize * pageIndex) {
                  // 还可以翻页
                  setHasMore(true);
                } else {
                  setHasMore(false);
                }
              } else {
                antd__WEBPACK_IMPORTED_MODULE_5__.message.error(message);
              }

              setLoading(false);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function fetchList(_x) {
      return _ref3.apply(this, arguments);
    };
  }();

  var fetchMore = () => {
    setPageIndex(pageIndex + 1);
    fetchList(true);
  };

  (0,react__WEBPACK_IMPORTED_MODULE_4__.useEffect)(() => {
    if (manual === false) {
      fetchList();
    }
  }, effects || []);
  return {
    data: list,
    loading,
    fetch: fetchList,
    fetchMore,
    hasMore,
    setList
  };
};

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (useCallData);

/***/ }),

/***/ "./ui/icon.tsx":
/*!*********************!*\
  !*** ./ui/icon.tsx ***!
  \*********************/
/*! namespace exports */
/*! export Clear [provided] [used] [could be renamed] */
/*! export default [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__,
/* harmony export */   "Clear": () => /* binding */ Clear
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/extends */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/components/Icon.js");



/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (props => {
  var SVGIcon = () => /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement("svg", (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
    width: "1em",
    height: "1em",
    fill: "currentColor",
    viewBox: "0 0 1024 1024"
  }, props), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement("path", {
    d: "M949.546 650.8c11.194 0 20.29 8.981 20.48 20.13v80.129a20.48 20.48 0 01-11.06 18.185l-.352.178-432.828 206.25a32 32 0 01-27.531 0L65.427 769.422a20.48 20.48 0 01-11.413-18.363V671.28c0-11.31 9.17-20.48 20.48-20.48 3.06 0 6.082.686 8.842 2.007l414.87 198.558a32 32 0 0027.629 0l414.87-198.558a20.48 20.48 0 018.841-2.007zm0-234c11.194 0 20.29 8.981 20.48 20.13v80.129a20.48 20.48 0 01-11.06 18.185l-.352.178-432.828 206.25a32 32 0 01-27.531 0L65.427 535.422a20.48 20.48 0 01-11.413-18.363V437.28c0-11.31 9.17-20.48 20.48-20.48 3.06 0 6.082.686 8.842 2.007l414.87 198.558a32 32 0 0027.629 0l414.87-198.558a20.48 20.48 0 018.841-2.007zm-426-367.089l.47.22 445.996 212.278c9.973 4.747 14.21 16.68 9.463 26.654a20 20 0 01-9.48 9.471l-445.98 211.763a32 32 0 01-27.619-.004L54.082 298.407c-6.968-3.612-10.989-10.67-11.068-18.006v-.386c-.06-7.346 3.84-14.468 10.704-18.2l.364-.193L496.396 49.935a32 32 0 0127.15-.224z",
    fill: "currentColor",
    fillRule: "nonzero"
  }));

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_2__.default, (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
    component: SVGIcon
  }, props));
});
var Clear = props => {
  var SVGIcon = () => /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement("svg", (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
    width: "1em",
    height: "1em",
    fill: "currentColor",
    viewBox: "0 0 1024 1024"
  }, props), /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement("path", {
    d: "M899.1 869.6l-53-305.6H864c14.4 0 26-11.6 26-26V346c0-14.4-11.6-26-26-26H618V138c0-14.4-11.6-26-26-26H432c-14.4 0-26 11.6-26 26v182H160c-14.4 0-26 11.6-26 26v192c0 14.4 11.6 26 26 26h17.9l-53 305.6c-.3 1.5-.4 3-.4 4.4 0 14.4 11.6 26 26 26h723c1.5 0 3-.1 4.4-.4 14.2-2.4 23.7-15.9 21.2-30zM204 390h272V182h72v208h272v104H204V390zm468 440V674c0-4.4-3.6-8-8-8h-48c-4.4 0-8 3.6-8 8v156H416V674c0-4.4-3.6-8-8-8h-48c-4.4 0-8 3.6-8 8v156H202.8l45.1-260H776l45.1 260H672z",
    fill: "currentColor",
    fillRule: "nonzero"
  }));

  return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_2__.default, (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
    component: SVGIcon
  }, props));
};

/***/ }),

/***/ "./ui/index.tsx":
/*!**********************!*\
  !*** ./ui/index.tsx ***!
  \**********************/
/*! namespace exports */
/*! export default [provided] [used] [usage prevents renaming] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => __WEBPACK_DEFAULT_EXPORT__
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/extends */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/extends.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/objectWithoutProperties.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _UIApiContext__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./UIApiContext */ "./ui/UIApiContext.ts");
/* harmony import */ var _BlocksViewer__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./BlocksViewer */ "./ui/BlocksViewer.tsx");
/* harmony import */ var _TitleTab__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./TitleTab */ "./ui/TitleTab/index.tsx");
/* harmony import */ var _icon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./icon */ "./ui/icon.tsx");
/* harmony import */ var _locales_zh_CN__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./locales/zh-CN */ "./ui/locales/zh-CN.js");
/* harmony import */ var _locales_en_US__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./locales/en-US */ "./ui/locales/en-US.js");
/* harmony import */ var _Container__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./Container */ "./ui/Container.ts");










/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (api => {
  api.addLocales({
    'zh-CN': _locales_zh_CN__WEBPACK_IMPORTED_MODULE_7__.default,
    'en-US': _locales_en_US__WEBPACK_IMPORTED_MODULE_8__.default
  });
  api.addPanel({
    title: 'org.umi.ui.blocks.content.title',
    headerTitle: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_TitleTab__WEBPACK_IMPORTED_MODULE_5__.default, null),
    provider: (_ref) => {
      var children = _ref.children,
          restProps = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_objectWithoutProperties__WEBPACK_IMPORTED_MODULE_1__.default)(_ref, ["children"]);

      return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_Container__WEBPACK_IMPORTED_MODULE_9__.default.Provider, (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_extends__WEBPACK_IMPORTED_MODULE_0__.default)({
        initialState: {
          api
        }
      }, restProps), children);
    },
    path: '/blocks',
    icon: /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_icon__WEBPACK_IMPORTED_MODULE_6__.default, null),
    actions: [],
    component: () => /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_UIApiContext__WEBPACK_IMPORTED_MODULE_3__.default.Provider, {
      value: {
        api
      }
    }, /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_2___default().createElement(_BlocksViewer__WEBPACK_IMPORTED_MODULE_4__.default, null))
  });
});

/***/ }),

/***/ "./ui/unstated-next.tsx":
/*!******************************!*\
  !*** ./ui/unstated-next.tsx ***!
  \******************************/
/*! namespace exports */
/*! export createContainer [provided] [used] [could be renamed] */
/*! export useContainer [provided] [unused] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "createContainer": () => /* binding */ createContainer
/* harmony export */ });
/* unused harmony export useContainer */
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

function createContainer(useHook) {
  var Context = react__WEBPACK_IMPORTED_MODULE_0___default().createContext(null);

  function Provider(props) {
    var value = useHook(props.initialState);
    return /*#__PURE__*/react__WEBPACK_IMPORTED_MODULE_0___default().createElement(Context.Provider, {
      value: value
    }, props.children);
  }

  function useContainer() {
    var value = react__WEBPACK_IMPORTED_MODULE_0___default().useContext(Context);

    if (value === null) {
      throw new Error('Component must be wrapped with <Container.Provider>');
    }

    return value;
  }

  return {
    Provider,
    useContainer
  };
}
function useContainer(container) {
  return container.useContainer();
}

/***/ }),

/***/ "./ui/util.ts":
/*!********************!*\
  !*** ./ui/util.ts ***!
  \********************/
/*! namespace exports */
/*! export getNoExitPath [provided] [used] [could be renamed] */
/*! export getNoExitRoute [provided] [used] [could be renamed] */
/*! export getNoExitVar [provided] [used] [could be renamed] */
/*! other exports [not provided] [unused] */
/*! runtime requirements: __webpack_require__, __webpack_require__.n, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "getNoExitVar": () => /* binding */ getNoExitVar,
/* harmony export */   "getNoExitRoute": () => /* binding */ getNoExitRoute,
/* harmony export */   "getNoExitPath": () => /* binding */ getNoExitPath
/* harmony export */ });
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/regenerator */ "../ui-builder/node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator */ "../ui-builder/node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js");


var defaultNameArray = ['Two', 'Three', 'Four', 'Five', 'Six', 'Seven'];

var getNewName = function getNewName(name) {
  var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  return "".concat(name).concat(defaultNameArray[index]);
};
/**
 * 获取一个未定义的变量名
 * @param param2
 */


var getNoExitVar = /*#__PURE__*/function () {
  var _ref2 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee(_ref) {
    var api, name, path, defaultName, _ref$index, index, _ref$need, need, _ref3, exists;

    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            api = _ref.api, name = _ref.name, path = _ref.path, defaultName = _ref.defaultName, _ref$index = _ref.index, index = _ref$index === void 0 ? 0 : _ref$index, _ref$need = _ref.need, need = _ref$need === void 0 ? true : _ref$need;

            if (need) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return", name);

          case 3:
            _context.prev = 3;
            _context.next = 6;
            return api.callRemote({
              type: 'org.umi.block.checkBindingInFile',
              payload: {
                path,
                name
              }
            });

          case 6:
            _ref3 = _context.sent;
            exists = _ref3.exists;

            if (!(index < 6 && exists)) {
              _context.next = 10;
              break;
            }

            return _context.abrupt("return", getNoExitVar({
              name: getNewName(defaultName || name, index),
              path,
              api,
              defaultName: defaultName || name,
              index: index + 1
            }));

          case 10:
            return _context.abrupt("return", name);

          case 13:
            _context.prev = 13;
            _context.t0 = _context["catch"](3);

          case 15:
            return _context.abrupt("return", name);

          case 16:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[3, 13]]);
  }));

  return function getNoExitVar(_x) {
    return _ref2.apply(this, arguments);
  };
}();
/**
 * 获取未定义的路由
 * @param param0
 */

var getNoExitRoute = /*#__PURE__*/function () {
  var _ref5 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee2(_ref4) {
    var api, path, defaultPath, _ref4$index, index, _ref4$need, need, _ref6, exists, fileArray, name, filePath;

    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            api = _ref4.api, path = _ref4.path, defaultPath = _ref4.defaultPath, _ref4$index = _ref4.index, index = _ref4$index === void 0 ? 0 : _ref4$index, _ref4$need = _ref4.need, need = _ref4$need === void 0 ? true : _ref4$need;

            if (need) {
              _context2.next = 3;
              break;
            }

            return _context2.abrupt("return", path);

          case 3:
            _context2.prev = 3;
            _context2.next = 6;
            return api.callRemote({
              type: 'org.umi.block.checkExistRoute',
              payload: {
                path: path.toLowerCase()
              }
            });

          case 6:
            _ref6 = _context2.sent;
            exists = _ref6.exists;

            if (!(index < 6 && exists)) {
              _context2.next = 13;
              break;
            }

            fileArray = (defaultPath || path).split('/');
            name = fileArray.pop();
            filePath = fileArray.join('/') || '/';
            return _context2.abrupt("return", getNoExitRoute({
              path: "".concat(filePath, "/").concat(getNewName(name, index)).replace(/\/\//g, '/'),
              api,
              defaultPath: defaultPath || path,
              index: index + 1
            }));

          case 13:
            return _context2.abrupt("return", path);

          case 16:
            _context2.prev = 16;
            _context2.t0 = _context2["catch"](3);

          case 18:
            return _context2.abrupt("return", path);

          case 19:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[3, 16]]);
  }));

  return function getNoExitRoute(_x2) {
    return _ref5.apply(this, arguments);
  };
}();
/**
 * 获取未定义的文件列表
 * @param param0
 */

var getNoExitPath = /*#__PURE__*/function () {
  var _ref8 = (0,F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_helpers_esm_asyncToGenerator__WEBPACK_IMPORTED_MODULE_1__.default)( /*#__PURE__*/F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee3(_ref7) {
    var api, path, defaultPath, _ref7$index, index, _ref7$need, need, _ref9, exists, fileArray, name, filePath;

    return F_goworks_src_gitee_com_zlinkgroup_rad_ui_packages_ui_builder_node_modules_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            api = _ref7.api, path = _ref7.path, defaultPath = _ref7.defaultPath, _ref7$index = _ref7.index, index = _ref7$index === void 0 ? 0 : _ref7$index, _ref7$need = _ref7.need, need = _ref7$need === void 0 ? true : _ref7$need;

            if (need) {
              _context3.next = 3;
              break;
            }

            return _context3.abrupt("return", path);

          case 3:
            _context3.prev = 3;
            _context3.next = 6;
            return api.callRemote({
              type: 'org.umi.block.checkExistFilePath',
              payload: {
                path
              }
            });

          case 6:
            _ref9 = _context3.sent;
            exists = _ref9.exists;

            if (!(index < 6 && exists)) {
              _context3.next = 13;
              break;
            }

            fileArray = (defaultPath || path).split('/');
            name = fileArray.pop();
            filePath = fileArray.join('/') || '/';
            return _context3.abrupt("return", getNoExitPath({
              path: "".concat(filePath, "/").concat(getNewName(name, index)).replace(/\/\//g, '/'),
              api,
              defaultPath: defaultPath || path,
              index: index + 1
            }));

          case 13:
            return _context3.abrupt("return", path);

          case 16:
            _context3.prev = 16;
            _context3.t0 = _context3["catch"](3);

          case 18:
            return _context3.abrupt("return", path);

          case 19:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[3, 16]]);
  }));

  return function getNoExitPath(_x3) {
    return _ref8.apply(this, arguments);
  };
}();

/***/ }),

/***/ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/Adder/ResultPanel.module.less?modules":
/*!******************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/Adder/ResultPanel.module.less?modules ***!
  \******************************************************************************************************************************************************************************************************************************************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: __webpack_exports__, module, __webpack_require__, module.id */
/***/ ((module, exports, __webpack_require__) => {

// Imports
var ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../ui-builder/node_modules/css-loader/dist/runtime/api.js */ "../ui-builder/node_modules/css-loader/dist/runtime/api.js");
exports = ___CSS_LOADER_API_IMPORT___(false);
// Module
exports.push([module.id, ".result___2ePaW {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n.result___2ePaW .ant-result-icon > .anticon {\n  font-size: 56px;\n}\n.result___2ePaW .ant-result-title {\n  font-size: 16px;\n}\n.result___2ePaW .ant-result-subtitle {\n  font-size: 14px;\n}\n.result___2ePaW .ant-result-extra {\n  margin-top: 40px;\n}\n", ""]);
// Exports
exports.locals = {
	"result": "result___2ePaW"
};
module.exports = exports;


/***/ }),

/***/ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/AssetsMenu/index.module.less?modules":
/*!*****************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/AssetsMenu/index.module.less?modules ***!
  \*****************************************************************************************************************************************************************************************************************************************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: __webpack_exports__, module, __webpack_require__, module.id */
/***/ ((module, exports, __webpack_require__) => {

// Imports
var ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../ui-builder/node_modules/css-loader/dist/runtime/api.js */ "../ui-builder/node_modules/css-loader/dist/runtime/api.js");
exports = ___CSS_LOADER_API_IMPORT___(false);
// Module
exports.push([module.id, ".resource___3w-4O {\n  height: 60px;\n  background: #23232e;\n  cursor: pointer;\n  display: flex;\n  align-items: center;\n  padding: 0 24px;\n}\n.resource___3w-4O .icon___1TTbN {\n  padding-right: 12px;\n  text-align: center;\n}\n.resource___3w-4O .titleAndDescription___e1ZMS {\n  flex: 1 1;\n}\n.resource___3w-4O .titleAndDescription___e1ZMS .title___3q-7U {\n  color: #dfdfe1;\n  font-size: 14px;\n}\n.resource___3w-4O .titleAndDescription___e1ZMS .description___3X3L7 {\n  color: #8a8a90;\n  font-size: 12px;\n}\n.resource___3w-4O:hover {\n  background: #2b2b36;\n}\n.resource___3w-4O.current___27qgK {\n  background: #2b2b36;\n}\n.cats___3Phfs {\n  flex: 1 1;\n  background: #2b2b36;\n  border-bottom: 1px solid #000;\n  overflow: auto;\n}\n.catsLoading___2tGJW {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n.cat___i8LI4 {\n  color: #b5b5b8;\n  cursor: pointer;\n  height: 38px;\n  line-height: 38px;\n  text-indent: 24px;\n}\n.cat___i8LI4:hover,\n.cat___i8LI4.current___27qgK {\n  background: #33333d;\n  color: #fff;\n}\n", ""]);
// Exports
exports.locals = {
	"resource": "resource___3w-4O",
	"icon": "icon___1TTbN",
	"titleAndDescription": "titleAndDescription___e1ZMS",
	"title": "title___3q-7U",
	"description": "description___3X3L7",
	"current": "current___27qgK",
	"cats": "cats___3Phfs",
	"catsLoading": "catsLoading___2tGJW",
	"cat": "cat___i8LI4"
};
module.exports = exports;


/***/ }),

/***/ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/BlockList/index.module.less?modules":
/*!****************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/BlockList/index.module.less?modules ***!
  \****************************************************************************************************************************************************************************************************************************************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: __webpack_exports__, module, __webpack_require__, module.id */
/***/ ((module, exports, __webpack_require__) => {

// Imports
var ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../ui-builder/node_modules/css-loader/dist/runtime/api.js */ "../ui-builder/node_modules/css-loader/dist/runtime/api.js");
exports = ___CSS_LOADER_API_IMPORT___(false);
// Module
exports.push([module.id, ".emptyWrapper___2HozI {\n  margin: 120px auto;\n  text-align: center;\n}\n.ant-empty .ant-empty-image {\n  display: block;\n}\n.tagContainer___Fuld1 {\n  margin-bottom: 16px;\n  float: right;\n  margin-right: -8px;\n  max-width: 60%;\n  margin-top: 0;\n  text-align: right;\n}\n.tagContainer___Fuld1 .ant-tag:not(.ant-tag-checkable-checked) {\n  border: 1px solid rgba(255, 255, 255, 0.15);\n  border-radius: 4px;\n  margin-top: 8px;\n}\n.cardContainer___1y_EL {\n  clear: both;\n}\n.pagination___1uLKJ {\n  margin-top: 32px;\n}\n.isMini .templateCard___1Zw4I .demo___2sB26 {\n  padding: 0;\n  height: 140px;\n}\n.isMini .templateCard___1Zw4I .demo___2sB26 .addProject___1T4hP .previewBtn____aAfn,\n.isMini .templateCard___1Zw4I .demo___2sB26 .addProject___1T4hP .addBtn___3DExb {\n  width: 92px;\n}\n.isMini .btnGroup___WB5l6 {\n  width: 92px !important;\n}\n.isMini .btnGroup___WB5l6.hasPreview___JPhYm .previewBtn____aAfn {\n  width: 42px !important;\n}\n.col___1-API {\n  flex: 0 1 25%;\n  overflow: hidden;\n}\n.col___1-API .ant-spin.ant-spin-spinning.ant-spin-show-text {\n  color: rgba(255, 255, 255, 0.65);\n}\n@media screen and (max-width: 1200px) {\n  .col___1-API {\n    flex: 0 1 33.33%;\n    overflow: hidden;\n  }\n}\n@media screen and (max-width: 900px) {\n  .col___1-API {\n    flex: 0 1 33.33%;\n    overflow: hidden;\n  }\n}\n@media screen and (max-width: 768px) {\n  .col___1-API {\n    flex: 0 1 50%;\n    overflow: hidden;\n  }\n}\n@media screen and (max-width: 576px) {\n  .col___1-API {\n    flex: 0 1 100%;\n    overflow: hidden;\n  }\n}\n.templateCard___1Zw4I {\n  width: 100%;\n  cursor: pointer;\n  position: relative;\n  top: 0;\n  transition: all 0.3s;\n  font-size: 14px;\n  display: block;\n  border-radius: 2px;\n  overflow: hidden;\n}\n.templateCard___1Zw4I .demo___2sB26 {\n  padding: 12px;\n  background: #30303d;\n  overflow: hidden;\n  position: relative;\n  box-sizing: border-box;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  height: 150px;\n}\n.templateCard___1Zw4I .demo___2sB26 .img___jHTTX {\n  width: 100%;\n  height: 100%;\n  background-position: top center;\n  background-size: 100% auto;\n  background-repeat: no-repeat;\n  background-color: #fff;\n}\n.templateCard___1Zw4I .demo___2sB26 .defaultImg___7jRhu {\n  width: 100%;\n  height: 100%;\n  background-position: center center;\n  background-repeat: no-repeat;\n}\n.templateCard___1Zw4I .demo___2sB26 .addProject___1T4hP {\n  width: 100%;\n  height: 100%;\n  background-color: rgba(0, 0, 0, 0.65);\n  position: absolute;\n  left: 0;\n  top: 0;\n  opacity: 0;\n  display: flex;\n  flex-direction: column;\n  justify-content: center;\n  align-items: center;\n  transition: all ease-in-out 0.3s;\n}\n.templateCard___1Zw4I .demo___2sB26 .addProject___1T4hP .previewBtn____aAfn {\n  margin-top: 8px;\n}\n.templateCard___1Zw4I .demo___2sB26 .addProject___1T4hP .previewBtn____aAfn,\n.templateCard___1Zw4I .demo___2sB26 .addProject___1T4hP .addBtn___3DExb {\n  width: 102px;\n}\n.templateCard___1Zw4I .demo___2sB26 .addProject___1T4hP .btnGroup___WB5l6 {\n  display: flex;\n  width: 102px;\n}\n.templateCard___1Zw4I .demo___2sB26 .addProject___1T4hP .btnGroup___WB5l6.hasPreview___JPhYm .previewBtn____aAfn {\n  width: 47px;\n}\n.templateCard___1Zw4I .demo___2sB26 .addProject___1T4hP .btnSep___3OPDs {\n  flex: 1 1;\n}\n.templateCard___1Zw4I .demo___2sB26 .spin___13SYR {\n  position: absolute;\n}\n.templateCard___1Zw4I .demo___2sB26:hover .addProject___1T4hP {\n  opacity: 100;\n}\n.templateCard___1Zw4I .content___cUR8T {\n  font-size: 14px;\n  padding: 8px 12px;\n  background: #30303d;\n  margin-top: 1px;\n}\n.templateCard___1Zw4I .content___cUR8T .title___iej25 {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  max-width: 180px;\n  font-size: 14px;\n  line-height: 22px;\n  color: rgba(255, 255, 255, 0.85);\n  font-weight: 500;\n}\n.templateCard___1Zw4I .content___cUR8T .description___2q2yh {\n  margin-top: 4px;\n  font-size: 12px;\n  color: rgba(255, 255, 255, 0.45);\n  letter-spacing: 0;\n  line-height: 20px;\n  height: 40px;\n  margin-bottom: 0;\n}\n.templateCard___1Zw4I .content___cUR8T .meats___2xhLV {\n  display: flex;\n  justify-content: space-between;\n  align-items: baseline;\n  line-height: 1;\n  margin-top: 16px;\n}\n.templateCard___1Zw4I .content___cUR8T .meats___2xhLV .tags___1PF6O {\n  color: rgba(255, 255, 255, 0.45);\n  font-size: 12px;\n  line-height: 22px;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  max-width: 160px;\n  height: 20px;\n  overflow: hidden;\n}\n.templateCard___1Zw4I .content___cUR8T .meats___2xhLV .tags___1PF6O .tagItem____DfEK {\n  margin-left: 16px;\n}\n.templateCard___1Zw4I .content___cUR8T .meats___2xhLV .tags___1PF6O .tagItem____DfEK:first-child {\n  margin-left: 0;\n}\n.templateCard___1Zw4I .content___cUR8T .meats___2xhLV .tagInCard___3wK7E + .tagInCard___3wK7E {\n  margin-left: 12px;\n}\n.templateCard___1Zw4I .content___cUR8T .meats___2xhLV .info___mUtsE {\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.45);\n  white-space: nowrap;\n}\n", ""]);
// Exports
exports.locals = {
	"emptyWrapper": "emptyWrapper___2HozI",
	"tagContainer": "tagContainer___Fuld1",
	"cardContainer": "cardContainer___1y_EL",
	"pagination": "pagination___1uLKJ",
	"templateCard": "templateCard___1Zw4I",
	"demo": "demo___2sB26",
	"addProject": "addProject___1T4hP",
	"previewBtn": "previewBtn____aAfn",
	"addBtn": "addBtn___3DExb",
	"btnGroup": "btnGroup___WB5l6",
	"hasPreview": "hasPreview___JPhYm",
	"col": "col___1-API",
	"img": "img___jHTTX",
	"defaultImg": "defaultImg___7jRhu",
	"btnSep": "btnSep___3OPDs",
	"spin": "spin___13SYR",
	"content": "content___cUR8T",
	"title": "title___iej25",
	"description": "description___2q2yh",
	"meats": "meats___2xhLV",
	"tags": "tags___1PF6O",
	"tagItem": "tagItem____DfEK",
	"tagInCard": "tagInCard___3wK7E",
	"info": "info___mUtsE"
};
module.exports = exports;


/***/ }),

/***/ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/BlocksViewer.module.less?modules":
/*!*************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/BlocksViewer.module.less?modules ***!
  \*************************************************************************************************************************************************************************************************************************************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: __webpack_exports__, module, __webpack_require__, module.id */
/***/ ((module, exports, __webpack_require__) => {

// Imports
var ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../ui-builder/node_modules/css-loader/dist/runtime/api.js */ "../ui-builder/node_modules/css-loader/dist/runtime/api.js");
exports = ___CSS_LOADER_API_IMPORT___(false);
// Module
exports.push([module.id, ".container___1Ekz6 {\n  padding: 24px;\n  height: 100%;\n  overflow: auto;\n}\n.container___1Ekz6.min___2QowR {\n  padding: 20px;\n}\n.loading___1b9tl {\n  text-align: center;\n  margin-top: 200px;\n}\n.blockList___9o44d h3 {\n  display: inline-block;\n}\n.tabs___1QAQc .ant-tabs-bar {\n  border: 0;\n  margin-bottom: 24px;\n}\n.tabs___1QAQc .ant-tabs-tab {\n  padding: 4px 8px;\n}\n.block___1ndBs {\n  cursor: pointer;\n  float: left;\n  margin-right: 20px;\n  margin-bottom: 20px;\n  width: 140px;\n  height: 140px;\n  border: 1px solid #ccc;\n  overflow: hidden;\n  text-align: center;\n  position: relative;\n  background: #fff;\n  border-radius: 5px;\n}\n.spin___Ndy7c {\n  position: absolute;\n  left: 0;\n  top: 50px;\n  width: 140px;\n}\n.block___1ndBs:hover {\n  border: 1px solid #1c92ff;\n  box-shadow: 0 -2px 10px rgba(0, 0, 0, 0.1);\n}\n.blockTitle___1Mskf {\n  font-size: 16px;\n  margin-bottom: 20px;\n}\n.ant-select-tree-indent {\n  white-space: pre;\n}\n.wrapper___CMsLO {\n  display: flex;\n  height: 100%;\n  overflow: auto;\n}\n.wrapper___CMsLO .side___24KM7 {\n  width: 256px;\n  display: flex;\n  flex-direction: column;\n  border-right: 1px solid #000;\n}\n@media screen and (max-width: 768px) {\n  .wrapper___CMsLO .side___24KM7 {\n    width: 212px;\n  }\n}\n.wrapper___CMsLO .main___2uAsV {\n  flex: 1 1;\n}\n", ""]);
// Exports
exports.locals = {
	"container": "container___1Ekz6",
	"min": "min___2QowR",
	"loading": "loading___1b9tl",
	"blockList": "blockList___9o44d",
	"tabs": "tabs___1QAQc",
	"block": "block___1ndBs",
	"spin": "spin___Ndy7c",
	"blockTitle": "blockTitle___1Mskf",
	"wrapper": "wrapper___CMsLO",
	"side": "side___24KM7",
	"main": "main___2uAsV"
};
module.exports = exports;


/***/ }),

/***/ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/GlobalSearch.module.less?modules":
/*!*************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/GlobalSearch.module.less?modules ***!
  \*************************************************************************************************************************************************************************************************************************************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: __webpack_exports__, module, __webpack_require__, module.id */
/***/ ((module, exports, __webpack_require__) => {

// Imports
var ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../ui-builder/node_modules/css-loader/dist/runtime/api.js */ "../ui-builder/node_modules/css-loader/dist/runtime/api.js");
exports = ___CSS_LOADER_API_IMPORT___(false);
// Module
exports.push([module.id, ".search___2cAhF {\n  width: 266px;\n}\n.search___2cAhF > input {\n  background-color: #17171f;\n}\n.isMini .search___2cAhF {\n  height: 24px;\n  line-height: 24px;\n}\n", ""]);
// Exports
exports.locals = {
	"search": "search___2cAhF"
};
module.exports = exports;


/***/ }),

/***/ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/TitleTab/index.module.less?modules":
/*!***************************************************************************************************************************************************************************************************************************************************************************************!*\
  !*** ../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/TitleTab/index.module.less?modules ***!
  \***************************************************************************************************************************************************************************************************************************************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: __webpack_exports__, module, __webpack_require__, module.id */
/***/ ((module, exports, __webpack_require__) => {

// Imports
var ___CSS_LOADER_API_IMPORT___ = __webpack_require__(/*! ../../../ui-builder/node_modules/css-loader/dist/runtime/api.js */ "../ui-builder/node_modules/css-loader/dist/runtime/api.js");
exports = ___CSS_LOADER_API_IMPORT___(false);
// Module
exports.push([module.id, ".tabs___1raMy {\n  margin-bottom: -16px;\n}\n.tabs___1raMy .ant-tabs-bar {\n  border: 0;\n}\n.tabs___1raMy .ant-tabs-tab {\n  padding: 16px 0 !important;\n  font-size: 20px;\n}\n.isMini .tabs___1raMy .ant-tabs-tab {\n  padding: 8px 0 !important;\n  font-size: 16px;\n  margin: 0 22px 0 0 !important;\n}\n", ""]);
// Exports
exports.locals = {
	"tabs": "tabs___1raMy"
};
module.exports = exports;


/***/ }),

/***/ "../ui-builder/node_modules/css-loader/dist/runtime/api.js":
/*!*****************************************************************!*\
  !*** ../ui-builder/node_modules/css-loader/dist/runtime/api.js ***!
  \*****************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module */
/***/ ((module) => {

"use strict";


/*
  MIT License http://www.opensource.org/licenses/mit-license.php
  Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
// eslint-disable-next-line func-names
module.exports = function (useSourceMap) {
  var list = []; // return the list of modules as css string

  list.toString = function toString() {
    return this.map(function (item) {
      var content = cssWithMappingToString(item, useSourceMap);

      if (item[2]) {
        return "@media ".concat(item[2], " {").concat(content, "}");
      }

      return content;
    }).join('');
  }; // import a list of modules into the list
  // eslint-disable-next-line func-names


  list.i = function (modules, mediaQuery, dedupe) {
    if (typeof modules === 'string') {
      // eslint-disable-next-line no-param-reassign
      modules = [[null, modules, '']];
    }

    var alreadyImportedModules = {};

    if (dedupe) {
      for (var i = 0; i < this.length; i++) {
        // eslint-disable-next-line prefer-destructuring
        var id = this[i][0];

        if (id != null) {
          alreadyImportedModules[id] = true;
        }
      }
    }

    for (var _i = 0; _i < modules.length; _i++) {
      var item = [].concat(modules[_i]);

      if (dedupe && alreadyImportedModules[item[0]]) {
        // eslint-disable-next-line no-continue
        continue;
      }

      if (mediaQuery) {
        if (!item[2]) {
          item[2] = mediaQuery;
        } else {
          item[2] = "".concat(mediaQuery, " and ").concat(item[2]);
        }
      }

      list.push(item);
    }
  };

  return list;
};

function cssWithMappingToString(item, useSourceMap) {
  var content = item[1] || ''; // eslint-disable-next-line prefer-destructuring

  var cssMapping = item[3];

  if (!cssMapping) {
    return content;
  }

  if (useSourceMap && typeof btoa === 'function') {
    var sourceMapping = toComment(cssMapping);
    var sourceURLs = cssMapping.sources.map(function (source) {
      return "/*# sourceURL=".concat(cssMapping.sourceRoot || '').concat(source, " */");
    });
    return [content].concat(sourceURLs).concat([sourceMapping]).join('\n');
  }

  return [content].join('\n');
} // Adapted from convert-source-map (MIT)


function toComment(sourceMap) {
  // eslint-disable-next-line no-undef
  var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap))));
  var data = "sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(base64);
  return "/*# ".concat(data, " */");
}

/***/ }),

/***/ "./ui/Adder/ResultPanel.module.less?modules":
/*!**************************************************!*\
  !*** ./ui/Adder/ResultPanel.module.less?modules ***!
  \**************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__, module.id */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var api = __webpack_require__(/*! !../../../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js */ "../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js");
            var content = __webpack_require__(/*! !!../../../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../../../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ResultPanel.module.less?modules */ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/Adder/ResultPanel.module.less?modules");

            content = content.__esModule ? content.default : content;

            if (typeof content === 'string') {
              content = [[module.id, content, '']];
            }

var options = {"base":0};

options.insert = "head";
options.singleton = false;

var update = api(content, options);

var exported = content.locals ? content.locals : {};



module.exports = exported;

/***/ }),

/***/ "./ui/AssetsMenu/index.module.less?modules":
/*!*************************************************!*\
  !*** ./ui/AssetsMenu/index.module.less?modules ***!
  \*************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__, module.id */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var api = __webpack_require__(/*! !../../../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js */ "../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js");
            var content = __webpack_require__(/*! !!../../../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../../../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./index.module.less?modules */ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/AssetsMenu/index.module.less?modules");

            content = content.__esModule ? content.default : content;

            if (typeof content === 'string') {
              content = [[module.id, content, '']];
            }

var options = {"base":0};

options.insert = "head";
options.singleton = false;

var update = api(content, options);

var exported = content.locals ? content.locals : {};



module.exports = exported;

/***/ }),

/***/ "./ui/BlockList/index.module.less?modules":
/*!************************************************!*\
  !*** ./ui/BlockList/index.module.less?modules ***!
  \************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__, module.id */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var api = __webpack_require__(/*! !../../../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js */ "../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js");
            var content = __webpack_require__(/*! !!../../../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../../../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./index.module.less?modules */ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/BlockList/index.module.less?modules");

            content = content.__esModule ? content.default : content;

            if (typeof content === 'string') {
              content = [[module.id, content, '']];
            }

var options = {"base":0};

options.insert = "head";
options.singleton = false;

var update = api(content, options);

var exported = content.locals ? content.locals : {};



module.exports = exported;

/***/ }),

/***/ "./ui/BlocksViewer.module.less?modules":
/*!*********************************************!*\
  !*** ./ui/BlocksViewer.module.less?modules ***!
  \*********************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__, module.id */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var api = __webpack_require__(/*! !../../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js */ "../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js");
            var content = __webpack_require__(/*! !!../../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./BlocksViewer.module.less?modules */ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/BlocksViewer.module.less?modules");

            content = content.__esModule ? content.default : content;

            if (typeof content === 'string') {
              content = [[module.id, content, '']];
            }

var options = {"base":0};

options.insert = "head";
options.singleton = false;

var update = api(content, options);

var exported = content.locals ? content.locals : {};



module.exports = exported;

/***/ }),

/***/ "./ui/GlobalSearch.module.less?modules":
/*!*********************************************!*\
  !*** ./ui/GlobalSearch.module.less?modules ***!
  \*********************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__, module.id */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var api = __webpack_require__(/*! !../../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js */ "../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js");
            var content = __webpack_require__(/*! !!../../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./GlobalSearch.module.less?modules */ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/GlobalSearch.module.less?modules");

            content = content.__esModule ? content.default : content;

            if (typeof content === 'string') {
              content = [[module.id, content, '']];
            }

var options = {"base":0};

options.insert = "head";
options.singleton = false;

var update = api(content, options);

var exported = content.locals ? content.locals : {};



module.exports = exported;

/***/ }),

/***/ "./ui/TitleTab/index.module.less?modules":
/*!***********************************************!*\
  !*** ./ui/TitleTab/index.module.less?modules ***!
  \***********************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__, module.id */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var api = __webpack_require__(/*! !../../../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js */ "../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js");
            var content = __webpack_require__(/*! !!../../../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../../../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./index.module.less?modules */ "../ui-builder/node_modules/css-loader/dist/cjs.js??ruleSet[1].rules[0].use[1]!../../node_modules/postcss-loader/src/index.js??ruleSet[1].rules[0].use[2]!../ui-builder/node_modules/less-loader/dist/cjs.js??ruleSet[1].rules[0].use[3]!./ui/TitleTab/index.module.less?modules");

            content = content.__esModule ? content.default : content;

            if (typeof content === 'string') {
              content = [[module.id, content, '']];
            }

var options = {"base":0};

options.insert = "head";
options.singleton = false;

var update = api(content, options);

var exported = content.locals ? content.locals : {};



module.exports = exported;

/***/ }),

/***/ "../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js":
/*!****************************************************************************************!*\
  !*** ../ui-builder/node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js ***!
  \****************************************************************************************/
/*! unknown exports (runtime-defined) */
/*! exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module, __webpack_require__.nc, __webpack_require__.* */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var isOldIE = function isOldIE() {
  var memo;
  return function memorize() {
    if (typeof memo === 'undefined') {
      // Test for IE <= 9 as proposed by Browserhacks
      // @see http://browserhacks.com/#hack-e71d8692f65334173fee715c222cb805
      // Tests for existence of standard globals is to allow style-loader
      // to operate correctly into non-standard environments
      // @see https://github.com/webpack-contrib/style-loader/issues/177
      memo = Boolean(window && document && document.all && !window.atob);
    }

    return memo;
  };
}();

var getTarget = function getTarget() {
  var memo = {};
  return function memorize(target) {
    if (typeof memo[target] === 'undefined') {
      var styleTarget = document.querySelector(target); // Special case to return head of iframe instead of iframe itself

      if (window.HTMLIFrameElement && styleTarget instanceof window.HTMLIFrameElement) {
        try {
          // This will throw an exception if access to iframe is blocked
          // due to cross-origin restrictions
          styleTarget = styleTarget.contentDocument.head;
        } catch (e) {
          // istanbul ignore next
          styleTarget = null;
        }
      }

      memo[target] = styleTarget;
    }

    return memo[target];
  };
}();

var stylesInDom = [];

function getIndexByIdentifier(identifier) {
  var result = -1;

  for (var i = 0; i < stylesInDom.length; i++) {
    if (stylesInDom[i].identifier === identifier) {
      result = i;
      break;
    }
  }

  return result;
}

function modulesToDom(list, options) {
  var idCountMap = {};
  var identifiers = [];

  for (var i = 0; i < list.length; i++) {
    var item = list[i];
    var id = options.base ? item[0] + options.base : item[0];
    var count = idCountMap[id] || 0;
    var identifier = "".concat(id, " ").concat(count);
    idCountMap[id] = count + 1;
    var index = getIndexByIdentifier(identifier);
    var obj = {
      css: item[1],
      media: item[2],
      sourceMap: item[3]
    };

    if (index !== -1) {
      stylesInDom[index].references++;
      stylesInDom[index].updater(obj);
    } else {
      stylesInDom.push({
        identifier: identifier,
        updater: addStyle(obj, options),
        references: 1
      });
    }

    identifiers.push(identifier);
  }

  return identifiers;
}

function insertStyleElement(options) {
  var style = document.createElement('style');
  var attributes = options.attributes || {};

  if (typeof attributes.nonce === 'undefined') {
    var nonce =  true ? __webpack_require__.nc : undefined;

    if (nonce) {
      attributes.nonce = nonce;
    }
  }

  Object.keys(attributes).forEach(function (key) {
    style.setAttribute(key, attributes[key]);
  });

  if (typeof options.insert === 'function') {
    options.insert(style);
  } else {
    var target = getTarget(options.insert || 'head');

    if (!target) {
      throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");
    }

    target.appendChild(style);
  }

  return style;
}

function removeStyleElement(style) {
  // istanbul ignore if
  if (style.parentNode === null) {
    return false;
  }

  style.parentNode.removeChild(style);
}
/* istanbul ignore next  */


var replaceText = function replaceText() {
  var textStore = [];
  return function replace(index, replacement) {
    textStore[index] = replacement;
    return textStore.filter(Boolean).join('\n');
  };
}();

function applyToSingletonTag(style, index, remove, obj) {
  var css = remove ? '' : obj.media ? "@media ".concat(obj.media, " {").concat(obj.css, "}") : obj.css; // For old IE

  /* istanbul ignore if  */

  if (style.styleSheet) {
    style.styleSheet.cssText = replaceText(index, css);
  } else {
    var cssNode = document.createTextNode(css);
    var childNodes = style.childNodes;

    if (childNodes[index]) {
      style.removeChild(childNodes[index]);
    }

    if (childNodes.length) {
      style.insertBefore(cssNode, childNodes[index]);
    } else {
      style.appendChild(cssNode);
    }
  }
}

function applyToTag(style, options, obj) {
  var css = obj.css;
  var media = obj.media;
  var sourceMap = obj.sourceMap;

  if (media) {
    style.setAttribute('media', media);
  } else {
    style.removeAttribute('media');
  }

  if (sourceMap && btoa) {
    css += "\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))), " */");
  } // For old IE

  /* istanbul ignore if  */


  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    while (style.firstChild) {
      style.removeChild(style.firstChild);
    }

    style.appendChild(document.createTextNode(css));
  }
}

var singleton = null;
var singletonCounter = 0;

function addStyle(obj, options) {
  var style;
  var update;
  var remove;

  if (options.singleton) {
    var styleIndex = singletonCounter++;
    style = singleton || (singleton = insertStyleElement(options));
    update = applyToSingletonTag.bind(null, style, styleIndex, false);
    remove = applyToSingletonTag.bind(null, style, styleIndex, true);
  } else {
    style = insertStyleElement(options);
    update = applyToTag.bind(null, style, options);

    remove = function remove() {
      removeStyleElement(style);
    };
  }

  update(obj);
  return function updateStyle(newObj) {
    if (newObj) {
      if (newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap) {
        return;
      }

      update(obj = newObj);
    } else {
      remove();
    }
  };
}

module.exports = function (list, options) {
  options = options || {}; // Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
  // tags it will allow on a page

  if (!options.singleton && typeof options.singleton !== 'boolean') {
    options.singleton = isOldIE();
  }

  list = list || [];
  var lastIdentifiers = modulesToDom(list, options);
  return function update(newList) {
    newList = newList || [];

    if (Object.prototype.toString.call(newList) !== '[object Array]') {
      return;
    }

    for (var i = 0; i < lastIdentifiers.length; i++) {
      var identifier = lastIdentifiers[i];
      var index = getIndexByIdentifier(identifier);
      stylesInDom[index].references--;
    }

    var newLastIdentifiers = modulesToDom(newList, options);

    for (var _i = 0; _i < lastIdentifiers.length; _i++) {
      var _identifier = lastIdentifiers[_i];

      var _index = getIndexByIdentifier(_identifier);

      if (stylesInDom[_index].references === 0) {
        stylesInDom[_index].updater();

        stylesInDom.splice(_index, 1);
      }
    }

    lastIdentifiers = newLastIdentifiers;
  };
};

/***/ }),

/***/ "antd":
/*!***********************!*\
  !*** external "antd" ***!
  \***********************/
/*! unknown exports (runtime-defined) */
/*! export Button [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Col [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Empty [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Form [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Input [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Modal [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Pagination [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Result [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Row [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Select [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Spin [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Switch [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Tabs [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Tooltip [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export TreeSelect [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export Typography [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! export message [maybe provided (runtime-defined)] [used] [provision prevents renaming] */
/*! other exports [maybe provided (runtime-defined)] [unused] */
/*! runtime requirements: module */
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE_antd__;

/***/ }),

/***/ "react":
/*!************************!*\
  !*** external "react" ***!
  \************************/
/*! unknown exports (runtime-defined) */
/*! export Children [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export createContext [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export createElement [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export forwardRef [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export isValidElement [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export useContext [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export useEffect [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export useLayoutEffect [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export useMemo [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export useRef [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! export useState [maybe provided (runtime-defined)] [used] [usage and provision prevents renaming] */
/*! other exports [maybe provided (runtime-defined)] [maybe used (runtime-defined)] */
/*! runtime requirements: module */
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE_react__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		if(__webpack_module_cache__[moduleId]) {
/******/ 			return __webpack_module_cache__[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => module['default'] :
/******/ 				() => module;
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => Object.prototype.hasOwnProperty.call(obj, prop)
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	// module exports must be returned from runtime so entry inlining is disabled
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__("./ui/index.tsx");
/******/ })()
.default;
});
//# sourceMappingURL=index.umd.js.map